unit	Bitmap;

interface

uses Objects,WinTypes;

type	PBitmapObject=^TBitmapObject;
			TBitmapObject=object(TObject)
				TheBitmap:HBitmap;
				Width,Height:integer;
				constructor Create(NewWidth,NewHeight:integer);
				constructor Copy(SourceBitmap:HBitmap);
				destructor Done; virtual;
				end;

type  PFileableBitmap=^TFileableBitmap;
			TFileableBitmap=object(TBitmapObject)
				constructor Load(Filename:PChar);
				constructor Create(NewWidth,NewHeight:integer);
				constructor Copy(SourceBitmap:HBitmap);
				procedure Save(Filename:PChar); virtual;
				end;

implementation

uses WinProcs;

constructor TBitmapObject.Create(NewWidth,NewHeight:integer);
var ScreenDC,MemDC:HDC;
		OldBitmap:HBitmap;
begin
ScreenDC:=GetDC(0);
MemDC:=CreateCompatibleDC(ScreenDC);
TheBitmap:=CreateCompatibleBitmap(ScreenDC,NewWidth,NewHeight);
ReleaseDC(0,ScreenDC);
OldBitmap:=SelectObject(MemDC,TheBitmap);
PatBlt(MemDC,0,0,NewWidth,NewHeight,whiteness);
SelectObject(MemDC,OldBitmap);
DeleteDC(MemDC);
Width:=NewWidth;
Height:=NewHeight;
end;

constructor TBitmapObject.Copy(SourceBitmap:HBitmap);
var Info:TBitmap;
begin
TObject.Init;
GetObject(SourceBitmap,SizeOf(TBitmap),@Info);
TheBitmap:=SourceBitmap;
Width:=Info.bmWidth;
Height:=Info.bmHeight;
end;

destructor TBitmapObject.Done;
begin
DeleteObject(TheBitmap);
TObject.Done;
end;

constructor TFileableBitmap.Create;
begin
TBitmapObject.Create(NewWidth,NewHeight);
end;

constructor TFileableBitmap.Copy;
begin
TBitmapObject.Copy(SourceBitmap);
end;

constructor TFileableBitmap.Load;
begin RunError(30) end;

procedure TFileableBitmap.Save;
begin RunError(30) end;


end.