unit Contain;

interface

uses Objects;

{-------------------------------------------}
{-------TContainer--------------------------
					Init
					Done
					InitIterator
					Add
					Detach
					IsEmpty
					HasMember}
{-------TContainerIterator------------------
					Init
					Done
					This
					Finished
					Inc
					Reset}
{------------------------------------------}


type  PContainerIterator=^TContainerIterator;
			TContainerIterator=object(TObject)
				constructor Init;
				destructor Done; virtual;
				function This:Pointer; virtual;
				function Finished:boolean; virtual;
				function Inc:Boolean; virtual;
				procedure Reset; virtual;
				end;

type	PContainer=^TContainer;
			TContainer=object(TObject)
				Size:integer;
				constructor Init;
				destructor Done; virtual;
				function InitIterator:PContainerIterator; virtual;
				procedure Add(ToAdd:PObject); virtual;
				function Detach:Pointer; virtual;
				procedure Delete; virtual;
				function IsEmpty:Boolean; virtual;
				function HasMember(ToFind:PObject):Boolean; virtual;
				function FindMember(ToFind:PObject):PContainerIterator; virtual;
				procedure Write(var WriteTo:Text);
				procedure ForEach(Action:Pointer); virtual;
				function FirstThat(Test:Pointer):Pointer; virtual;
				function LastThat(Test:Pointer):Pointer; virtual;
				end;

{---------------------------------------------------}

implementation

constructor TContainer.Init;						begin TObject.Init; Size:=0 end;
destructor TContainer.Done;						begin TObject.Done end;
constructor TContainerIterator.Init;		begin TObject.Init end;
destructor TContainerIterator.Done;		begin TObject.Done end;

procedure TContainer.Add;							begin RunError(20) end;
function TContainer.Detach;						begin RunError(20) end;
procedure TContainer.Delete;						begin RunError(20) end;
procedure TContainer.Write;						begin RunError(20) end;
function TContainer.InitIterator;			begin RunError(20) end;
function TContainerIterator.Inc;				begin RunError(20) end;
function TContainerIterator.This;			begin RunError(20) end;
procedure TContainerIterator.Reset;		begin RunError(20) end;
function TContainerIterator.Finished;	begin RunError(20) end;


{---------------------------------------------------------}
{----TContainer.HasMember---------------------------------}

function TContainer.HasMember(ToFind:PObject):boolean;
var Iterator:PContainerIterator;
begin
Iterator:=FindMember(ToFind);
if Iterator=nil then
	HasMember:=false
else
	begin
	HasMember:=true;
	dispose(Iterator, Done);
	end;
end;

{----TContainer.FindMember--------------------------------}

function TContainer.FindMember(ToFind:PObject):PContainerIterator;
var Iterator:PContainerIterator;
begin
Iterator:=InitIterator;
while ((not Iterator^.Finished) and (Iterator^.This<>ToFind)) do
	Iterator^.Inc;
if Iterator^.This<>ToFind then
	begin
	FindMember:=nil;
	dispose(Iterator, Done);
	end
else
	FindMember:=Iterator;
end;

{----TContainer.ForEach-----------------------------------}

procedure TContainer.ForEach(Action:Pointer);
type TIterationProcedure=procedure(Item:Pointer);
var Iterator:PContainerIterator;
		T:Pointer;
		C:array[0..10] of char;
begin
C[0]:='P'; C[1]:='Q'; C[2]:='R'; C[3]:='S';
TIterationProcedure(Action)(nil);
{Iterator:=InitIterator;
C[0]:='A'; C[1]:='B'; C[2]:='C'; C[3]:='D';
while (not Iterator^.Finished) do
	begin
	T:=Iterator^.This;
	TIterationProcedure(Action)(T);
	Iterator^.Inc;
	end;
dispose(Iterator,Done);
}end;

{----TContainer.FirstThat---------------------------------}

function TContainer.FirstThat(Test:Pointer):Pointer;
type TTestItemFunction=function(Item:Pointer):boolean;
var Iterator:PContainerIterator;
begin
Iterator:=InitIterator;
while ((not Iterator^.Finished) and (not TTestItemFunction(Test)(Iterator^.This))) do
	Iterator^.Inc;
if Iterator^.Finished then
	FirstThat:=nil
else
	FirstThat:=Iterator^.This;
dispose(Iterator,Done);
end;

{----TContainer.LastThat----------------------------------}

function TContainer.LastThat(Test:Pointer):Pointer;
type TTestItemFunction=function(Item:Pointer):boolean;
var Iterator:PContainerIterator;
		Match:PObject;
begin
Iterator:=InitIterator;
Match:=nil;
while (not Iterator^.Finished) do
	begin
	if TTestItemFunction(Test)(Iterator^.This) then Match:=Iterator^.This;
	Iterator^.Inc;
	end;
LastThat:=Match;
dispose(Iterator,Done);
end;

{----TContainer.IsEmpty-----------------------------------}

function TContainer.IsEmpty:boolean;
begin
IsEmpty:=(Size=0);
end;


end.
