//----------------------------------------------------------------------------
// Balloon.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: Balloon.pas
//----------------------------------------------------------------------------
#ifndef BalloonHPP
#define BalloonHPP
//----------------------------------------------------------------------------
#include <DTUtil.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysUtils.hpp>
#include <System.hpp>
namespace Balloon
{
//-- type declarations -------------------------------------------------------
enum TBalloonShape { bsRoundRect, bsRectangle };

enum TBalloonShadowStyle { ssShaded, ssSolid };

enum TBalloonPosition { bpAboveLeft, bpAboveRight, bpBelowLeft, bpBelowRight };

enum TBalloonBehavior { bbNoShowMouseDown, bbUseRegions, bbHideOnPaint };

typedef Set<TBalloonBehavior, bbNoShowMouseDown, bbHideOnPaint>  TBalloonBehaviors;

typedef Shortint TShadowDepth;

struct TBalloonProps
{
	Graphics::TColor BorderColor;
	Graphics::TColor Color;
	Graphics::TFont* Font;
	int MaxWidth;
	int MaxWidthPixels;
	TBalloonBehaviors Behavior;
	TBalloonPosition Position;
	TShadowDepth ShadowDepth;
	TBalloonShadowStyle ShadowStyle;
	TBalloonShape Shape;
	THintStyle Style;
} ;

typedef TBalloonProps *PBalloonProps;

class __declspec(delphiclass) TBalloonWindow;
class __declspec(pascalimplementation) TBalloonWindow : public Controls::THintWindow
{
	typedef Controls::THintWindow inherited;
	
private:
	TBalloonProps *FProps;
	TBalloonPosition FBalloonPosition;
	Graphics::TColor FBackColor;
	Graphics::TColor FBorderColor;
	void __fastcall AdjustPositionToPoint(Windows::TRect &Balloon_, const tagPOINT &Balloon_);
	void __fastcall CalcBounds(void);
	void __fastcall CalcDrawMetrics(Windows::TRect &Balloon_, Windows::TRect &Balloon_, tagPOINT * p2, 
		const int p2_Size);
	HIDESBASE MESSAGE void __fastcall CMTextChanged(Messages::TMessage &Balloon_);
	void __fastcall DrawBalloon(Graphics::TCanvas* p0, const Windows::TRect &Balloon_, const tagPOINT * 
		p2, const int p2_Size, int p4, Graphics::TColor p5, Graphics::TColor p6);
	HRGN __fastcall CreateBalloonRegion(const Windows::TRect &Balloon_, const tagPOINT * p1, const int 
		p1_Size, int p3);
	void __fastcall InitBitmap(Graphics::TBitmap* &p0);
	HIDESBASE MESSAGE void __fastcall WMEraseBkgnd(Messages::TWMEraseBkgnd &Balloon_);
	MESSAGE void __fastcall WMShowWindow(Messages::TWMShowWindow &Balloon_);
	
protected:
	virtual void __fastcall CreateParams(Controls::TCreateParams &Balloon_);
	virtual void __fastcall Paint(void);
public:
	/* THintWindow.Create */ __fastcall virtual TBalloonWindow(Classes::TComponent* AOwner) : Controls::
		THintWindow(AOwner) { }
	
public:
	/* TCustomControl.Destroy */ __fastcall virtual ~TBalloonWindow(void) { }
	
public:
	/* TWinControl.CreateParented */ __fastcall TBalloonWindow(HWND ParentWindow) : Controls::THintWindow(
		ParentWindow) { }
	
};

class __declspec(delphiclass) TBalloonHintWindow;
class __declspec(pascalimplementation) TBalloonHintWindow : public TBalloonWindow
{
	typedef TBalloonWindow inherited;
	
public:
	__fastcall virtual TBalloonHintWindow(Classes::TComponent* p0);
	virtual void __fastcall ActivateHint(const Windows::TRect &Balloon_, const System::AnsiString p1);
public:
		
	/* TCustomControl.Destroy */ __fastcall virtual ~TBalloonHintWindow(void) { }
	
public:
	/* TWinControl.CreateParented */ __fastcall TBalloonHintWindow(HWND ParentWindow) : Balloon::TBalloonWindow(
		ParentWindow) { }
	
};

class __declspec(delphiclass) TBalloonBase;
class __declspec(pascalimplementation) TBalloonBase : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	Graphics::TColor __fastcall GetBorderColor(void);
	Graphics::TColor __fastcall GetColor(void);
	Graphics::TFont* __fastcall GetFont(void);
	int __fastcall GetMaxWidth(void);
	TBalloonBehaviors __fastcall GetBehavior(void);
	TBalloonPosition __fastcall GetPosition(void);
	TShadowDepth __fastcall GetShadowDepth(void);
	TBalloonShadowStyle __fastcall GetShadowStyle(void);
	TBalloonShape __fastcall GetShape(void);
	Dtutil::THintStyle __fastcall GetStyle(void);
	void __fastcall SetBorderColor(Graphics::TColor p0);
	void __fastcall SetColor(Graphics::TColor p0);
	void __fastcall SetFont(Graphics::TFont* p0);
	void __fastcall SetMaxWidth(int p0);
	void __fastcall SetBehavior(TBalloonBehaviors p0);
	void __fastcall SetPosition(TBalloonPosition p0);
	void __fastcall SetShadowDepth(TShadowDepth p0);
	void __fastcall SetShadowStyle(TBalloonShadowStyle p0);
	void __fastcall SetShape(TBalloonShape p0);
	void __fastcall SetStyle(Dtutil::THintStyle p0);
	
protected:
	TBalloonProps FProps;
	void __fastcall SetMaxWidthPixels(void);
	
public:
	__fastcall virtual TBalloonBase(Classes::TComponent* p0);
	__fastcall virtual ~TBalloonBase(void);
	int __fastcall GetMaxWidthPixels(void);
	
__published:
	__property Graphics::TColor BorderColor = {read=GetBorderColor, write=SetBorderColor, nodefault};
	__property Graphics::TColor Color = {read=GetColor, write=SetColor, nodefault};
	__property Graphics::TFont* Font = {read=GetFont, write=SetFont, nodefault};
	__property int MaxWidth = {read=GetMaxWidth, write=SetMaxWidth, nodefault};
	__property TBalloonBehaviors Behavior = {read=GetBehavior, write=SetBehavior, nodefault};
	__property TBalloonPosition Position = {read=GetPosition, write=SetPosition, nodefault};
	__property TShadowDepth ShadowDepth = {read=GetShadowDepth, write=SetShadowDepth, nodefault};
	__property TBalloonShadowStyle ShadowStyle = {read=GetShadowStyle, write=SetShadowStyle, default=0}
		;
	__property TBalloonShape Shape = {read=GetShape, write=SetShape, nodefault};
	__property Dtutil::THintStyle Style = {read=GetStyle, write=SetStyle, default=0};
};

class __declspec(delphiclass) TBalloonHint;
class __declspec(pascalimplementation) TBalloonHint : public TBalloonBase
{
	typedef TBalloonBase inherited;
	
private:
	bool FActive;
	void __fastcall SetActive(bool p0);
	
public:
	__fastcall virtual TBalloonHint(Classes::TComponent* p0);
	__fastcall virtual ~TBalloonHint(void);
	
__published:
	__property bool Active = {read=FActive, write=SetActive, nodefault};
};

//-- var, const, procedure ---------------------------------------------------
//-- template instantiations -------------------------------------------------
template class TBalloonBehaviors ;

}	/* namespace Balloon */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Balloon;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// Balloon
