
//
// DebugLog Unit
//
// Provides a simple procedural interface to the Debug Log Automation Server.
//
// Written by Mike Scott 100140.2420@compuserve.com   10th January 1996
//

unit DebugLog;

interface

uses OLEAuto ;

// procedures to output a string and Format-ted string and clear the log.
procedure DebugString( const s : string ) ;
procedure FmtDebugString( const s : string ;
                          const Args : array of const ) ;
procedure ClearLog ;

// LogWindow gives direct access to the automation server if you need it -
// can't think of any reason why you'd want to, but... <grin>
function  LogWindow : variant ;

implementation

var
  FLogWindow : variant ;

function  LogWindow : variant ;
begin
  if VarIsEmpty( FLogWindow ) then
  try
    FLogWindow := CreateOleObject('DebugLog.LogWindow');
  except
    Raise EOLEError.Create(
      'The DebugLog Automation Server could not be started. ' +
      'Run the DebugLog application once to registered the server.' ) ;
  end;
  Result := FLogWindow ;
end ;

procedure DebugString( const s : string ) ;
begin
  LogWindow.Log( s ) ;
end ;

procedure FmtDebugString( const s : string ;
                          const Args : array of const ) ;
begin
  LogWindow.Log( Format( s, Args ) ) ;
end ;

procedure ClearLog ;
begin
  LogWindow.Clear ;
end ;

end.
