unit Deque;


interface

uses Objects, DlstElem, Queue;


{------------- TDeque ---------------------------
								Init
								AddAtTail
								Detach
								DetachFromHead}
{------------------------------------------------}

type  PDeque=^TDeque;
			TDeque=object(TQueue)
				constructor Init;
				procedure AddAtTail(ToAdd:PObject); virtual;
				function Detach:Pointer; virtual;
				function DetachFromHead:Pointer; virtual;
				end;


{------------------------------------------------}

implementation

{---Init-----------------------------------------}

constructor TDeque.Init;
begin
TQueue.Init;
end;

{---AddAtTail------------------------------------}

procedure TDeque.AddAtTail(ToAdd:PObject);
var NewElement:PDoubleListElement;
begin
new(NewElement);
with NewElement^ do
	begin
	Init(ToAdd);
	Next:=Tail;
	Previous:=Tail^.Previous;
	Next^.Previous:=NewElement;
	Previous^.Next:=NewElement;
	end;
Size:=Size+1;
end;

{---Detach---------------------------------------}

function TDeque.Detach:Pointer;
begin
Detach:=DetachFromHead;
end;

{---DetachFromHead-------------------------------}

function TDeque.DetachFromHead:Pointer;
var Temp:PDoubleListElement;
begin
Temp:=Head^.Next;
DetachFromHead:=Temp^.Data;
Temp^.Data:=nil;
Head^.Next:=Temp^.Next;
Temp^.Next^.Previous:=Head;
if Temp<>Tail then
	begin
	dispose(Temp, Done);
	Size:=Size-1;
	end;
end;


end.