{***************************************************************************}
{  Date: 17.01.97                                            Time: 17:30:40 }
{  Copyright (c)1996-1997                                                   }
{   by Dr.Plass                                               TFindWin2.0  }
{                                                                           }
{                                              for DELPHI 2, Win95 (Not NT! }
{  feel free to contact me:                                                 }
{  Peter.Plass@FH-Zwickau.de                                                }
{  http://www.fh-zwickau.de/~pp/tm.htm                                      }
{                                                                           }
{  All Rights Reserved.                                                     }
{  This component can be freely used and distributed in commercial and      }
{  private environments, provided this notice is not modified in any way.   }
{                                                                           }
{      based on Jerome Tremblay's component TWindowsList v1.0               }
{      --> jerome@infose.com                                                }
{  used:                                                                    }
{  ToolHelp32 v1.00  Copyright 1996 by Brad Stowers                         }
{                                                                           }
{                                                                           }
{***************************************************************************}
//
//
//  Methods:
//  procedure Execute;
//  function GetWinHandle (Idx : Integer): HWND;
//  function GetWinParent (Idx : Integer): HWND;
//  function GetThreadID  (Idx : Integer): HTask;
//  function GetProcessID (Idx : Integer): DWORD;
//  function GetWinStyle  (Idx : Integer): LongInt;
//  function GetWinExStyl (Idx : Integer): LongInt;
//  function GetWinExePath(Idx : Integer): String;
//  function GetWnClasName(Idx : Integer): String;
//  function GetParentName(Idx : Integer): String;
//
//  e.g.: whdl := WinList1.GetWinHandle(ListBox1.ItemIndex);
//
//  Properties:
//  Property WhatDoFind : TFind_ID;
//  Property WindowList : TStringList;
//  Property EmptyNames : Boolean;
//  Property TaskBarSty : Boolean;
//  Property TimerIntval: Integer;
//  Property EnableTimer: Boolean;
//  Property OnChanged  : TNotifyEvent;
//
//

unit FListWin;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Findwin, ExtCtrls, OneInstance, FileLbl;

type
  TForm1 = class(TForm)
    ListBox1    : TListBox;
    BitBtn1     : TBitBtn;
    BitBtn2     : TBitBtn;
    BitBtn3     : TBitBtn;
    BitBtn4     : TBitBtn;
    CheckBox1   : TCheckBox;
    CheckBox2   : TCheckBox;
    CheckBox3: TCheckBox;
    Edit1: TEdit;
    Label3: TLabel;
    WinList1: TWinList;
    GroupBox1: TGroupBox;
    cb1: TCheckBox;
    cb2: TCheckBox;
    cb3: TCheckBox;
    cb4: TCheckBox;
    cb5: TCheckBox;
    cb6: TCheckBox;
    cb7: TCheckBox;
    cb8: TCheckBox;
    cb9: TCheckBox;
    cb10: TCheckBox;
    cb11: TCheckBox;
    cb12: TCheckBox;
    cb13: TCheckBox;
    cb14: TCheckBox;
    cb15: TCheckBox;
    cb16: TCheckBox;
    cb17: TCheckBox;
    cb18: TCheckBox;
    cb19: TCheckBox;
    cb20: TCheckBox;
    Panel1: TPanel;
    Label1: TLabel;
    Label7: TLabel;
    Label6: TLabel;
    Label5: TLabel;
    Label2: TLabel;
    cb21: TCheckBox;
    cb22: TCheckBox;
    BitBtn5: TBitBtn;
    Label4: TFileLabel;
    procedure SetStyle(sty:LongInt);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure ListWin(Sender: TObject);
    procedure ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CheckBox3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
 WinList1.TaskBarSty := Checkbox2.checked;
 if checkbox2.checked then begin
  checkbox1.checked := False;
  checkbox1.enabled := False;
 end else
  checkbox1.enabled := True;
 WinList1.EmptyNames:= Checkbox1.checked;
 if Edit1.Text <> '' then
  WinList1.TimerIntVal:= StrToInt(Edit1.Text);

 if Sender = BitBtn1 then WinList1.WhatDoFind := id_all;
 if Sender = BitBtn2 then WinList1.WhatDoFind := id_visonly;
 if Sender = BitBtn3 then WinList1.WhatDoFind := id_invisonly;
 WinList1.Execute;
 ListWin(Sender);
end;

procedure TForm1.ListWin(Sender: TObject);
begin
 ListBox1.Clear;
 ListBox1.Items.Assign(WinList1.WindowList);
 SetStyle(0);
 Label1.Caption := IntToStr(ListBox1.Items.count) + ' window(s) found  ';
 Label6.Caption := '';
 Label7.Caption := 'klick an item to obtain some information';
 Label5.caption := '';
 Label2.caption := '';
 Label4.Filename:= '';
 Edit1.Text     := IntToStr(WinList1.TimerIntval);

end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin
 close;
end;

procedure TForm1.ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
 hdlp,
 whdl  : HWnd;
 thdl  : HTask;
 phdl  : DWORD;
 wsty,
 wXty  : LongInt;
begin
 if ListBox1.Items.count < 1 then exit;
 if ListBox1.ItemIndex < 0   then exit;
 whdl := WinList1.GetWinHandle(ListBox1.ItemIndex);
 hdlp := WinList1.GetWinParent(ListBox1.ItemIndex);
 thdl := WinList1.GetThreadID(ListBox1.ItemIndex);
 phdl := WinList1.GetProcessID(ListBox1.ItemIndex);
 wsty := WinList1.GetWinStyle(ListBox1.ItemIndex);
 wxty := WinList1.GetWinExStyl(ListBox1.ItemIndex);

 Label1.Caption := 'HWnd:      ' + IntToHex(whdl,4);
 Label7.Caption := 'ThreadID:  ' + IntToHEX(thdl,4)+
                   ' / ProcessID: ' + IntToHEX(phdl,4);
 Label6.Caption := 'HParent:   ' + IntToHex(hdlp,4) +
                   ' -> '+WinList1.GetParentName(ListBox1.ItemIndex);
 Label5.Caption := 'ClassName: ' + WinList1.GetWnClasName(ListBox1.ItemIndex);
 Label2.Caption := 'WinStyle:  ' + IntToHex(wsty,4)+
                   ' / WinExSty: ' + IntToHEX(wxty,4);
 Label4.Filename:= WinList1.GetWinExePath(ListBox1.ItemIndex);

 SetStyle(wsty);
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
 WinList1.EnableTimer := CheckBox3.checked;
 Edit1.Enabled := CheckBox3.checked;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Caption    := WinList1.About;
 Edit1.Text := IntToStr(WinList1.TimerIntval);
end;

procedure TForm1.SetStyle(sty:LongInt);
begin
 if sty = 0 then  cb1.checked := False
 else
 cb1.checked := (sty AND WS_OVERLAPPED) = WS_OVERLAPPED;
 cb2.checked := (sty AND WS_POPUP) = WS_POPUP;
 cb3.checked := (sty AND WS_CHILD) = WS_CHILD;
 cb4.checked := (sty AND WS_MINIMIZE) = WS_MINIMIZE;
 cb5.checked := (sty AND WS_VISIBLE) = WS_VISIBLE;
 cb6.checked := (sty AND WS_DISABLED) = WS_DISABLED;
 cb7.checked := (sty AND WS_CLIPSIBLINGS) = WS_CLIPSIBLINGS;
 cb8.checked := (sty AND WS_CLIPCHILDREN) = WS_CLIPCHILDREN;
 cb9.checked := (sty AND WS_MAXIMIZE) = WS_MAXIMIZE;
 cb10.checked := (sty AND WS_CAPTION) = WS_CAPTION;
 cb11.checked := (sty AND WS_BORDER) = WS_BORDER;
 cb12.checked := (sty AND WS_DLGFRAME) = WS_DLGFRAME;
 cb13.checked := (sty AND WS_VSCROLL) = WS_VSCROLL;
 cb14.checked := (sty AND WS_HSCROLL) = WS_HSCROLL;
 cb15.checked := (sty AND WS_SYSMENU) = WS_SYSMENU;
 cb16.checked := (sty AND WS_THICKFRAME) = WS_THICKFRAME;
 cb17.checked := (sty AND WS_GROUP) = WS_GROUP;
 cb18.checked := (sty AND WS_TABSTOP) = WS_TABSTOP;
 cb19.checked := (sty AND WS_MINIMIZEBOX) = WS_MINIMIZEBOX;
 cb20.checked := (sty AND WS_MAXIMIZEBOX) = WS_MAXIMIZEBOX;
 cb21.checked := (sty AND WS_TILEDWINDOW) = WS_TILEDWINDOW;
 cb22.checked := (sty AND WS_POPUPWINDOW) = WS_POPUPWINDOW;
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
begin
 MessageDlg('Demosoftware'+ #10#13+
            'zur Komponente: TFindWin2.0          '+ #10#13+ #10#13+
            ' 1997 by Dr.Plass                   '+ #10#13+
            'Peter.Plass@fh-zwickau.de            '+ #10#13+
            'http://www.fh-zwickau.de/~pp/tm.htm  ',
            mtInformation, [mbOk],0);
end;

end.
