(*

  File Name Property Editor
  (C) 1995-96, Glen Why

*)
unit FileNameProp;

interface
uses
 Classes, DsgnIntf;

type


 TFileNameProperty = class( TPropertyEditor )
 protected
   function GetAttributes :TPropertyAttributes; override;
   procedure Edit; override;
   function GetValue :string; override;
   procedure SetValue( const V :String ); override;
 end;


implementation
uses
  Forms, Dialogs;

{ TFileNameProperty }

function TFileNameProperty.GetAttributes :TPropertyAttributes;
begin
 result := [ paDialog ];
end;

procedure TFileNameProperty.Edit;
begin
  with TOpenDialog.Create( Application.MainForm ) do
   try
     Filter := 'All Files|*.*';
     Options := [ ofFileMustExist, ofPathMustExist, ofNoDereferenceLinks ];
     Title := 'Select file';
     if Execute then
      begin
        SetStrValue( FileName );
        Modified;
      end;
   finally
     free;
   end;
end;

function TFileNameProperty.GetValue :string;
begin
 result := GetStrValue;
end;

procedure TFileNameProperty.SetValue( const V :String );
begin
 SetStrValue( V );
end;



end.
