unit Gstarex;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Gcontrol, ExtCtrls, StdCtrls,
  Gev,Gboard,Gobject,Gglobal,Ggraph, Gprop;

type
  TForm1 = class(TForm)
    GSPanel1: TGSPanel;
    GSDrawer_None1: TGSDrawer_None;
    GSDrawer_AddEV1: TGSDrawer_AddEV;
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    GSPanel2: TGSPanel;
    Button7: TButton;
    Button9: TButton;
    Button3: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    GSDrawer_None2: TGSDrawer_None;
    GSDrawer_Touch1: TGSDrawer_Touch;
    GSDrawer_AddFCEV1: TGSDrawer_AddFCEV;
    Button8: TButton;
    Button10: TButton;
    GSPropertyEditor1: TGSPropertyEditor;
    Bevel1: TBevel;
    Button11: TButton;
    Button12: TButton;
    Panel1: TPanel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure GSPanel1AfterCreate(Sender: TObject; p_Object: TGSObject);
    function GSPanel1CreateEdge(Sender: TObject; p_Parent: TGSObject; p_x1,
      p_y1, p_x2, p_y2: Longint; p_v1, p_v2: TGSVertex): TGSEdge;
    function GSPanel1CreateVertex(Sender: TObject; p_Parent: TGSObject;
      p_x1, p_y1: Longint; p_e: TGSEdge): TGSVertex;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    function GSPanel2CreateEdge(Sender: TObject; p_Parent: TGSObject; p_x1,
      p_y1, p_x2, p_y2: Longint; p_v1, p_v2: TGSVertex): TGSEdge;
    function GSPanel2CreateVertex(Sender: TObject; p_Parent: TGSObject;
      p_x1, p_y1: Longint; p_e: TGSEdge): TGSVertex;
    procedure GSPanel1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GSPanel2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button10Click(Sender: TObject);
    procedure GSPropertyEditor1AfterChange(Sender: TObject;
      PropertyID: String);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure GSPanel2MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    function GSDrawer_AddEV1CreateEdge(Sender: TObject;
      p_Parent: TGSObject; p_x1, p_y1, p_x2, p_y2: Longint; p_v1,
      p_v2: TGSVertex): TGSEdge;
    function GSDrawer_AddEV1CreateVertex(Sender: TObject;
      p_Parent: TGSObject; p_x1, p_y1: Longint; p_e: TGSEdge): TGSVertex;
    function GSDrawer_Touch1CreateTouchObject(Sender: TObject;
      p_Parent: TGSObject; p_x1, p_y1: Longint): TGSObject;
  private
    { Private declarations }
    procedure EdgeClick(Sender: TObject);
    procedure EdgeMove(Sender: TObject);
    procedure VertexClick(Sender: TObject);
    procedure VertexMove(Sender: TObject);
  public
    { Public declarations }
  end;

  TGSRedEdge = class(TGSEdge)
    class procedure RegisterClasses;override;
    procedure Draw(p_DrawBoard: TGSDrawBoard); override ;
  end ;

  TGSRedVertex = class(TGSVertex)
    class procedure RegisterClasses;override;
    procedure Draw(p_DrawBoard: TGSDrawBoard); override ;
  end ;

  TGSBlueEdge = class(TGSEdge)
    class procedure RegisterClasses;override;
    procedure Draw(p_DrawBoard: TGSDrawBoard); override ;
  end ;

  TGSBlueVertex = class(TGSVertex)
    class procedure RegisterClasses;override;
    procedure Draw(p_DrawBoard: TGSDrawBoard); override ;
  end ;


{stream object for TGSMyTouch}
  TGSMyStreamObj = class(TGSStreamObject)
  private
     FColor:TColor;
  published
     property Color:TColor read  FColor write FColor;
  end ;

{this class showes
      1. derive TGSObject with 'Color' property.
      1. how to save/load new properties.
      2. how to work with property editor}

  TGSMyTouch = class(TGSObject)
  private
     FColor: TColor;

  public
     { *** draw }
     procedure Draw(p_DrawBoard: TGSDrawBoard); override;

     { *** save/load}
     procedure Assign(Source: TPersistent); override;
     procedure AssignTo(Dest: TPersistent); override;
     class function GetStreamObjectClassName: string; override;
     class procedure RegisterClasses; override ;

     { *** Property Editor}
     function GetProperty( p_Count:int;
                           p_PID:string):string; override;

     function GetPropertyTitle( p_Count:int;
                                p_PID:string):string; override;

     function GetPropertyIDList( p_Count:int): TStringList; override;

     procedure SetProperty( p_Count:int;
                            p_PID:string;
                            const p_ComboBox,p_AuxComboBox:TComboBox); override;

     procedure LoadProperty( p_Count:int;
                             p_PID:string;
                             const p_ComboBox,p_AuxComboBox:TComboBox;
                             var p_DefaultDialog:bool;
                             var p_EditType:gsPropertyEditType); override;

     {}
     property Color:TColor read  FColor write FColor;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

var
   gsGraph: TGSGraph ;

procedure STATUS(s1:string);
begin
   Form1.Panel1.Caption := s1 ;
   Form1.Panel1.Update ;
end ;


procedure TGSRedEdge.Draw(p_DrawBoard: TGSDrawBoard);
begin
   p_DrawBoard.Canvas.Pen.Color := clRed ;
   inherited Draw(p_DrawBoard) ;
end ;

procedure TGSRedVertex.Draw(p_DrawBoard: TGSDrawBoard);
begin
   p_DrawBoard.Canvas.Pen.Color := clRed ;
   inherited Draw(p_DrawBoard) ;
end ;

procedure TGSBlueEdge.Draw(p_DrawBoard: TGSDrawBoard);
begin
   p_DrawBoard.Canvas.Pen.Color := clBlue ;
   inherited Draw(p_DrawBoard) ;
end ;

procedure TGSBlueVertex.Draw(p_DrawBoard: TGSDrawBoard);
begin
   p_DrawBoard.Canvas.Pen.Color := clBlue ;
   inherited Draw(p_DrawBoard) ;
end ;

{*****************************************************}
{register procedure, used in save/load}
class procedure TGSRedEdge.RegisterClasses;
begin
   inherited RegisterClasses;
   Classes.RegisterClasses([TGSRedEdge]) ;
end ;

class procedure TGSBlueEdge.RegisterClasses;
begin
   inherited RegisterClasses;
   Classes.RegisterClasses([TGSBlueEdge]) ;
end ;

class procedure TGSRedVertex.RegisterClasses;
begin
   inherited RegisterClasses;
   Classes.RegisterClasses([TGSRedVertex]) ;
end ;

class procedure TGSBlueVertex.RegisterClasses;
begin
   inherited RegisterClasses;
   Classes.RegisterClasses([TGSBlueVertex]) ;
end ;

{*** TGSMyTouch ******************************************}
{draw }
procedure TGSMyTouch.Draw(p_DrawBoard: TGSDrawBoard);
begin
   with p_DrawBoard.Canvas do begin
      Pen.Color := self.Color ;
      Pen.Mode := pmCopy ;
      Brush.Color := Color ;
      Brush.Style := bsSolid ;
   end ;

   inherited Draw(p_DrawBoard) ;
end ;

{save/load}
procedure TGSMyTouch.Assign(Source: TPersistent);
begin
   inherited Assign(Source) ;

   if (Source<>nil) and (Source is TGSMyStreamObj) then
      Color := TGSMyStreamObj(Source).Color ;
end ;

procedure TGSMyTouch.AssignTo(Dest: TPersistent);
begin
   inherited AssignTo(Dest) ;

   if (Dest<>nil) and (Dest is TGSMyStreamObj) then
      TGSMyStreamObj(Dest).Color := Color ;
end ;

class function TGSMyTouch.GetStreamObjectClassName: string;
begin
   result := 'TGSMyStreamObj' ;
end ;

class procedure TGSMyTouch.RegisterClasses;
begin
   Classes.RegisterClasses([TGSMyTouch,TGSMyStreamObj]) ;
end ;

{Property Editor}
function TGSMyTouch.GetProperty( p_Count:int;
                      p_PID:string):string;
begin
   if p_PID = 'Color' then begin
      result := IntToStr(Color) ;
      exit ;
   end ;

   result := inherited GetProperty(p_Count,p_PID) ;
end ;

function TGSMyTouch.GetPropertyTitle( p_Count:int;
                           p_PID:string):string;
begin
   {default title name is equal to handle name}
   result := inherited GetPropertyTitle(p_Count,p_PID) ;
end ;


function TGSMyTouch.GetPropertyIDList( p_Count:int): TStringList;
begin
   {if you override this methos then you MUST assign a returned value}
(*   result := nil ;*)

   if (FPropertyIDList<>nil) and
      (FPropertyIDList.Count <= 0) then begin { load at most once,
                                                take care of load parent's IDList
                                                at most once }

      inherited GetPropertyIDList(p_Count) ;

      FPropertyIDList.Add('Color') ;
   end ;

   result := PropertyIDList ;
end ;


procedure TGSMyTouch.SetProperty( p_Count:int;
                       p_PID:string;
                       const p_ComboBox,p_AuxComboBox:TComboBox);
begin
   if p_PID = 'Color' then begin
      Color := StrToInt(p_ComboBox.Text) ;
      exit ;
   end ;

   inherited GetProperty(p_Count,p_PID) ;

   {doing some updating here ...}
end ;


procedure TGSMyTouch.LoadProperty( p_Count:int;
                        p_PID:string;
                        const p_ComboBox,p_AuxComboBox:TComboBox;
                        var p_DefaultDialog:bool;
                        var p_EditType:gsPropertyEditType);
begin
   {generally, loading once for the same kind of object is OK}
   if p_Count <> 0 then
      exit ;

   inherited LoadProperty( p_Count,p_PID,p_ComboBox,p_AuxComboBox,
                           p_DefaultDialog,p_EditType);
end ;


{*****************************************************}
procedure TForm1.EdgeMove(Sender: TObject);
var
   e1: TGSEdge ;
begin
   if not (Sender is TGSEdge) then
      exit ;

   e1 := Sender as TGSEdge ;
   STATUS(e1.ObjectName + ' Moved') ;
end ;

procedure TForm1.EdgeClick(Sender: TObject);
var
   e1: TGSEdge ;
begin
   if not (Sender is TGSEdge) then
      exit ;

   e1 := Sender as TGSEdge ;
   STATUS(e1.ObjectName + ' Clicked') ;
end ;


procedure TForm1.VertexMove(Sender: TObject);
var
   v1: TGSVertex ;
begin
   if not (Sender is TGSVertex) then
      exit ;

   v1 := Sender as TGSVertex ;
   STATUS(v1.ObjectName + ' Moved') ;
end ;

procedure TForm1.VertexClick(Sender: TObject);
var
   v1: TGSVertex ;
begin
   if not (Sender is TGSVertex) then
      exit ;

   v1 := Sender as TGSVertex ;
   STATUS(v1.ObjectName + ' Clicked') ;

end ;


procedure TForm1.Button1Click(Sender: TObject);
begin
   GSPanel1.Drawer := GSDrawer_None1 ;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   GSPanel1.Drawer := GSDrawer_AddEV1 ;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
   GSPanel2.Drawer := GSDrawer_None2 ;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
   GSPanel1.Scale := StrToFloat(Edit1.Text) ;
   GSPanel1.Invalidate ;

end;

procedure TForm1.Button5Click(Sender: TObject);
begin
   GSPanel1.xOffset := StrToInt(Edit1.Text) ;
   GSPanel1.Invalidate ;

end;

procedure TForm1.Button6Click(Sender: TObject);
begin
   GSPanel1.yOffset := StrToInt(Edit1.Text) ;
   GSPanel1.Invalidate ;
end;

procedure TForm1.GSPanel1AfterCreate(Sender: TObject; p_Object: TGSObject);
begin
   if (p_Object is TGSEdge) then begin
      p_Object.OnClick := EdgeClick ;
      p_Object.OnAfterMove := EdgeMove ;
      exit ;
   end ;

   if (p_Object is TGSVertex) then begin
      p_Object.OnClick := VertexClick ;
      p_Object.OnAfterMove := VertexMove ;
   end ;

end;

function TForm1.GSPanel1CreateEdge(Sender: TObject; p_Parent: TGSObject;
  p_x1, p_y1, p_x2, p_y2: Longint; p_v1, p_v2: TGSVertex): TGSEdge;
begin
     result := TGSRedEdge.Create ;
     result.Init( p_Parent,
                  p_x1, p_y1, p_x2, p_y2,
                  p_v1, p_v2) ;
end;

function TForm1.GSPanel1CreateVertex(Sender: TObject; p_Parent: TGSObject;
  p_x1, p_y1: Longint; p_e: TGSEdge): TGSVertex;
begin
     result := TGSRedVertex.Create ;
     result.Init( p_Parent,
                  p_x1, p_y1) ;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   gsGraph := nil ;

   {For Loading}
   Classes.RegisterClasses([TGSRedEdge,TGSBlueEdge,TGSRedVertex,TGSBlueVertex]) ;
   Classes.RegisterClasses([TGSMyTouch,TGSMyStreamObj]) ;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     if gsGraph <> nil then
        gsGRaph.Free ;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
     GSPanel2.FreeGraph ;
     GSPanel2.BoundGraph := GSPanel1.BoundGraph ;
     GSPanel2.Invalidate ;
     GSPanel1.Invalidate ;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
   GSPanel1.Drawer := GSDrawer_AddFCEV1 ;

end;

procedure TForm1.Button9Click(Sender: TObject);
begin
   GSPanel2.Drawer := GSDrawer_AddEV1 ;
end;

function TForm1.GSPanel2CreateEdge(Sender: TObject; p_Parent: TGSObject;
  p_x1, p_y1, p_x2, p_y2: Longint; p_v1, p_v2: TGSVertex): TGSEdge;
begin
     result := TGSBlueEdge.Create ;
     result.Init( p_Parent,
                  p_x1, p_y1, p_x2, p_y2,
                  p_v1, p_v2) ;
end;

function TForm1.GSPanel2CreateVertex(Sender: TObject; p_Parent: TGSObject;
  p_x1, p_y1: Longint; p_e: TGSEdge): TGSVertex;
begin
     result := TGSBlueVertex.Create ;
     result.Init( p_Parent,
                  p_x1, p_y1) ;
end;

procedure TForm1.GSPanel1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if GSPanel2.BoundGraph = GSPanel1.BoundGraph then
      GSPanel2.Invalidate ;
end;

procedure TForm1.GSPanel2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if GSPanel2.BoundGraph = GSPanel1.BoundGraph then
      GSPanel1.Invalidate ;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
   GSPanel1.Drawer := GSDrawer_Touch1 ;
end;

procedure TForm1.GSPropertyEditor1AfterChange(Sender: TObject;
  PropertyID: String);
begin
   GSPanel1.Invalidate ;
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
   GSPanel1.SaveToFile(Edit1.Text) ;
end;

procedure TForm1.Button12Click(Sender: TObject);
begin
   GSPanel1.LoadFromFile(Edit1.Text) ;
   GSPanel1.Invalidate ;

end;

procedure TForm1.GSPanel2MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   if not (ssLeft in Shift) then
      exit ;

   {ad-hoc}
   GSPanel1.xOffset := GSPanel2.DrawBoard.X_CToA(Round(X * 2)) ;
   GSPanel1.yOffset := GSPanel2.DrawBoard.Y_CToA(Round(Y * 2)) ;
   GSPanel1.Invalidate ;

end;

function TForm1.GSDrawer_AddEV1CreateEdge(Sender: TObject;
  p_Parent: TGSObject; p_x1, p_y1, p_x2, p_y2: Longint; p_v1,
  p_v2: TGSVertex): TGSEdge;
begin

   if GSDrawer_AddEV1.BoundGSPanel = GSPanel1 then
      result := TGSRedEdge.Create
   else
      result := TGSBlueEdge.Create ;
end;

function TForm1.GSDrawer_AddEV1CreateVertex(Sender: TObject;
  p_Parent: TGSObject; p_x1, p_y1: Longint; p_e: TGSEdge): TGSVertex;
begin
   if GSDrawer_AddEV1.BoundGSPanel = GSPanel1 then
      result := TGSRedVertex.Create
   else
      result := TGSBlueVertex.Create ;
end;

function TForm1.GSDrawer_Touch1CreateTouchObject(Sender: TObject;
  p_Parent: TGSObject; p_x1, p_y1: Longint): TGSObject;
begin
   result := TGSMyTouch.Create ;
end;

end.
