(*

   GUID Property Editor
   (C) 1996, Glen Why

*)
unit GUIDProp;

interface
uses
  DsgnIntf;


type

 TGUIDProperty = class( TPropertyEditor )
 public
   function GetAttributes :TPropertyAttributes; override;
   procedure SetValue( const S :String ); override;
   function GetValue :string; override;
   function GetEditLimit: Integer; override;
 end;


implementation
uses
 SysUtils, OLE2;

{ TGUIDProperty }

const

  GUID_STRING_LEN = 39;
  GUID_BUFFER_LEN = 128;

function TGUIDProperty.GetAttributes :TPropertyAttributes;
begin
 result := [];
end;

procedure TGUIDProperty.SetValue( const S :String );
var
  Buffer: array[0..GUID_BUFFER_LEN-1] of WideChar;
  U :TGUID;
begin
  if CLSIDFromString( StringToWideChar( S, Buffer,
    SizeOf( Buffer ) shr 1 ), U ) < 0
     then raise Exception.CreateFmt( 'Invalid GUID: %s', [ S ] );
  SetStrValue( S );
end;

function TGUIDProperty.GetValue :string;
begin
  Result := GetStrValue;
end;

function TGUIDProperty.GetEditLimit: Integer;
begin
 result := GUID_STRING_LEN;
end;



end.
