{***************************************************************************}
{  Date: 17.01.97                                            Time: 17:30:40 }
{  Copyright (c)1996-1997                                                   }
{   by Dr.Plass                                               TFindWin2.0  }
{                                                                           }
{                                              for DELPHI 2, Win95 (Not NT! }
{  feel free to contact me:                                                 }
{  Peter.Plass@FH-Zwickau.de                                                }
{  http://www.fh-zwickau.de/~pp/tm.htm                                      }
{                                                                           }
{  All Rights Reserved.                                                     }
{  This component can be freely used and distributed in commercial and      }
{  private environments, provided this notice is not modified in any way.   }
{                                                                           }
{      based on Jerome Tremblay's component TWindowsList v1.0               }
{      --> jerome@infose.com                                                }
{                                                                           }
{  used:                                                                    }
{  ToolHelp32 v1.00  Copyright 1996 by Brad Stowers                         }
{                                                                           }
{                                                                           }
{***************************************************************************}
//
//
//  Methods:
//  procedure Execute;
//  function GetWinHandle (Idx : Integer): HWND;
//  function GetWinParent (Idx : Integer): HWND;
//  function GetThreadID  (Idx : Integer): HTask;
//  function GetProcessID (Idx : Integer): DWORD;
//  function GetWinStyle  (Idx : Integer): LongInt;
//  function GetWinExStyl (Idx : Integer): LongInt;
//  function GetWinExePath(Idx : Integer): String;
//  function GetWnClasName(Idx : Integer): String;
//  function GetParentName(Idx : Integer): String;
//
//  e.g.: whdl := WinList1.GetWinHandle(ListBox1.ItemIndex);
//
//  Properties:
//  Property WhatDoFind : TFind_ID;
//  Property WindowList : TStringList;
//  Property EmptyNames : Boolean;
//  Property TaskBarSty : Boolean;
//  Property TimerIntval: Integer;
//  Property EnableTimer: Boolean;
//  Property OnChanged  : TNotifyEvent;
//
//


unit FindWin;
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, toolhelp32;

const
 cAbout = 'TFindWin2.0:  1997 by Dr.Plass';
type
  TFind_ID = (id_All,id_VisOnly,id_InvisOnly);

  TWinInfo = class(TObject)
  private
  public
   hpar,
   whdl    : HWND;
   thdl    : HTask;
   Parent,
   clas,
   ExePath : String;
   phdl    : DWORD;
   wsty,
   wXty    : LongInt;
  end;

  TWinList = class(TComponent)
  private
   FFindID           : TFind_ID;
   fWindowsList      : TStringList;
   WinObj            : TWinInfo;
   fAcceptEmptyNames,
   fTimerOn,
   fTaskBarStyle     : Boolean;
   fOnChanged        : TNotifyEvent;
   timer1            : TTimer;
   fTimeVal          : Integer;
   fAbout            : String;
  protected
   Procedure GetWindowsInfo(WinHandle : HWND);
   procedure SomeChanged;
   procedure FuAbout(value :String);
   procedure SetTimer(value:Boolean);
   procedure SetTimeVal(value:Integer);
   procedure Timer1Timer(Sender:TObject);
  public
   Constructor Create(AOwner : TComponent); override;
   Destructor Destroy; override;
   Procedure Execute; virtual;
   function GetWinHandle(Idx : Integer): HWND;
   function GetWinParent(Idx : Integer): HWND;
   function GetThreadID (Idx : Integer): HTask;
   function GetProcessID(Idx : Integer): DWORD;
   function GetWinStyle (Idx : Integer): LongInt;
   function GetWinExStyl(Idx : Integer): LongInt;
   function GetWinExePath(Idx : Integer): String;
   function GetWnClasName(Idx : Integer): String;
   function GetParentName(Idx : Integer): String;
  published
   Property About      : String read FAbout write FuAbout;
   Property WhatDoFind : TFind_ID read FFindID write FFindID default id_visonly;
   Property WindowList : TStringList read fWindowsList write fWindowsList;
   Property EmptyNames : Boolean read fAcceptEmptyNames write fAcceptEmptyNames default False;
   Property TaskBarSty : Boolean read fTaskBarStyle write fTaskBarStyle default True;
   Property TimerIntval: Integer read fTimeVal write SetTimeVal default 500;
   Property EnableTimer: Boolean read fTimerOn write SetTimer default False;
   Property OnChanged  : TNotifyEvent read FOnChanged write FOnChanged;
  end;

function  GetStyle(hdl : HWnd):Boolean;
procedure Register;
implementation
var
 WCheck,
 nWCheck : LongInt;
 ac,ftb,
 changed : Boolean;
 fid     : TFind_ID;
 Nums    : Integer;
 aw      : array[0..255] of HWnd;


function EnumWindowsProc(hwndNext : HWnd; var lpara : LongInt):Bool;stdcall;
var
 P      : array[0..255] of Char;
 DoIt   : Boolean;
 hwPop  : HWnd;
begin
 Result := True;

 if hwndNext <> 0 then begin
  P[0] := #0;
  DoIt := False;
  GetWindowText(hwndNext, P, 255);
  if (ac or (P[0] <> #0)) then

   case fid of
    id_all      :                                         DoIt := True;
    id_visonly  : if (IsWindowVisible(hwndNext))     then DoIt := True;
    id_invisonly: if NOT (IsWindowVisible(hwndNext)) then DoIt := True;
   end;

   if (DoIt)then begin
    if NOT(ftb) then begin
     aw[Nums]:= hwndNext;
     inc (Nums);
     nWCheck := nWCheck + hwndNext;
     exit;
    end;
    if (GetWindow(hwndNext, GW_OWNER) = 0) then
     if GetStyle(hwndNext) then begin
      aw[Nums]:= hwndNext;
      inc (Nums);
      nWCheck := nWCheck + hwndNext;
     end
     else if isWindow(GetLastActivePopup(hwndNext))then begin
       hwPop := GetLastActivePopup(hwndNext);
       if GetStyle(hwPop) then begin
        aw[Nums]:= hwndNext;
        inc (Nums);
        nWCheck := nWCheck + hwndNext;
       end;
     end;
   end;
  end else Result := False;
end;

Constructor TWinList.Create(AOwner : TComponent);
Begin
 inherited Create(AOwner);
 fWindowsList      := TStringList.Create;
 timer1            := TTimer.Create(self);
 timer1.OnTimer    := Timer1Timer;
 timer1.Enabled    := False;
 fAcceptEmptyNames := False;
 fTimeVal          := 500;
 fTimerOn          := False;
 fFindId           := id_visonly;
 fTaskBarStyle     := True;
 WCheck            := 0;
 fAbout            := '';
 changed           := True;
End;

Destructor TWinList.Destroy;
Begin
 fWindowsList.Clear;
 fWindowsList.Free;
 WinObj.Free;
 WinObj := NIL;
 timer1.Enabled := False;
 timer1.Free;
 inherited Destroy;
End;

Procedure TWinList.GetWindowsInfo(WinHandle : HWND);
var
 P      : array[0..256] Of Char;
 dwActiveProcessId : DWORD;
 snap   : THandle;
 pe32   : TPROCESSENTRY32;
Begin
 P[0] := #0; snap := 0;
 WinObj      := TWinInfo.Create;
 WinObj.whdl := WinHandle;
 WinObj.thdl := GetWindowThreadProcessId(WinHandle,NIL);
 GetWindowThreadProcessId(WinHandle, @dwActiveProcessId );
 WinObj.phdl := dwActiveProcessId;
 WinObj.wsty := GetWindowLong(WinHandle,GWL_STYLE);
 WinObj.wXty := GetWindowLong(WinHandle,GWL_EXSTYLE);
 WinObj.hPar := GetWindowLong(WinHandle,GWL_HWNDPARENT);
 GetClassName(WinHandle, P, 100);
 WinObj.clas := String(P);

 if WinObj.hPar = 0 then P := 'Desktop'
 else               GetWindowText(WinObj.hPar, P, 255);
 if P='' then P := 'NoName';
 WinObj.Parent := String(P);

 GetWindowText(WinHandle, P, 255);
 try
  snap := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS,
                                   dwActiveProcessId);
  if snap <> 0 then begin
   pe32.dwSize := SizeOf(TPROCESSENTRY32);
   if Process32First(snap, pe32) then begin
    if pe32.th32ProcessID = dwActiveProcessId then begin
     WinObj.ExePath := String(pe32.szExeFile);
     // and so on ProcessEntry
    end else begin
     while Process32Next(snap, pe32) do begin
      if pe32.th32ProcessID = dwActiveProcessId then begin
       WinObj.ExePath := String(pe32.szExeFile);
       // and so on ProcessEntry
       break;
      end;
     end;
    end;
   end;
  end;
 finally
  CloseHandle(snap);
 end;
 fWindowsList.AddObject(P, WinObj);
End;

Procedure TWinList.Execute;
var
 i : Integer;
Begin
 nWCheck := 0;
 timer1.Enabled := False;
 ac   := fAcceptEmptyNames;
 fid  := FFindID;
 ftb  := fTaskBarStyle;
 Nums := 0;

 EnumWindows(@EnumWindowsProc,0);

 if WCheck <> nWCheck then begin
  WCheck  := nWCheck;
  fWindowsList.Clear;
   for i := 0 to Nums - 1 do
    GetWindowsInfo(aw[i]);
  changed := True;
 end else changed := False;
 if fTimerOn then timer1.Enabled := True;
End;

procedure TWinList.SomeChanged;
begin
 if Assigned(FOnChanged) then FOnChanged(Self);
end;

procedure TWinList.Timer1Timer(Sender:TObject);
begin
 if fTimeVal < 1 then timer1.Enabled := False;
 Execute;
 Application.ProcessMessages;
 if changed then SomeChanged;
end;

procedure TWinList.FuAbout(value:String);
begin
 if value <> fAbout then begin
  fAbout := cAbout;
  MessageDlg('Komponente: TFindWin2.0             '+ #10#13+ #10#13+
             '1997 by Dr.Plass                   '+ #10#13+
             'Peter.Plass@fh-zwickau.de           '+ #10#13+
             'http://www.fh-zwickau.de/~pp/tm.htm ',
              mtInformation, [mbOk],0);
  end;
end;

procedure TWinList.SetTimer(value:Boolean);
begin
 if value <> fTimerOn then begin
  fTimerOn       := value;
  timer1.Enabled := fTimerOn;
 end;
end;

procedure TWinList.SetTimeVal(value: Integer);
begin
 if value < 1 then  EnableTimer:= False;
 if value <> fTimeVal then begin
  fTimeVal        := value;
  timer1.Interval := fTimeVal;
 end;
end;

function TWinList.GetWinParent(Idx : Integer) : HWND;
begin
  Result := TWinInfo(fWindowsList.Objects[Idx]).hpar;
end;
function TWinList.GetWinHandle(Idx : Integer) : HWND;
begin
  Result := TWinInfo(fWindowsList.Objects[Idx]).whdl;
end;
function TWinList.GetThreadID(Idx : Integer) : HTask;
begin
  Result := TWinInfo(fWindowsList.Objects[Idx]).thdl;
end;
function TWinList.GetProcessID(Idx : Integer) : DWORD;
begin
  Result := TWinInfo(fWindowsList.Objects[Idx]).phdl;
end;
function TWinList.GetWinStyle(Idx : Integer) : LongInt;
begin
  Result := TWinInfo(fWindowsList.Objects[Idx]).wsty;
end;
function TWinList.GetWinExStyl(Idx : Integer) : LongInt;
begin
  Result := TWinInfo(fWindowsList.Objects[Idx]).wXty;
end;
function TWinList.GetWinExePath(Idx : Integer): String;
begin
  Result := TWinInfo(fWindowsList.Objects[Idx]).ExePath;
end;
function TWinList.GetWnClasName(Idx : Integer): String;
begin
 Result := TWinInfo(fWindowsList.Objects[Idx]).clas;
end;
function TWinList.GetParentName(Idx : Integer): String;
begin
 Result := TWinInfo(fWindowsList.Objects[Idx]).Parent;
end;

function GetStyle(hdl : HWnd):Boolean;
var
 style : LongInt;
BEGIN
 Result := False;
 style  := GetWindowLong(hdl,GWL_STYLE);
 if((  style AND WS_POPUP)    = WS_POPUP) then  begin
  if(((style AND WS_GROUP)    = WS_GROUP)       AND NOT
     ((style AND WS_DISABLED) = WS_DISABLED)    AND
     ((style AND WS_SYSMENU)  = WS_SYSMENU))    then
     Result := True;
 end else Result := True;
END;

procedure Register;
begin
  RegisterComponents('Plass', [TWinList]);
end;

end.







