unit List;

interface

uses Objects, ListElem, Stack, Contain;


{------------- TList (Stack)---------------------
								 Init
								 InitIterator
								 AddAt
								 DetachAt
								 DeleteAt}

{------------- TListIterator ---------------------
								 Init
                 Copy
								 Done
								 This
								 Finished
								 Inc
								 Reset}
{------------------------------------------------}


type	PListIterator=^TListIterator;
			TListIterator=object(TContainerIterator)
				constructor Init(TheHead,TheTail:PListElement);
				constructor Copy(ToCopy:PListIterator);
				destructor Done; virtual;
				function This:Pointer; virtual;
				function Finished:Boolean; virtual;
				function Inc:Boolean; virtual;
				procedure Reset; virtual;
			private
				Head,Tail,Current,Previous:PListElement;
				end;

type  PList=^TList;
			TList=object(TStack)
				constructor Init;
				function InitIterator:PContainerIterator; virtual;
				procedure AddAt(Iterator:PListIterator;ToAdd:PObject); virtual;
				function DetachAt(Iterator:PListIterator):Pointer; virtual;
				procedure DeleteAt(Iterator:PListIterator); virtual;
				end;



implementation


{-----------------------------------------------}
{------------------ TList ----------------------}
{--Init-----------------------------------------}

constructor TList.Init;
begin
TStack.Init;
end;

{--InitIterator---------------------------------}

function TList.InitIterator:PContainerIterator;
begin
writeln('Yes');
InitIterator:=PContainerIterator(new(PListIterator, Init(Head,Tail)));
end;

{--AddAt----------------------------------------}

procedure TList.AddAt(Iterator:PListIterator;ToAdd:PObject);
var NewListElem:PListElement;
begin
new(NewListElem, Init(ToAdd));
with Iterator^ do
	begin
	Previous^.Next:=NewListElem;
	NewListElem^.Next:=Current;
	Current:=NewListElem;
	end;
Size:=Size+1;
end;

{--DetachAt-------------------------------------}

function TList.DetachAt(Iterator:PListIterator):Pointer;
begin
with Iterator^ do
	begin
	DetachAt:=Current^.Data;
	Current^.Data:=nil;
	Previous^.Next:=Current^.Next;
	if Current<>Tail then
		begin
		dispose(Current, Done);
		Size:=Size-1;
		end;
	Current:=Previous^.Next;
	end;
end;

{--DeleteAt-------------------------------------}

procedure TList.DeleteAt(Iterator:PListIterator);
var Temp:PObject;
begin
Temp:=DetachAt(Iterator);
if Temp<>nil then dispose(Temp, Done);
end;



{-----------------------------------------------}
{---------------- List Iterator ----------------}
{--Init-----------------------------------------}

constructor TListIterator.Init(TheHead,TheTail:PListElement);
begin
TContainerIterator.Init;
Head:=TheHead;
Tail:=TheTail;
Reset;
end;

{--Init-----------------------------------------}

constructor TListIterator.Copy(ToCopy:PListIterator);
begin
TContainerIterator.Init;
Head:=ToCopy^.Head;
Tail:=ToCopy^.Tail;
Current:=ToCopy^.Current;
Previous:=ToCopy^.Previous;
end;

{--Done-----------------------------------------}

destructor TListIterator.Done;
begin
TContainerIterator.Done;
end;

{--This-----------------------------------------}

function TListIterator.This:Pointer;
begin
This:=Current^.Data;
end;

{--Finished-------------------------------------}

function TListIterator.Finished:boolean;
begin
Finished:=(Current=Tail);
end;

{--Inc------------------------------------------}

function TListIterator.Inc:Boolean;
begin
if not Finished then
	begin
	Previous:=Current;
	Current:=Current^.Next;
	end;
Inc:=not Finished;
end;

{--Reset----------------------------------------}

procedure TListIterator.Reset;
begin
Previous:=Head;
Current:=Head^.Next;
end;

end.