unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DBTables, StdCtrls, DbiTypes, DbiErrs, DbiProcs,
  ExtCtrls, ComCtrls, Menus, PswdInf, Password;

type
  TMainForm = class(TForm)
    Table1: TTable;
    AAPanel: TPanel;
    AABtn: TButton;
    APswd: TEdit;
    RORb: TRadioButton;
    MRb: TRadioButton;
    IRb: TRadioButton;
    IDRb: TRadioButton;
    AMPanel: TPanel;
    MPswd: TEdit;
    AMBtn: TButton;
    RAPanel: TPanel;
    RMPanel: TPanel;
    RMBtn: TButton;
    RABtn: TButton;
    RAPswd: TEdit;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Close1: TMenuItem;
    View1: TMenuItem;
    PasswordInformation1: TMenuItem;
    procedure AMBtnClick(Sender: TObject);
    procedure AABtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MPswdChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure RMBtnClick(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure RABtnClick(Sender: TObject);
    procedure RAPswdChange(Sender: TObject);
    procedure PasswordInformation1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.AMBtnClick(Sender: TObject);
begin
  Table1.Open;
  screen.cursor := crHourGlass;
  try
    AddMasterPassword(Table1, MPswd.Text);
    Table1.Close;
  finally
    screen.cursor := crDefault;
  end;
end;

procedure TMainForm.AABtnClick(Sender: TObject);
begin
  Table1.Open;
  screen.cursor := crHourGlass;
  try
    if RORb.Checked = True then
      AABtn.Tag := prvREADONLY;
    if IRb.Checked = True then
      AABtn.Tag := prvINSERT;
    if MRb.Checked = True then
      AABtn.Tag := prvMODIFY;
    if IDRb.Checked = True then
      AABtn.Tag := prvINSDEL;
    AddAuxPassword(Table1, MPswd.Text, APswd.Text, AABtn.Tag);
    Table1.Close;
  finally
    screen.cursor := crDefault;
  end;
end;


procedure TMainForm.FormCreate(Sender: TObject);
begin
  MPswd.Text := '';
  APswd.Text := '';
  RAPswd.Text := '';
  Table1.DatabaseName := ExtractFilePath(Application.ExeName);
end;

procedure TMainForm.MPswdChange(Sender: TObject);
begin
  if Length(MPswd.Text) > 0 then
  begin
    AMBtn.Enabled := True;
    if Length(APswd.Text) > 0 then
      AABtn.Enabled := True
    else
      AABtn.Enabled := False;
    if Length(RAPswd.Text) > 0 then
      RABtn.Enabled := True
    else
      RABtn.Enabled := False;
  end
  else
  begin
    AMBtn.Enabled := False;
    AABtn.Enabled := False;
    RABtn.Enabled := False;
  end;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  MPswd.SetFocus;
end;

procedure TMainForm.RMBtnClick(Sender: TObject);
begin
  screen.cursor := crHourGlass;
  Table1.Open;
  try
    RemoveMasterPassword(Table1);
    Table1.Close;
  finally
    screen.cursor := crDefault;
  end;
end;

procedure TMainForm.Close1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.RABtnClick(Sender: TObject);
var
  mstrpswd: string;
begin
  mstrpswd := '';
  screen.cursor := crHourGlass;
  Table1.Open;
  try
    RemoveAuxPassword(Table1, MPswd.Text, RAPswd.Text);
    Table1.Close;
  finally
    screen.cursor := crDefault;
  end;
end;

procedure TMainForm.RAPswdChange(Sender: TObject);
begin
  if (Length(RAPswd.Text) > 0) and (Length(MPswd.Text) > 0) then
    RABtn.Enabled := True
  else
    RABtn.Enabled := False;  
end;

procedure TMainForm.PasswordInformation1Click(Sender: TObject);
begin
  Table1.Open;
  PswdInfo.TNLbl.Caption := Table1.TableName;
  PswdInfo.hDb := Table1.DBHandle;
  PswdInfo.ShowModal;
  Table1.Close;
end;

initialization
  Session.Open;
finalization
  Session.Close;
end.
