{$A+,B-,C-,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y-,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
{
  Main.pas -- main form unit for IB Create Database example.

  DESCRIPTION:  This program will create an IB Database and optionally
    add data to a table within the Database.  An InterBase Database file
    cannot be created through BDE calls; it must be created through the
    InterBase API.  This program demonstrates and wraps a simple
    function to create a new Database.

}
unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, DB, DBTables, StdCtrls, ExtCtrls, IB, BDE;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    CreateBtn: TButton;
    AddDataChk: TCheckBox;
    IBDB: TDatabase;
    DBGrid1: TDBGrid;
    Label1: TLabel;
    UserName: TEdit;
    Label2: TLabel;
    Password: TEdit;
    Label3: TLabel;
    PathDB: TEdit;
    IBTable: TTable;
    DataSource1: TDataSource;
    procedure CreateBtnClick(Sender: TObject);
  private
    { Private declarations }
    procedure AddData;
    function GetString(MsgId: Word): String;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}
{$R data.res}
{$I data.inc}

const
  IBTableName = 'TEST_TABLE';

{ Create and optionally add data to a new Database }
procedure TMainForm.CreateBtnClick(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  try try
    IBTable.Close;
    IBDB.Close;
    CreateDatabase(PathDB.Text, UserName.Text, Password.Text);
    if AddDataChk.Checked = True then
      AddData;
  except
    on E:EDatabaseError do
    begin
      MessageBeep(MB_ICONEXCLAMATION);
      MessageDlg(E.Message, mtError, [mbOk], 0);
    end;
  end;
  finally
    Screen.Cursor := crDefault;
  end;
end;

{ Add data to a Database }
procedure TMainForm.AddData;
var
  Buf: String;
  Rows, W, Count: Word;
  x_handle: hDBIXact;

begin
  Buf := Format('CREATE TABLE %s (Field1 INTEGER NOT NULL UNIQUE,  ' +
           'Field2 CHAR(30), Field3 VARCHAR(45), Field4 SMALLINT NOT NULL);',
            [IBTableName]);
  { Setup and connect the TDatabase to the new Database }
  IBDB.Params.Values['SERVER NAME'] := PathDB.Text;
  IBDB.Params.Values['USER NAME'] := UserName.Text;
  IBDB.Params.Values['PASSWORD'] := Password.Text;
  IBDB.Open;
  Check(DbiQExecDirect(IBDB.Handle, qrylangSQL, PChar(Buf), nil));
  Rows := StrToInt(GetString(MAX_RECORDS));
  { Start a transaction ... }
  Check(DbiBeginTran(IBDB.Handle, xilREADCOMMITTED, x_handle));
  try
    for W := 1 to Rows do
    begin
      Count := W * 4;
      Buf := Format('INSERT INTO %s VALUES (%s, "%s", "%s", %s);',
                [IBTableName, GetString(Count - 3), GetString(Count - 2),
                 GetString(Count - 1), GetString(Count)]);
      { Insert the data }
      Check(DbiQExecDirect(IBDB.Handle, qrylangSQL, PChar(Buf), nil));
    end;
    { If all goes well, commit the inserted records }
    Check(DbiEndTran(IBDB.Handle, x_handle, xendCOMMIT));
  except
    on E:EDatabaseError do
    begin
      { Rollback any inserted records if an error occurred }
      Check(DbiEndTran(IBDB.Handle, x_handle, xendABORT));
      raise EDatabaseError.Create(E.Message);
    end;
  end;
  { Open and display the new table information }
  IBTable.TableName := IBTableName;
  IBTable.Open;
end;

{ Get a string out of a stringtable resource }
function TMainForm.GetString(MsgId: Word): String;
const
  MAXSIZE = 100;
var
  Msg: string;

begin
  SetLength(Msg, MAXSIZE);
  if LoadString(HInstance, MsgId, PChar(Msg), 255) = 0 then
    raise Exception.Create('String resource does not exist')
  else
  begin
    SetLength(Msg, StrLen(PChar(Msg)));
    GetString := Msg;
  end;
end;

end.
