unit MemQueue;

interface

uses MemBuf,Classes,MemStr;

type  TMemoryQueue=class(TMemoryBuffer)
			private
				function GetSize:longint; override;
			public
				function Read(var Buf; Count:longint):longint; override;
				function Seek(Offset:longint; Origin:word):longint; override;
			end;

implementation

{-----------------------------------------------------------------------}
{------------------ TMemoryQueue ---------------------------------------}
{-----------------------------------------------------------------------}

function TMemoryQueue.Read(var Buf; Count:longint):longint;
var FirstBlockDataSize:longint;
		i,BlocksRequired:longint;
		CountLeft:word;
		StartRead,BufWrite:PChar;
		OldBlock:TMemoryBlock;
begin
with StartPos do
	begin
	if Block=WritePos.Block then
		FirstBlockDataSize:=WritePos.Offset-StartPos.Offset
	else
		FirstBlockDataSize:=Block.Size-Offset;
	StartRead:=Block.Data;
	Inc(StartRead,Offset);
	BufWrite:=PChar(@Buf);
	if Count<=FirstBlockDataSize then
		begin
		Move(StartRead^,BufWrite^,Count);
		Offset:=Offset+Count;
		end
	else
		begin
		Move(StartRead^,BufWrite^,FirstBlockDataSize);
		Inc(BufWrite,FirstBlockDataSize);
		CountLeft:=Count-FirstBlockDataSize;
		BlocksRequired:=(CountLeft+BlockSize-1) div BlockSize;
		for i:=1 to BlocksRequired do
			begin
			if Block.Next=nil then raise EEndOfStream.Create('End of stream') else
				begin
				OldBlock:=Block;
				Block:=Block.Next;
				OldBlock.Free;
				if CountLeft<=BlockSize then
					begin
					Move(Block.Data^,BufWrite^,CountLeft);
					Offset:=CountLeft;
					end
				else
					begin
					Move(Block.Data^,BufWrite^,BlockSize);
					Inc(BufWrite,BlockSize);
					Dec(CountLeft,BlockSize);
					end;
				end;
			end;
		end;
	end;
end;

function TMemoryQueue.GetSize:longint;
begin
GetSize:=(inherited GetSize) - StartPos.Offset;
end;

function TMemoryQueue.Seek(Offset:longint; Origin:word):longint;
var Buf:PChar;
begin
if Offset<0 then
	begin
	if (Origin<>stEnd) then
		raise EEndOfStream.Create('Can''t read back from beginning of stream')
	else
		Result:=Seek(Size+Offset,stBeginning)
	end
else
	begin
	if Origin=stEnd then
		raise EEndOfStream.Create('Can''t read past end of stream')
	else
		begin
		GetMem(Buf,Offset);
		Read(Buf,Offset);
		FreeMem(Buf,Offset);
		Result:=Offset;
		end;
	end;
end;

end.
