unit Mssql16;

{ Import routines and some constants for MS SQL server.
  16-bit only...  Use Freely, but I warranty nothing.
  Ed Lyk  1997-08-27
  elyk@sprynet.com
}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Forms, Dialogs;

type

  DBPROCESS = Integer;  {these are actually near pointers.}
  LOGINREC = Integer;   {since delphi does have these I used}
  DBCURSOR = Integer;   {integers and seems to work fine.}

const
  DBSETHOST  = 1;
  DBSETUSER  = 2;
  DBSETPWD   = 3;
  DBSETAPP   = 4;
  DBSETID    = 5;
  DBSETLANG  = 6;
  DBSUCCEED  = 1;
  DBFAIL     = 0;
  INTBIND    = 3;
  CHARBIND   = 4;
  BINARYBIND = 5;
  DATETIMEBIND = 7;
  STRINGBIND = 10;
  NTBSTRINGBIND = 11;
  VARYCHARBIND = 12;
  VARYBINBIND = 13;
  MORE_ROWS   = -1;
  NO_MORE_ROWS = -2;
  BUF_FULL  = -3;
  NO_MORE_RESULTS = 2;
  REG_ROW = MORE_ROWS;
  DBRPCRETURN = 1;
  SQLTEXT = $23;
  SQLVARBINARY = $25;
  SQLVARCHAR = $27;
  SQLBINARY = $2d;
  SQLIMAGE =  $22;
  SQLCHAR =  $2f;
  SQLINT1 =  $30;
  SQLINT2 = $34;
  SQLINT4 = $38;
  SQLINTN = $26;
  SQLDATETIME = $3d;
  SQLFLT8 = $3e;
  SQLFLTN = $6d;
  SQLMONEYN = $6e;
  SQLDATETIMN = $6f;

function dblogin: LOGINREC; cdecl; far;
function dbopen(login: LOGINREC; ServerName: PChar): DBPROCESS; cdecl; far;
function dbinit: PChar; cdecl; far;
procedure dbexit; cdecl; far;
function dbsetlname(login: LOGINREC; val: PChar; item: Integer): Integer; cdecl; far;
procedure dbfreelogin(login: LOGINREC); cdecl; far;
procedure dbclose(proc: DBPROCESS); cdecl; far;
function dbcmd(proc: DBPROCESS; cmd: PChar): Integer; cdecl; far;
function dbsqlexec(proc: DBPROCESS): Integer; cdecl; far;
function dbresults(proc: DBPROCESS): Integer; cdecl; far;
function dbbind(proc: DBPROCESS; Column, VarType, VarLen: Integer; VarAddr: Pointer):Integer; cdecl; far;
function dbnextrow(proc: DBPROCESS): Integer; cdecl; far;
function dbdata(proc: DBPROCESS; column: Integer): Pointer; cdecl; far;
function dbdatlen(proc: DBPROCESS; column: Integer): Integer; cdecl; far;
function dbrpcinit(proc: DBPROCESS; ProcName: PChar; Options: Integer): Integer; cdecl; far;
function dbrpcparam(proc: DBPROCESS; paramname: PChar; status: Byte; ptype: Integer; maxlen, datalen: Integer;
                    value: Pointer): Integer; cdecl; far;
function dbrpcsend(proc: DBPROCESS): Integer; cdecl; far;
function dbsqlok(proc: DBPROCESS): Integer; cdecl; far;
function dbretdata(proc: DBPROCESS; column: Integer): Pointer; cdecl; far;
function dbrpcexec(proc: DBPROCESS): Integer; cdecl; far;
function dbuse(proc: DBPROCESS; DBName: PChar): Integer; cdecl; far;

implementation

function dblogin: LOGINREC; external 'msdblib3' name '_dblogin';
function dbopen(login: LOGINREC; ServerName: PChar): DBPROCESS;external 'msdblib3' name '_dbopen';
function dbinit: PChar; external 'msdblib3' name '_dbinit';
procedure dbexit; external 'msdblib3' name '_dbexit';
function dbsetlname(login: LOGINREC; val: PChar; item: Integer): Integer; external 'msdblib3' name '_dbsetlname';
procedure dbfreelogin(login: LOGINREC); external 'msdblib3' name '_dbfreelogin';
procedure dbclose(proc: DBPROCESS); external 'msdblib3' name '_dbclose';
function dbcmd(proc: DBPROCESS; cmd: PChar): Integer; external 'msdblib3' name '_dbcmd';
function dbsqlexec(proc: DBPROCESS): Integer; external 'msdblib3' name '_dbsqlexec';
function dbresults(proc: DBPROCESS): Integer; external 'msdblib3' name '_dbresults';
function dbbind(proc: DBPROCESS; Column, VarType, VarLen: Integer; VarAddr: Pointer):Integer;
                                external 'msdblib3' name '_dbbind';
function dbnextrow(proc: DBPROCESS): Integer; external 'msdblib3' name '_dbnextrow';
function dbdata(proc: DBPROCESS; column: Integer): Pointer; external 'msdblib3' name '_dbdata';
function dbdatlen(proc: DBPROCESS; column: Integer): Integer; external 'msdblib3' name '_dbdatlen';
function dbrpcinit(proc: DBPROCESS; ProcName: PChar; Options: Integer): Integer;
                external 'msdblib3' name '_dbrpcinit';
function dbrpcparam(proc: DBPROCESS; paramname: PChar; status: Byte; ptype: Integer; maxlen, datalen: Integer;
                    value: Pointer): Integer; external 'msdblib3' name '_dbrpcparam';
function dbrpcsend(proc: DBPROCESS): Integer; external 'msdblib3' name '_dbrpcsend';
function dbsqlok(proc: DBPROCESS): Integer; external 'msdblib3' name '_dbrpcsend';
function dbretdata(proc: DBPROCESS; column: Integer): Pointer; external 'msdblib3' name '_dbretdata';
function dbrpcexec(proc: DBPROCESS): Integer; external 'msdblib3' name '_dbrpcexec';
function dbuse(proc: DBPROCESS; DBName: PChar): Integer; external 'msdblib3' name '_dbuse';

end.
