{ File: Unit1.Pas                                                    }
{ Description: ODBC Interactive SQL                                  }
{ Author: Pieter A. Myburgh                                          }
{ Updated: 01/10/96                                                  }
{                                                                    }
{ Notes:                                                             }
{                                                                    }
{ 1.  This demo program demonstrates how to use the ODBCExpress grid }
{     to browse tables.                                              }

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, ExtGrid, OCIH, OCI, ODI, OCL, ExtCtrls, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    OEGrid1: TOEGrid;
    Henv1: THenv;
    Hdbc1: THdbc;
    BitBtn1: TBitBtn;
    Button1: TButton;
    Button2: TButton;
    Hstmt1: THstmt;
    Button3: TButton;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FTableName: String;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
  Unit2, Unit3;

procedure TForm1.FormShow(Sender: TObject);
begin
  FTableName:= '';
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Form2.ShowModal;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if Hdbc1.Connected then
    Form3.ShowModal
  else
    MessageDLG('Not connected to a data source.', mtError, [mbOK], 0);
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  RetCode: SQLRETURN;
  icol, NumCols: SQLUSMALLINT;
  ColName: NullString;
  cbDesc: SQLSMALLINT;
  ColType: SQLINTEGER;
  ColNames: String;
begin
  try
    if FTableName = '' then
      MessageDLG('No table name selected.', mtError, [mbOK], 0)
    else
    begin
      OEGrid1.Terminate;
      OEGrid1.ColCount:= 2;
      OEGrid1.Columns[1].Title:= '';

      Hstmt1.SQL:= 'SELECT * FROM '+FTableName;
      Hstmt1.Prepare;
      Hstmt1.Execute;
      NumCols:= Hstmt1.NumCols;

      ColNames:= '';
      for icol:= 1 to NumCols do
      begin
        { Retrieve Column Type }
        RetCode:= SQLColAttributes(Hstmt1.Handle, icol, SQL_COLUMN_TYPE, @ColName,
          MaxNullString+1, @cbDesc, @ColType);

        if Henv1.Error.Success(RetCode) and
          (ColType <> SQL_LONGVARCHAR) and (ColType <> SQL_LONGVARBINARY) then
        begin
          { Retrieve Column Name }
          RetCode:= SQLColAttributes(Hstmt1.Handle, icol, SQL_COLUMN_NAME, @ColName,
            MaxNullString+1, @cbDesc, @ColType);

          if Henv1.Error.Success(RetCode) then
          begin
            if ColNames = '' then
              ColNames:= ColName
            else
              ColNames:= ColNames+', '+ColName;
          end;
        end;
      end;

      if ColNames = '' then
        MessageDLG('Unable to retrieve selected table''s column names.', mtError, [mbOK], 0)
      else
      begin
        OEGrid1.SQL:= 'SELECT '+ColNames+ ' FROM '+FTableName;
        OEGrid1.Populate;
      end;
    end;
  except
    on ODBCError do
      Henv1.Error.Display;
  end;
end;

end.

