{ File: Unit1.Pas                                                    }
{ Description: ODBC Interactive SQL                                  }
{ Author: Pieter A. Myburgh                                          }
{ Updated: 01/10/96                                                  }
{                                                                    }
{ Notes:                                                             }
{                                                                    }
{ 1.  This demo program demonstrates how to integrate ODBC functions }
{     not directly supported by ODBCExpress.                         }

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OCIH, OCI, ODI, OCL, ComCtrls, Buttons;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    BitBtn1: TBitBtn;
    Edit1: TEdit;
    Label1: TLabel;
    Henv1: THenv;
    Hdbc1: THdbc;
    Hstmt1: THstmt;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    NumRows: Longint;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
  Unit2;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Form2.ShowModal;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  icol, NumCols: SQLUSMALLINT;
  S: String;
  RetCode: SQLRETURN;
  ColName: NullString;
  cbDesc: SQLSMALLINT;
  fDesc: SQLINTEGER;
begin
  try
    Hstmt1.SQL:= Edit1.Text;
    Hstmt1.Prepare;
    Hstmt1.Execute;

    NumCols:= Hstmt1.NumCols;
    Memo1.Clear;
    S:= '';
    for icol:= 1 to NumCols do
    begin
      { Retrieve Column Name }
      RetCode:= SQLColAttributes(Hstmt1.Handle, icol, SQL_COLUMN_NAME, @ColName,
        MaxNullString+1, @cbDesc, @fDesc);

      { Raise ODBCError }
      if not Henv1.Error.Success(RetCode) then
        Henv1.Error.RaiseError(Hstmt1, RetCode);

      if Hstmt1.ColType(icol) <> SQL_C_BINARY then
        S:= S+ColName+'  ';
    end;
    Memo1.Lines.Add(S);
    Memo1.Lines.Add('');

    NumRows:= 0;
    while Hstmt1.FetchNext do
    begin
      Inc(NumRows);
      S:= '';
      for icol:= 1 to NumCols do
        if Hstmt1.ColType(icol) <> SQL_C_BINARY then
          S:= S+Hstmt1.ColString(icol)+'  ';
      Memo1.Lines.Add(S);
    end;
  except
    On ODBCError do
      if StrComp(PChar(Henv1.Error.State), '24000') <> 0 then  //Invalid Cursor State
        Henv1.Error.Display;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  MessageDLG('Result set contains '+IntToStr(NumRows)+' rows.',
    mtInformation, [mbOK], 0);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  Memo1.Clear;
end;

end.

