{ File: Unit1.Pas                                                    }
{ Description: Test ODBCExpress Threads                              }
{ Author: Pieter A. Myburgh                                          }
{ Updated: 01/10/96                                                  }
{                                                                    }
{ Notes:                                                             }
{                                                                    }
{ 1.  This demo program demonstrates how to use ODBCExpress with     }
{     threads.                                                       }
{ 2.  This program was successfully run against MS SQLServer and     }
{     MS Access.                                                     }

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, ExtGrid, OCL, StdCtrls;

type
  TForm1 = class(TForm)
    OEGrid1: TOEGrid;
    OEGrid2: TOEGrid;
    OEGrid3: TOEGrid;
    Button1: TButton;
    Henv1: THenv;
    Hdbc1: THdbc;
    Hdbc2: THdbc;
    Hdbc3: THdbc;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TPopGrid = class(TThread)
  private
    FGrid: TOEGrid;
  protected
    procedure Execute; override;
  public
    constructor Create(AGrid: TOEGrid);
  published
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TPopGrid.Execute;
begin
  FGrid.Populate;
end;

constructor TPopGrid.Create(AGrid: TOEGrid);
begin
  inherited Create(False);

  FGrid:= AGrid;
  FreeOnTerminate:= True;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  OEGrid1.SQL:= 'SELECT SNo, SName FROM Students';
  OEGrid2.SQL:= OEGrid1.SQL;
  OEGrid3.SQL:= OEGrid1.SQL;

  TPopGrid.Create(OEGrid1);
  TPopGrid.Create(OEGrid2);
  TPopGrid.Create(OEGrid3);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  try
    Hdbc1.Connect;
    Hdbc2.Connect;
    Hdbc3.Connect;
  except
    on ODBCError do
      Henv1.Error.Display;
  end;
end;

end.

