unit pswdinf;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DB, BDE;

type
  TPswdInfo = class(TForm)
    GroupBox1: TGroupBox;
    Label2: TLabel;
    TNLbl: TLabel;
    GroupBox2: TGroupBox;
    PswdNameLB: TListBox;
    ROBtn: TRadioButton;
    IBtn: TRadioButton;
    MBtn: TRadioButton;
    IDBtn: TRadioButton;
    Button1: TButton;
    SecCountLbl: TLabel;
    SeqNoLbl: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure PswdNameLBClick(Sender: TObject);
  private
    { Private declarations }
    Sec: SECDesc;
    hCur: hDBICur;
    SecCount: longint;
    procedure ShowSecInfoByName(SecName: string);
  public
    { Public declarations }
    hDb: hDBIDb;
  end;

var
  PswdInfo: TPswdInfo;

implementation

uses Main;

{$R *.DFM}

procedure TPswdInfo.FormShow(Sender: TObject);
begin
  hCur := nil;
  PswdNameLB.Items.Clear;
  Check(DbiOpenSecurityList(hDb, PChar(TNLbl.Caption), nil, hCur));
  Check(DbiSetToBegin(hCur));
  while DbiGetNextRecord(hCur, dbiNOLOCK, @Sec, nil) = DBIERR_NONE do
  begin
    PswdNameLB.Items.Add(Sec.szPassword);
  end;
  Check(DbiGetRecordCount(hCur, SecCount));
  SecCountLbl.Caption := 'Count: ' + IntToStr(SecCount);
  SeqNoLbl.Caption := 'Sequence No:';
  IBtn.Checked := False;
  MBtn.Checked := False;
  IDBtn.Checked := False;
  ROBtn.Checked := False;
end;

procedure TPswdInfo.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if hCur <> nil then
    Check(DbiCloseCursor(hCur));
end;

procedure TPswdInfo.ShowSecInfoByName(SecName: string);
var
  rslt: DbiResult;

begin
  Check(DbiSetToBegin(hCur));
  rslt := DBIERR_NONE;
  while rslt = DBIERR_NONE do
  begin
    rslt := DbiGetNextRecord(hCur, dbiNOLOCK, @Sec, nil);
    if rslt <> DBIERR_NONE then
      break;
    if CompareText(Sec.szPassword, SecName) = 0 then  // Descriptor Found...
    begin
      SeqNoLbl.Caption := 'Sequence No: ' + IntToStr(Sec.iSecNum);
      if Sec.eprvTable = prvREADONLY then
        ROBtn.Checked := True;
      if Sec.eprvTable = prvMODIFY then
        MBtn.Checked := True;
      if Sec.eprvTable = prvINSERT then
        IBtn.Checked := True;
      if Sec.eprvTable = prvINSDEL then
        IDBtn.Checked := True;
      break;
    end;
  end;
end;

procedure TPswdInfo.PswdNameLBClick(Sender: TObject);
begin
  ShowSecInfoByName(PswdNameLB.Items.Strings[PswdNameLB.ItemIndex]);
end;

end.

