unit Queue;


interface

uses Objects, DlstElem, LinkList;


{------------- TQueue ---------------------------
								Init
								Done
								IsEmpty
								AddAtHead
								DetachFromTail
								DeleteFromTail}
{------------------------------------------------}

type  PQueue=^TQueue;
			TQueue=object(TLinkedList)
				Head,Tail:PDoubleListElement;
				constructor Init;
				destructor Done; virtual;
				function IsEmpty:Boolean; virtual;
				procedure AddAtHead(ToAdd:PObject); virtual;
				function Detach:Pointer; virtual;
				function DetachFromTail:Pointer; virtual;
				procedure DeleteFromTail; virtual;
				end;


{------------------------------------------------}

implementation

{---Init-----------------------------------------}

constructor TQueue.Init;
begin
TLinkedList.Init;
new(Head, Init(nil));
new(Tail, Init(nil));
Head^.Next:=Tail;
Head^.Previous:=Head;
Tail^.Next:=Tail;
Tail^.Previous:=Head;
end;

{---Done-----------------------------------------}

destructor TQueue.Done;
begin
while not IsEmpty do
	Delete;
dispose(Head, Done);
dispose(Tail, Done);
TLinkedList.Done;
end;

{---IsEmpty--------------------------------------}

function TQueue.IsEmpty:Boolean;
begin
IsEmpty:=(Head^.Next=Tail);
end;

{---AddAtHead------------------------------------}

procedure TQueue.AddAtHead(ToAdd:PObject);
var NewElement:PDoubleListElement;
begin
new(NewElement);
with NewElement^ do
	begin
	Init(ToAdd);
	Next:=Head^.Next;
	Previous:=Head;
	Next^.Previous:=NewElement;
	Previous^.Next:=NewElement;
	end;
Size:=Size+1;
end;

{---Detach---------------------------------------}

function TQueue.Detach:Pointer;
begin
Detach:=DetachFromTail;
end;

{---DetachFromTail-------------------------------}

function TQueue.DetachFromTail:Pointer;
var Temp:PDoubleListElement;
begin
Temp:=Tail^.Previous;
DetachFromTail:=Temp^.Data;
Temp^.Data:=nil;
Tail^.Previous:=Temp^.Previous;
Temp^.Previous^.Next:=Tail;
if Temp<>Head then
	begin
	dispose(Temp, Done);
	Size:=Size-1;
	end;
end;

{---DeleteFromTail-------------------------------}

procedure TQueue.DeleteFromTail;
var Temp:PObject;
begin
Temp:=DetachFromTail;
if Temp<>nil then
	dispose(Temp, Done);
end;


end.