unit RecpMemo;

interface

uses Classes,FancyMem,Measure,Graphics;

type TRecipeMemo=class(TFancyMemo)
		private
			InInstructions:boolean;
		public
			constructor Create(AOwner:TComponent); override;
			procedure OnBR(Token:string; Args:PChar; Length:longint);
			procedure OnHeading(Token:string; Args:PChar; Length:longint);
			procedure OnIngredient(Token:string; Args:PChar; Length:longint);
			procedure OnInstructions(Token:string; Args:PChar; Length:longint);
			procedure OnEnd(Token:string; Args:PChar; Length:longint);
			procedure NewLine; override;
		end;

procedure Register;

implementation

procedure Register;
begin
RegisterComponents('Additional',[TRecipeMemo]);
end;

constructor TRecipeMemo.Create(AOwner:TComponent);
begin
inherited Create(AOwner);
MethodList.AddMethod('BR',OnBr);
MethodList.AddMethod('Heading',OnHeading);
MethodList.AddMethod('Ingredient',OnIngredient);
MethodList.AddMethod('Instructions',OnInstructions);
MethodList.AddMethod('End',OnEnd);
MethodList.AddMethod('I',OnBr);
InInstructions:=false;
end;

procedure TRecipeMemo.OnHeading;
begin
Indent.Left:=mmToPixels(Canvas,5);
Indent.Top:=mmToPixels(Canvas,5);
Indent.Right:=Indent.Left;
PenPos:=Indent.TopLeft;
Canvas.Font.Name:='Arial';
Canvas.Font.Size:=12;
Canvas.Font.Style:=[fsBold];
end;

procedure TRecipeMemo.OnIngredient;
begin
Indent.Left:=mmToPixels(Canvas,10);
Leading(0);
Canvas.Font.Size:=8;
end;

procedure TRecipeMemo.OnInstructions;
begin
Indent.Left:=mmToPixels(Canvas,5);
Leading(8);
InInstructions:=True;
Canvas.Font.Name:='Times New Roman';
Canvas.Font.Style:=[];
end;

procedure TRecipeMemo.OnEnd;
begin
InInstructions:=false;
end;

procedure TRecipeMemo.OnBR;
begin
NewLine;
if InInstructions then
	PenPos.X:=mmToPixels(Canvas,10);
end;

procedure TRecipeMemo.NewLine;
begin
if InInstructions then
	Indent.Left:=mmToPixels(Canvas,5);
inherited NewLine;
end;

end.
