Unit RegFReg;

interface

uses Windows,SysUtils,Classes,
  Messages, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls,Dsgnintf,RegFiles, Menus,
  ShellAPI, JPRSplit;

type
  TRegEditDlg = class(TForm)
    Panel3: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    Panel2: TPanel;
    StatusBar1: TStatusBar;
    ValuesMenu: TPopupMenu;
    KeysMenu: TPopupMenu;
    Modify1: TMenuItem;
    DeleteValue: TMenuItem;
    Rename1: TMenuItem;
    N1: TMenuItem;
    LargeIcons1: TMenuItem;
    SmallIcons1: TMenuItem;
    List1: TMenuItem;
    Details1: TMenuItem;
    btnApply: TButton;
    New1: TMenuItem;
    key1: TMenuItem;
    DeleteKey: TMenuItem;
    new2: TMenuItem;
    StringValue1: TMenuItem;
    DWORDValue1: TMenuItem;
    N2: TMenuItem;
    StringValue2: TMenuItem;
    DWORDValue2: TMenuItem;
    Expand1: TMenuItem;
    N3: TMenuItem;
    RenameKey: TMenuItem;
    SetKey1: TMenuItem;
    TreeView1: TTreeView;
    Splitter1: TSplitter;
    ListView1: TListView;
    SmallImages: TImageList;
    LargeImages: TImageList;
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure FormCreate(Sender: TObject);
    procedure TreeView1DblClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Modify1Click(Sender: TObject);
    procedure ValuesMenuPopup(Sender: TObject);
    procedure ChangeViewClick(Sender: TObject);
    procedure ListView1Editing(Sender: TObject; Item: TListItem;
      var AllowEdit: Boolean);
    procedure FormShow(Sender: TObject);
    procedure Rename1Click(Sender: TObject);
    procedure btnApplyClick(Sender: TObject);
    procedure RenameKeyClick(Sender: TObject);
    procedure TreeView1Editing(Sender: TObject; Node: TTreeNode;
      var AllowEdit: Boolean);
    procedure TreeView1Edited(Sender: TObject; Node: TTreeNode;  var S: string);

    procedure DeleteKeyClick(Sender: TObject);
    procedure ListView1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure KeysMenuPopup(Sender: TObject);
    procedure Expand1Click(Sender: TObject);
    procedure DeleteValueClick(Sender: TObject);
    procedure key1Click(Sender: TObject);
    procedure StringValue2Click(Sender: TObject);
    procedure DWORDValue2Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure TreeView1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Edit1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure Edit1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure SetKey1Click(Sender: TObject);
    procedure TreeView1Expanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: Boolean);
    procedure NewLVEdited(Sender: TObject; Item: TListItem; var S: string);
  private
    { Private declarations }
    Reg:TRegFile;
    BuildingList:boolean;
    fOnApply:TNotifyEvent;
    OldKeyName:String;
    procedure BuildTree;
    procedure WMGetMinMaxInfo(var Msg:TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
    function BuildKeyString(N:TTreeNode):String;
    function RemoveHead(const AKey:String):string;
    procedure BuildValueList;
    procedure BuildSubList(AKey:String; ParentNode:TTreeNode);
    function FindNode(KeyString:String):TTreeNode;
    function ListValue(V:Variant; IsDefault:boolean):String;
    procedure MakeNewValue(V:Variant);
    procedure ChangeRoot(S:String);
  public
    RootKey:TRootKey;
    Key:String;
    function Execute:boolean;
    property OnApply:TNotifyEvent read fOnApply write fOnApply;
  end;

procedure Register;

implementation

{$R *.DFM} { The TRegEditDlg form }

{$R *.RES} { Contains the bitmaps for the TreeView and ListView }

const
   RootNames:array[TRootKey] of String = (
     'HKEY_CLASSES_ROOT','HKEY_CURRENT_USER','HKEY_LOCAL_MACHINE',
     'HKEY_USERS','HKEY_CURRENT_CONFIG','HKEY_DYN_DATA');

   DefaultLit = '(Default)';

type
  TRegFileEditor = class(TComponentEditor)
    RED:TRegEditDlg;
    MyVerb:integer;
    procedure ApplyProc(Sender:TObject);
    procedure ExecuteVerb(Index:integer); override;
    function GetVerbCount:integer; override;
    function GetVerb(Index:integer):String; override;
    procedure Edit; override;
    end;

procedure TRegFileEditor.ExecuteVerb(Index:integer);
begin
  if Index = MyVerb then Edit else inherited ExecuteVerb(Index);
end;

function TRegFileEditor.GetVerbCount:integer;
begin
  MyVerb := inherited GetVerbCount;
  Result := MyVerb+1;
end;

function TRegFileEditor.GetVerb(Index:integer):String;
begin
  if Index = MyVerb then
     Result := 'Key Editor...';
end;

procedure TRegFileEditor.ApplyProc(Sender:TObject);
begin
 With Component as TRegFile do
    begin
    Key := RED.Key;
    RootKey := RED.RootKey;
    Designer.Modified;
    end;
end;

procedure TRegFileEditor.Edit;
begin
  RED := TRegEditDlg.Create(Application);
  try
    With Component as TRegFile do
      begin
      RED.Caption := 'Registry Editor for '+Component.Name;
      RED.RootKey := RootKey;
      RED.Key := Key;
      RED.OnApply := ApplyProc;
      if RED.Execute then
         begin
         Key := RED.Key;
         RootKey := RED.RootKey;
         Designer.Modified;
         end;
      end;
  finally
    RED.Free;
    end;
end;

type
  TRegFilePropEditor = class(TStringProperty)
     RED:TRegEditDlg;
     procedure ApplyProc(Sender:TObject);
     function GetAttributes:TPropertyAttributes; override;
     procedure Edit; override;
     end;

procedure TRegFilePropEditor.ApplyProc(Sender:TObject);
var
  i : integer;
begin
 for i := 0 to PropCount-1 do
 With GetComponent(i) as TRegFile do
    begin
    Key := RED.Key;
    RootKey := RED.RootKey;
    end;
 Designer.Modified;
end;

function TRegFilePropEditor.GetAttributes:TPropertyAttributes;
begin
  Result := [paDialog,paMultiSelect];
end;

procedure TRegFilePropEditor.Edit;
begin
  RED := TRegEditDlg.Create(Application);
  try
   if PropCount > 1 then
      begin
      RED.Caption := 'Registry Editor';
      RED.RootKey := hkCurrentUser;
      RED.Key := '';
      end
   else
      With GetComponent(0) as TRegFile do begin
      RED.Caption := 'Registry Editor for '+Name;
      RED.RootKey := RootKey;
      RED.Key := Key;
      end;
   RED.OnApply := ApplyProc;
   if RED.Execute then ApplyProc(Self);
  finally
    RED.Free;
    end;
end;

procedure Register;
begin
  RegisterComponents('Win95',[TRegFile,TSplitter]);
  RegisterComponentEditor(TRegFile,TRegFileEditor);
  RegisterPropertyEditor(TypeInfo(String),TRegFile,'Key',TRegFilePropEditor);
end;

function TRegEditDlg.Execute:boolean;
var
  i : integer;
  SaveRootKey:TRootKey;
begin
   Edit1.Text := Key;
   SaveRootKey := RootKey;
   Result  := ShowModal=mrOK;
   if Result then
      begin
      Key := Edit1.Text;
      end
   else
      RootKey := SaveRootKey;
end;

const
 itBitmap: TResType = Controls.rtBitmap;

procedure TRegEditDlg.FormCreate(Sender: TObject);
var
  Icon:TIcon;
begin
   Reg := TRegFile.Create(Self);
   SmallImages.ResourceLoad(itBitmap,'REGFILES_BITMAPS_SMALL',clOlive);
   Icon := TIcon.Create;
   Icon.Handle := ExtractIcon(hInstance,'EXPLORER.exe',0);
   TreeView1.Images.AddIcon(Icon);
   Icon.Free;
   LargeImages.ResourceLoad(itBitmap,'REGFILES_BITMAPS_LARGE',clOlive);
end;

procedure TRegEditDlg.WMGetMinMaxInfo(var Msg:TWMGetMinMaxInfo);
begin
  With Msg.MinMaxInfo^.ptMinTrackSize do begin
     X := 439;
     Y := 265;
     end;
  inherited;
end;

function GetComputerName:String;
var
  R:TRegFile;
begin
  Result := 'My Computer';
  R := TRegFile.Create(nil);
  try
    R.RootKey := hkLocalMachine;
    Result := R.ValueDefault['System\CurrentControlSet\control\ComputerName\ComputerName\ComputerName','My Computer'];
  finally
    R.Free;
    end;

end;

procedure TRegEditDlg.BuildSubList(AKey:String; ParentNode:TTreeNode);
var
  SubList:TStringList;
  i : integer;
  NewNode:TTreeNode;
begin
  SubList := TStringList.Create;
  SubList.Sorted := true;
  Reg.Key := AKey;
  Screen.Cursor := crHourglass;
  try
    Reg.GetSubKeys('',SubList);
    for i := 0 to SubList.Count-1 do begin
      NewNode := TreeView1.Items.AddChild(ParentNode,SubList[i]);
      NewNode.ImageIndex := 2;
      NewNode.SelectedIndex := 3;
      NewNode.HasChildren := Reg.HasSubKey(SubList[i]);
      end;
  finally
    Screen.Cursor := crDefault;
    Reg.Key := '';
    SubList.Free;
    end;
end;

procedure TRegEditDlg.BuildTree;
var
  TheRoot,TheBase:TTreeNode;
  RK : TRootKey;
begin
  TreeView1.Items.Clear;
  ListView1.Items.Clear;
  Screen.Cursor := crHourglass;
  try
    TheRoot := TreeView1.Items.AddChild(nil,GetComputerName);
    TheRoot.ImageIndex := 4;
    TheRoot.SelectedIndex := 4;
    for RK := Low(TRootKey) to High(TRootKey) do begin
       Reg.RootKey := RK;
       Reg.Key := '';
       TheBase := TreeView1.Items.AddChild(TheRoot,RootNames[Reg.RootKey]);
       TheBase.ImageIndex := 2;
       TheBase.SelectedIndex := 3;
       TheBase.HasChildren := Reg.HasSubKey('');
       end;
    TheRoot.Expanded := true;
    Reg.RootKey := RootKey;
    if Key<>'' then
       TheBase := FindNode(RootNames[RootKey]+'\'+Key);
    if (TheBase=nil) or (Key='') then
       TheBase := FindNode(RootNames[RootKey]);
    TheBase.MakeVisible;
    TreeView1.Selected := TheBase;
  finally
    StatusBar1.SimpleText := BuildKeyString(TheBase);
    Screen.Cursor := crDefault;
    end;
end;

function TRegEditDlg.BuildKeyString(N:TTreeNode):String;
begin
  Result := N.Text;
  While N.Parent <> nil do begin
     N := N.Parent;
     Result := N.Text+'\'+Result;
     end;
end;

function ExpandSlashes(S:String):String;
var
  i : integer;
begin
  Result := '';
  for i := 1 to Length(S) do
     begin
     Result := Result+S[i];
     if S[i] = '\' then
        Result := Result+'\';
     end;
end;

function TRegEditDlg.ListValue(V:Variant; IsDefault:boolean):String;
begin
  if VarIsEmpty(V) then
     Result := '(non-displayable data)'
  else if VarIsNull(V) or
     ((VarType(V) = varString) and (IsDefault) and (V='')) then
    Result := '(value not set)'
  else
    if VarType(V)=varString then
       Result := '"'+V+'"'
    else
       Result := V;
end;

procedure TRegEditDlg.BuildValueList;
var
  OldKey:String;
  VList : TStringList;
  i : integer;

  procedure AddAValue(TheValue:String);
  var
    LI : TListItem;
    V : Variant;
  begin
    LI := ListView1.Items.Add;
    if TheValue = '' then
       LI.Caption := DefaultLit
    else
       LI.Caption := TheValue;
      V := Reg.Value[ExpandSlashes(TheValue)];
      LI.Data := Pointer(VarType(V));
      if VarType(V) = varString then
         LI.ImageIndex := 1
      else
         LI.ImageIndex := 0;

      LI.SubItems.Add(ListValue(V,TheValue=''));

  end;

begin
   OldKey := Reg.Key;
   VList := TStringList.Create;
   VList.Sorted := true;
   BuildingList := true;
   try
     Reg.Key := RemoveHead(StatusBar1.SimpleText);
     Reg.GetValueNames('',VList);
     ListView1.Items.Clear;
     AddAValue('');
     for i := 0 to VList.Count-1 do
        if VList[i] <> '' then
           AddAValue(VList[i]);
   finally
     Reg.Key := OldKey;
     VList.Free;
     BuildingList := false;
     end;
end;

procedure TRegEditDlg.ChangeRoot(S:String);
var
  i:integer;
  RK:TRootKey;
begin
  i := Pos('\',S);
  if i = 0 then exit;
  Delete(S,1,i);
  i := Pos('\',S);
  if i = 0 then i := Length(S)+1;
  S := Copy(S,1,i-1);
  for RK := Low(TRootKey) to High(TRootKey) do
     if S=RootNames[RK] then
        begin
        Reg.RootKey := RK;
        RootKey := RK;
        exit;
        end;
end;

procedure TRegEditDlg.TreeView1Change(Sender: TObject; Node: TTreeNode);
begin
   StatusBar1.SimpleText := BuildKeyString(Node);
   ChangeRoot(StatusBar1.SimpleText);
   if Node.Parent = nil then
      ListView1.Items.Clear
   else
      BuildValueList;
end;

function TRegEditDlg.RemoveHead(const AKey:String):string;
var
  i : integer;
begin
   Result := AKey;
   i := Pos('\',Result);
   if i = 0 then
      begin
      Result := '';
      exit;
      end;
   System.Delete(Result,1,i);
   i := Pos('\',Result);
   if i = 0 then i := Length(Result);
   System.Delete(Result,1,i);
end;


procedure TRegEditDlg.TreeView1DblClick(Sender: TObject);
begin
  Edit1.Text := RemoveHead(BuildKeyString(TreeView1.Selected));
end;


procedure TRegEditDlg.FormResize(Sender: TObject);
begin
  Edit1.Width := Panel3.Width-16
end;

procedure TRegEditDlg.Modify1Click(Sender: TObject);
var
  LI : TListItem;
  OldVal,NewVal:Variant;
  Temp:String;
begin
  LI := ListView1.Selected;
  if LI = nil then exit;
  Reg.Key := RemoveHead(StatusBar1.SimpleText);
  try
    if LI.Index = 0 then
       OldVal := Reg['']
    else
       OldVal := Reg[LI.Caption];
    if (integer(LI.Data) = varEmpty) then exit;
    if (integer(LI.Data) = varEmpty) or
       (integer(LI.Data) = varNull) then
       Temp := ''
    else
       Temp := OldVal;
    if InputQuery('Modify Value','New value for '+LI.Caption+':',Temp) then
       try
         OldVal := Temp;
         if (integer(LI.Data) = varEmpty) or
            (integer(LI.Data) = varNull) then
            NewVal := OldVal
         else
            NewVal := VarAsType(OldVal,integer(LI.Data));
         if LI.Index = 0 then
            Reg[''] := NewVal
         else
            Reg[LI.Caption] := NewVal;
         LI.SubItems[0] := ListValue(NewVal,LI.Index=0);
         LI.Update;
       except
         on EVariantError do
            MessageDlg('Invalid data for this Value type',mtInformation,[mbOK],0);
         end;
  finally
    Reg.Key := '';
    end;
end;

procedure TRegEditDlg.ValuesMenuPopup(Sender: TObject);
var
  LI : TListItem;
begin
  LI := ListView1.Selected;
  if LI = nil then
     begin
     Rename1.Enabled := false;
     DeleteValue.Enabled := false;
     Modify1.Enabled := false;
     end
  else
     begin
     Rename1.Enabled := LI.Index <> 0;
     DeleteValue.Enabled := LI.Index <> 0;
     Modify1.Enabled := longint(LI.Data) <> varEmpty;
     end;
end;

procedure TRegEditDlg.ChangeViewClick(Sender: TObject);
begin
  With Sender as TMenuItem do begin
     ListView1.ViewStyle := TViewStyle(Tag);
     Checked := true;
     end;
end;

procedure TRegEditDlg.ListView1Editing(Sender: TObject; Item: TListItem;
  var AllowEdit: Boolean);
begin
  AllowEdit := Item.Index <> 0;
end;

procedure TRegEditDlg.FormShow(Sender: TObject);
begin
  BuildTree;
end;


procedure TRegEditDlg.Rename1Click(Sender: TObject);
begin
   ListView1.Selected.EditCaption;
end;

procedure TRegEditDlg.btnApplyClick(Sender: TObject);
begin
  if Assigned(fOnApply) then
     begin
     Key := Edit1.Text;
     fOnApply(Self);
     end;
end;

procedure TRegEditDlg.RenameKeyClick(Sender: TObject);
begin
  TreeView1.Selected.EditText;
end;



procedure TRegEditDlg.DeleteKeyClick(Sender: TObject);
var
  ThisKey:string;
begin
   ThisKey := RemoveHead(Statusbar1.SimpleText);
   if MessageDlg('Delete '+ThisKey+'?',mtConfirmation,[mbYes,mbNo],0) = idYes then
      begin
      Reg.DeleteKey(ThisKey);
      TreeView1.Selected.Delete;
      end;
end;

procedure TRegEditDlg.ListView1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   if Button=mbRight then ValuesMenu.Popup(X,Y);
end;

procedure TRegEditDlg.KeysMenuPopup(Sender: TObject);
var
  TN:TTreeNode;
begin
  TN := TreeView1.Selected;
  if TN<>nil then
     begin
     RenameKey.Visible := TN.Parent <> nil;
     DeleteKey.Visible := TN.Parent <> nil;
     SetKey1.Visible := TN.Parent <> nil;
     New1.Visible := TN.Parent <> nil;
     N3.Visible := TN.Parent <> nil;
     Expand1.Enabled := TN.HasChildren;
     if TN.Expanded then
        Expand1.Caption := '&Collapse'
     else
        Expand1.Caption := '&Expand';
     RenameKey.Enabled := (TN.Parent <> nil)  and (TN.Parent.Parent <> nil);
     DeleteKey.Enabled := RenameKey.Enabled;
     end
  else
     raise EAbort.Create('nothing to Pop');
end;

procedure TRegEditDlg.Expand1Click(Sender: TObject);
begin
  if TreeView1.Selected <> nil then
     TreeView1.Selected.Expanded := not TreeView1.Selected.Expanded;
end;

function TRegEditDlg.FindNode(KeyString:String):TTreeNode;
{ expects a KeyString that starts with one of the "HKEY_" constants }
var
  TgtNode:TTreeNode;

  function FindSubNode(ParentNode:TTreeNode; Value:String):TTreeNode;
  var
    V:boolean;
  begin
    TreeView1Expanding(nil,ParentNode,V);
    Result := ParentNode.GetFirstChild;
    While Result <> nil do
       begin
       if UpperCase(Value)=Uppercase(Result.Text) then exit;
       Result := ParentNode.GetNextChild(Result);
       end;
  end;

  function ParseKey:String;
  var
    i : integer;
  begin
    i := Pos('\',KeyString);
    if i = 0 then i := Length(KeyString)+1;
    Result := Copy(KeyString,1,i-1);
    System.Delete(KeyString,1,i);
  end;

begin
  Result := TreeView1.Items.GetFirstNode;
  if Result = nil then exit;
  While KeyString <> '' do
     begin
     TgtNode := FindSubNode(Result,ParseKey);
     if TgtNode = nil then exit;
     Result := TgtNode;
     end;
end;

procedure TRegEditDlg.DeleteValueClick(Sender: TObject);
var
  ThisValue:string;

begin
   ThisValue := ListView1.Selected.Caption;
   Reg.Key := RemoveHead(Statusbar1.SimpleText);
   try
   if MessageDlg('Delete '+ThisValue+'?',mtConfirmation,[mbYes,mbNo],0) = idYes then
      begin
      Reg.DeleteValue('',ThisValue);
      ListView1.Selected.Delete;
      end;
   finally
     Reg.Key := '';
     end;
end;

procedure TRegEditDlg.key1Click(Sender: TObject);
var
  ThisParent,ParentNode : TTreeNode;

  function FindNewKey:string;
  var
    BaseKey: string;
    i : integer;
  begin
     BaseKey := RemoveHead(StatusBar1.SimpleText);
     i := 1;
     try
     repeat
       Result := 'New Key #'+IntToStr(i);
       Inc(i);
       Reg.Key := BaseKey;
     until not Reg.KeyExists(Result)
     finally
       Reg.Key := '';
       end;
  end;

begin
   ParentNode := TreeView1.Selected;
   ThisParent := TreeView1.Items.AddChild(ParentNode,FindNewKey);
   ThisParent.ImageIndex := 2;
   ThisParent.SelectedIndex := 3;
   TreeView1.Selected := ThisParent;
   ThisParent.EditText;
end;


procedure TRegEditDlg.MakeNewValue(V:Variant);
var
  LI : TListItem;
  function FindNewValue:string;
  var
    BaseKey : string;
    i : integer;
  begin
     Reg.Key := '';
     BaseKey := RemoveHead(StatusBar1.SimpleText);
     i := 1;
     repeat
       Result := 'New Value #'+IntToStr(i);
       Inc(i);
     until not Reg.ValueExists(BaseKey,Result);
     Reg[BaseKey+'\'+Result] := V;
  end;

begin
    LI := ListView1.Items.Add;
    LI.Caption := FindNewValue;
    LI.Data := Pointer(VarType(V));
    if VarType(V) = varString then
       LI.ImageIndex := 1
    else
       LI.ImageIndex := 0;
    LI.SubItems.Add(ListValue(V,false));
    ListView1.SetFocus;
    ListView1.Selected := LI;
    LI.EditCaption;
end;

procedure TRegEditDlg.StringValue2Click(Sender: TObject);
begin
  MakeNewValue('');
end;

procedure TRegEditDlg.DWORDValue2Click(Sender: TObject);
begin
  MakeNewValue(0);
end;

procedure TRegEditDlg.Button2Click(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TRegEditDlg.TreeView1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Node:TTreeNode;
begin
  if Button = mbLeft then
     begin
     Node := TreeView1.GetNodeAt(X,Y);
     if Node.Parent <> nil then
        if Node=TreeView1.Selected then
           TreeView1.BeginDrag(false);
     end
  else if Button = mbRight then
     begin
     Node := TreeView1.GetNodeAt(X,Y);
     if Node <> nil then
        begin
        TreeView1.Selected := Node;
        TreeView1.Update;
        end;
     end;
end;

procedure TRegEditDlg.Edit1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
   Accept := Source is TCustomTreeView;
end;

procedure TRegEditDlg.Edit1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
  Edit1.Text := RemoveHead(StatusBar1.SimpleText);
end;

procedure TRegEditDlg.SetKey1Click(Sender: TObject);
begin
   TreeView1DblClick(Sender);
end;

procedure TRegEditDlg.TreeView1Expanding(Sender: TObject; Node: TTreeNode;
  var AllowExpansion: Boolean);
var
  FullKey,TheKey : string;
  SaveRoot:TRootKey;
begin
  FullKey := BuildKeyString(Node);
  TheKey := RemoveHead(FullKey);
  SaveRoot := Reg.RootKey;
  ChangeRoot(FullKey);
  if Node.HasChildren and (Node.GetFirstChild = nil) then
     BuildSubList(TheKey,Node);
  Reg.RootKey := SaveRoot;
  AllowExpansion := true;
end;

procedure TRegEditDlg.TreeView1Editing(Sender: TObject; Node: TTreeNode;
  var AllowEdit: Boolean);
begin
   AllowEdit := (not TreeView1.Dragging) and (Node.Parent <> nil)  and (Node.Parent.Parent <> nil);
   OldKeyName := BuildKeyString(Node)
end;

procedure TRegEditDlg.TreeView1Edited(Sender: TObject; Node: TTreeNode;
  var S: string);
var
  NewKeyName:String;
begin
  NewKeyName := BuildKeyString(Node);
  Reg.RenameKey(RemoveHead(OldKeyName),RemoveHead(NewKeyName));
  StatusBar1.SimpleText := NewKeyName;
end;

procedure TRegEditDlg.NewLVEdited(Sender: TObject; Item: TListItem;
  var S: string);
begin
  if not Reg.RenameValue(RemoveHead(StatusBar1.SimpleText),ListView1.Selected.Caption,S) then
     begin
     ShowMessage('Unable to Rename value');
     S := ListView1.Selected.Caption;
     end;
end;

end.

