(*

   Abstract Reference Resolver Class
   by Glen Why

*)


unit ReferenceResolver;

interface
uses SysUtils, Classes;

type

  EUnresolvedReference = class( Exception );

  TReferenceResolver = class
  public
    function Resolve( const ObjectName :String ) :TObject; virtual; abstract;
  end;

function ResolveReference( ObjCls :TClass; const Name :String;
 Resolver :TReferenceResolver ) :Pointer;

implementation

function ResolveReference( ObjCls :TClass; const Name :String;
 Resolver :TReferenceResolver ) :Pointer;
begin
  result := Resolver.Resolve( Name );
  if result = nil then raise EUnresolvedReference.CreateFmt(
    'Could not resolve reference to object of class %s named %s', 
    [ ObjCls.ClassName, Name ] );
end;


end.
