{********************************************************************
 *  Sample form for TGradientCaption component.                     *
 *                                                                  *
 *  See the overrided WndProc method for implementing this          *
 *  component in your application.                                  *
 *                                                                  *
 ********************************************************************}



unit SampleFM;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Registry,
  GradCapt, StdCtrls;

type
  TLoadColorsMode = (lmActive, lmInactive);

  TGradientCaptionFM = class(TForm)
    GradientCaption1: TGradientCaption;
    Button1: TButton;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    GroupBox2: TGroupBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    Label1: TLabel;
    Edit1: TEdit;
    Button2: TButton;
    ColorDialog1: TColorDialog;
    procedure Button1Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox1KeyPress(Sender: TObject; var Key: Char);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  protected
    { Protected declarations }
    procedure WndProc(var Message: TMessage); override;
  public
    { Public declarations }
  end;

var
  GradientCaptionFM: TGradientCaptionFM;

implementation

{$R *.DFM}

procedure TGradientCaptionFM.WndProc(var Message: TMessage);
var PM: TMessage;
begin
  with Message do begin
    if Msg = WM_GETMINMAXINFO then begin
      TWMGetMinMaxInfo(Message).MinMaxInfo.ptMinTrackSize.X := 440;
      TWMGetMinMaxInfo(Message).MinMaxInfo.ptMinTrackSize.Y := 296;
      inherited WndProc(Message);
    end else begin
      PM := Message;
      inherited WndProc(Message);
      if (Msg = WM_NCPAINT)  or (Msg = WM_ACTIVATE) or (Msg = WM_NCACTIVATE)
      then begin
        GradientCaption1.DoMessage(PM);
      end;
    end;
  end;
end;

procedure TGradientCaptionFM.Button1Click(Sender: TObject);
begin
  if ColorDialog1.Execute then
    GradientCaption1.GradientColor := ColorDialog1.Color;
end;

procedure TGradientCaptionFM.Edit1Change(Sender: TObject);
begin
  GradientCaption1.ProductCaption := Edit1.Text;
end;

procedure TGradientCaptionFM.FormCreate(Sender: TObject);
begin
  Edit1.Text := GradientCaption1.ProductCaption;
end;

procedure TGradientCaptionFM.CheckBox1Click(Sender: TObject);
var FS : TFontStyles;
begin
  FS := [];
  if CheckBox1.Checked then FS := FS + [fsBold];
  if CheckBox2.Checked then FS := FS + [fsItalic];
  if CheckBox3.Checked then FS := FS + [fsUnderline];
  if CheckBox4.Checked then FS := FS + [fsStrikeOut];
  GradientCaption1.ProductCaptionFontStyle := FS;

  FS := [];
  if CheckBox5.Checked then FS := FS + [fsBold];
  if CheckBox6.Checked then FS := FS + [fsItalic];
  if CheckBox7.Checked then FS := FS + [fsUnderline];
  if CheckBox8.Checked then FS := FS + [fsStrikeOut];
  GradientCaption1.CaptionFontStyle := FS;
end;

procedure TGradientCaptionFM.CheckBox1KeyPress(Sender: TObject;
  var Key: Char);
begin
  CheckBox1Click(Sender);
end;

procedure TGradientCaptionFM.Button2Click(Sender: TObject);
begin
  Close;
end;

end.
