unit SQL32;

{ 
  See 16 bit for more detailed comments, functions are just about the same.
  Ed Lyk
  1997-08-27
}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, mssql32;

type
  TForm1 = class(TForm)
    BTN_Connect: TButton;
    BTN_Query: TButton;
    ListBox1: TListBox;
    Label1: TLabel;
    procedure BTN_ConnectClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BTN_QueryClick(Sender: TObject);
  private
    { Private declarations }
    login: LOGINREC;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;


implementation

{$R *.DFM}

procedure TForm1.BTN_ConnectClick(Sender: TObject);
var
  szVer: PChar;
  dbproc:  DBPROCESS;
  ret: Integer;
  MyKey: Integer;
begin

  szVer := dbinit;
  MessageBox(Handle, szVer, 'Opened', mb_ok);

  login := dblogin;

  ret := dbsetlname(login, 'sa', DBSETUSER);
  if ret = DBFAIL then
    begin
    MessageDlg('set user failed', mtError, [mbOk], 0);
    dbfreelogin(login);
    Exit;
    end;

  ret := dbsetlname(login, 'xyzzy', DBSETPWD);
  if ret = DBFAIL then
    MessageDlg('set password failed', mtError, [mbOk], 0);

  ret := dbsetlname(login, 'TestApp', DBSETAPP);
  if ret = DBFAIL then
    MessageDlg('set application failed', mtError, [mbOk], 0);

  dbproc := dbopen(login, 'DEV-SERVER');

  if dbproc <> nil then
    begin
    dbcmd(dbproc, 'SELECT * FROM DIVBRAZ.DBO.KEYID');
    dbsqlexec(dbproc);
    if dbresults(dbproc) = DBSUCCEED then
      begin
      ret := dbbind(dbproc, 1, INTBIND, 0, @MyKey);
      if ret = DBFAIL then
        MessageDlg('int bind failed', mtError, [mbOk], 0)
      else
        begin
        while dbnextrow(dbproc) <> NO_MORE_ROWS do
          MessageDlg('Keyid from table is: ' + IntToStr(MyKey), mtInformation, [mbOk], 0);

        end;
      end;
    dbclose(dbproc);
    end;

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  dbexit;
end;

procedure TForm1.BTN_QueryClick(Sender: TObject);
var
  sTemp: String;
  szName, szBaseNo: PChar;
  dbproc:  DBPROCESS;
  ret: Integer;
  t: TDateTime;
  wHour, wMinute, wSec, wMSec: Word;
begin

  ListBox1.Items.Clear;

  {create connection to server}
  dbproc := dbopen(login, 'DEV-SERVER');

  if dbproc <> nil then
    begin

    t := Time;

    {set sql statement}
    dbcmd(dbproc, 'SELECT CLIENT_NAME, CLIENT_BASE_NUMBER FROM DIVBRAZ.DBO.CLIENTS');
    {execute sql}
    dbsqlexec(dbproc);
    {check for results}
    if dbresults(dbproc) = DBSUCCEED then
      begin

      szName := StrAlloc(255);
      szBaseNo := StrAlloc(255);

      {get each row of the result set}
      while dbnextrow(dbproc) = REG_ROW do
        begin
        {get data from each column...
         note: strings are not null terminated, thus you must use
               StrLCopy and use dbdatlen to get the actual length
               of the string}

        ret := dbdatlen(dbproc,1);
        StrLCopy(szName, dbdata(dbproc, 1), ret);
        ret := dbdatlen(dbproc, 2);
        StrLCopy(szBaseNo, dbdata(dbproc, 2), ret);
        sTemp := strPas(szBaseNo) + ' : ' + strPas(szName);
        ListBox1.Items.Add(sTemp);
        end;

      StrDispose(szName);
      strDispose(szBaseNo);
      
      end;

    {close the connection}
    dbclose(dbproc);

    t := Time - t;

    end;

  DecodeTime(t, wHour, wMinute, wSec, wMSec);
  Label1.Caption := 'Rows loaded: ' + IntToStr(ListBox1.Items.Count) + '  Time: ' +
  Format('%.2d:%.2d:%.2d.%d', [wHour, wMinute, wSec, wMSec]);

end;

end.
