unit Stack;

interface

uses Objects, ListElem, LinkList;


{------------- TStack ---------------------------
								Init
								Done
								IsEmpty
								PeekAtHead
								AddAtHead
								DetachFromHead}
{------------------------------------------------}


type	PStack=^TStack;
			TStack=object(TLinkedList)
				Head,Tail:PListElement;
				constructor Init;
				destructor Done; virtual;
				function IsEmpty:Boolean; virtual;
				function PeekAtHead:PObject; virtual;
				procedure AddAtHead(ToAdd:PObject); virtual;
				function DetachFromHead:Pointer; virtual;
				end;

implementation


{-----------------------------------------------}
{------------------ TStack----------------------}
{--Init-----------------------------------------}

constructor TStack.Init;
begin
TLinkedList.Init;
New(Head, Init(nil));
New(Tail, Init(nil));
Head^.Next:=Tail;
Tail^.Next:=Tail;
end;

{--Done-----------------------------------------}

destructor TStack.Done;
begin
while Head^.Next<>Tail do
	DeleteFromHead;
dispose(Head, Done);
dispose(Tail, Done);
TLinkedList.Done;
end;

{--IsEmpty--------------------------------------}

function TStack.IsEmpty:Boolean;
begin
IsEmpty:=(Head^.Next=Tail);
end;

{--PeekAtHead-----------------------------------}

function TStack.PeekAtHead:PObject;
begin
PeekAtHead:=Head^.Next^.Data;
end;

{--AddAtHead------------------------------------}

procedure TStack.AddAtHead(ToAdd:PObject);
var PNewListElement:PListElement;
begin
new(PNewListElement, Init(ToAdd));
PNewListElement^.Next:=Head^.Next;
Head^.Next:=PNewListElement;
Size:=Size+1;
end;

{--DetachFromHead-------------------------------}

function TStack.DetachFromHead:Pointer;
var Temp:PListElement;
begin
Temp:=Head^.Next;
DetachFromHead:=Temp^.Data;
Temp^.Data:=nil;
Head^.Next:=Temp^.Next;
if Temp<>Tail then
	begin
	dispose(Temp, Done);
	Size:=Size-1;
	end;
end;



end.

