unit Unit4;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, ExtGrid, OCIH, ODI, OCL, ExtCtrls, StdCtrls;

type
  TForm4 = class(TForm)
    Panel1: TPanel;
    OEGrid1: TOEGrid;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    function OEGrid1Update(Sender: TObject; DefaultMsg: string): Boolean;
    function OEGrid1Delete(Sender: TObject; DefaultMsg: string): Boolean;
    procedure OEGrid1UpdateFailed(Sender: TObject; Row: Longint;
      ResultRowStatus, GridRowStatus: Word; DefaultMsg: string);
    procedure OEGrid1DeleteFailed(Sender: TObject; Row: Longint;
      ResultRowStatus, GridRowStatus: Word; DefaultMsg: string);
  private
    { Private declarations }
    FUpdateFlag: Word;
    FDeleteFlag: Word;
  public
    { Public declarations }
  end;

var
  Form4: TForm4;

implementation

{$R *.DFM}

uses
  OETree;


procedure TForm4.FormShow(Sender: TObject);
begin
  FUpdateFlag:= mrCancel;
  FDeleteFlag:= mrCancel;

  try
    OEGrid1.SQL:= 'SELECT SNo, SName, SGender, SGender, SBirth FROM Students';
    OEGrid1.Populate;
  except
    on ODBCError do
      Tree.Henv1.Error.Display;
  end;
end;

procedure TForm4.Button1Click(Sender: TObject);
begin
  try
    FUpdateFlag:= MessageDLG('Apply updates made to rows?', mtInformation,
      [mbYes, mbNo, mbCancel], 0);
    if FUpdateFlag <> mrCancel then
      OEGrid1.DoUpdate;
  except
    on ODBCError do
      Tree.Henv1.Error.Display;
  end;
end;

procedure TForm4.Button2Click(Sender: TObject);
begin
  try
    FDeleteFlag:= MessageDLG('Apply deletes made to rows?', mtInformation,
      [mbYes, mbNo, mbCancel], 0);
    if FDeleteFlag <> mrCancel then
      OEGrid1.DoDelete;
  except
    on ODBCError do
      Tree.Henv1.Error.Display;
  end;
end;

procedure TForm4.Button3Click(Sender: TObject);
begin
  try
    OEGrid1.DoRefresh;
  except
    on ODBCError do
      Tree.Henv1.Error.Display;
  end;
end;

function TForm4.OEGrid1Update(Sender: TObject;
  DefaultMsg: string): Boolean;
begin
  if FUpdateFlag = mrCancel then
    Result:= MessageDLG(DefaultMsg, mtInformation, [mbYes, mbNo], 0) = mrYes
  else
    Result:= FUpdateFlag = mrYes;
  FUpdateFlag:= mrCancel;
end;

function TForm4.OEGrid1Delete(Sender: TObject;
  DefaultMsg: string): Boolean;
begin
  if FDeleteFlag = mrCancel then
    Result:= MessageDLG(DefaultMsg, mtInformation, [mbYes, mbNo], 0) = mrYes
  else
    Result:= FDeleteFlag = mrYes;
  FDeleteFlag:= mrCancel;
end;

procedure TForm4.OEGrid1UpdateFailed(Sender: TObject; Row: Longint;
  ResultRowStatus, GridRowStatus: Word; DefaultMsg: string);
begin
  MessageDLG(DefaultMsg, mtError, [mbOK], 0);
end;

procedure TForm4.OEGrid1DeleteFailed(Sender: TObject; Row: Longint;
  ResultRowStatus, GridRowStatus: Word; DefaultMsg: string);
begin
  MessageDLG(DefaultMsg, mtError, [mbOK], 0);
end;

end.

