unit USAppBar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,ShellApi;

const WM_Appbar = WM_USER+23;
      id_UnhideTimer = 2906 ;
      id_HideTimer   = 2907 ;

type

  TEdge = (abeLeft,abeTop,abeRight,abeBottom);

  TUSAppBar = class(TComponent)
  private
    { Private declarations }
   FABOldStyle,FABOldStyleEx,FABZOrder,FABTimerID:Integer;
   FABOwner:TForm;
   FABHandle:THandle;
   FABData:TAppBarData;
   FABReg,FABMoving,FABHidden:Boolean;
   FABWide,FABEdge:Integer;
   FABActive,FABSliding,FABAutoHide,FABAlwaysOnTop:Boolean;
   FABOldRect,FABRect:TRect;
   procedure SlideWindow (hwnd:Integer;np:TRect;slide:boolean);

   procedure AB_Register; //Registriert
   procedure AB_Remove;   //Entfernt AppBar aus dem System
   procedure AB_CB (var msg:TMessage);

   procedure AB_Hide;
   procedure AB_Unhide;

   procedure AB_CalcRect (wide:Integer;var R:TRect);
   procedure AB_CheckPos (wide:Integer;var R:Trect);
   procedure AB_SetABPos;
   procedure AB_SetWndPos;

   procedure AB_SetActive;

   procedure AB_NoAutoHide;
   procedure AB_AutoHide;
   procedure AB_SetAutoHide;
   procedure AB_SetAlwaysOnTop (aAlwaysOnTop:Boolean);
  protected
    { Protected declarations }
    FOnChangeEdge:TNotifyEvent;
    OldWndProc : TFarProc;
    NewWndProc : Pointer;
    procedure SetEdge (aEdge:TEdge);
    function  GetEdge:TEdge;
    procedure SetWide (aWide:Integer);
    procedure SetAutoHide (aAutoHide:Boolean);
    procedure SetAlwaysOnTop (aAlwaysOnTop:Boolean);
    procedure SetActive (aActive:Boolean);

    procedure HookWin;
    procedure UnhookWin;
    function Design:Boolean; //Noch ersetzen
    procedure HookWndProc(var Message: TMessage);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent);  override;
    destructor  Destroy; override;
  published
    { Published declarations }
    property Active:boolean read FABActive write SetActive;
    property Wide:Integer read FABWide write SetWide;
    property Edge:TEdge read GetEdge write SetEdge;
    property Autohide:boolean read FABAutohide write SetAutohide;
    property AlwaysOnTop:boolean read FABAlwaysOnTop write SetAlwaysOnTop;
    property Sliding:boolean read FABSliding write FABSliding;
    property Registerd:Boolean Read FABReg;
    property OnChangeEdge:TNotifyEvent read FOnChangeEdge write FOnChangeEdge;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Win95', [TUSAppBar]);
end;

function TUSAppBar.Design:Boolean;
BEGIN
result:=csDesigning in ComponentState;
END;

procedure TUSAppBar.SlideWindow(hwnd:Integer;np:TRect;slide:Boolean);
var OldPos:TRect;
    priority,x,y,dx,dy,dt,t,t0:Integer;
    fShow:Boolean;
    hThreadMe:Integer;
const g_dtSlideHide = 400;
const g_dtSlideShow = 400;

begin
 IF slide THEN
  BEGIN
 GetWindowRect(hwnd, OldPos);

 fShow:=((np.bottom - np.top)>(OldPos.bottom - OldPos.top)) or
 	((np.right - np.left) > (OldPos.right - OldPos.left));
 dx := (np.right - oldpos.right) + (np.left - oldpos.left);
 dy := (np.bottom - oldpos.bottom) + (np.top - oldpos.top);
if (fShow) THEN
 BEGIN
  OldPos:=np;
  OffsetRect(OldPos, -dx, -dy);
  SetWindowPos(hwnd,0,OldPos.left,OldPos.top,
     OldPos.right - OldPos.left, OldPos.bottom - OldPos.top,
     SWP_NOZORDER OR SWP_NOACTIVATE {OR SWP_DRAWFRAME});
  dt := g_dtSlideShow;
END
 else
  dt := g_dtSlideHide;

hThreadMe := GetCurrentThread();
priority := GetThreadPriority(hThreadMe);
SetThreadPriority(hThreadMe, THREAD_PRIORITY_BELOW_NORMAL);

t0 := GetTickCount();
t:=t0;
while ((t) < t0 + dt) do
 begin
   t := GetTickCount();
   x := Round(OldPos.left + dx * (t - t0) / dt);
   y := Round(OldPos.top + dy * (t - t0) / dt);
   SetWindowPos(hwnd, 0, x, y, 0, 0,
   SWP_NOSIZE or SWP_NOZORDER or SWP_NOACTIVATE);
   if (fShow) THEN UpdateWindow(hwnd) else;
    UpdateWindow(GetDesktopWindow());
 END;
  SetThreadPriority(hThreadMe, priority);
  END;

 SetWindowPos(hwnd, 0, np.left, np.top,
    np.right - np.left, np.bottom - np.top,
    SWP_NOZORDER or SWP_NOACTIVATE or SWP_DRAWFRAME);
END;


procedure  TUSAppBar.AB_Register;
begin
with FABData do
 begin
  cbsize:=SizeOf (FABData);
  hwnd:=FABHandle;
  uCallBackMessage:=wm_appbar;
 end;
 if not FABReg THEN
  FABReg:=(shAppBarMessage (ABM_NEW,FABData)<>0);
end;

procedure TUSAppBar.AB_Remove;
begin
with FABData do
 begin
  cbsize:=SizeOf (FABData);
  hwnd:=FABHandle;
 end;
if FABReg THEN shAppBarMessage (ABM_REMOVE,FABData);
FABReg:=false;
end;

procedure TUSAppBar.AB_CB (var msg:TMessage);
begin
  IF msg.WPARAM = ABN_PosChanged THEN
   BEGIN
    AB_SetABPOS;AB_SetWndPos
   END
end;

procedure TUSAppBar.AB_Hide;

var r:TRect;
begin
If (not FABHidden) Then
 BEGIN
 AB_CheckPos(2,r);
 SlideWindow (FABHandle,r,FABSliding);
 FABHidden:=true;
 END;
end;

procedure TUSAppBar.AB_Unhide;
var r:TRect;

begin

If FABHidden Then
 BEGIN
 AB_CheckPos (FABWide,r);
 SlideWindow (FABHandle,r,FABSliding);
 FABHidden:=False;
 if (fABAutoHide) THEN
   FABTimerId:=SetTimer(FABHandle, ID_HIDETIMER, 500, NIL)
 END
END;

procedure TUSAppBar.AB_CalcRect (wide:Integer;var R:TRect);

BEGIN
case FABEdge of
 ABE_LEFT  : with r do
              BEGIN
               TOP:=0;
               LEFT:=0;
               Bottom:=GetSystemMetrics(SM_CYSCREEN);
               Right:=Wide;
              END;
 ABE_RIGHT : with r do
              BEGIN
               TOP:=0;
               Bottom:=GetSystemMetrics(SM_CYSCREEN);
               Right:=GetSystemMetrics(SM_CXSCREEN);
               LEFT:=Right-Wide;
              END;
 ABE_TOP   : with r do
              BEGIN
               TOP:=0;
               LEFT:=0;
               Bottom:=Wide;
               Right:=GetSystemMetrics(SM_CXSCREEN);
              END;
 ABE_BOTTOM: with r do
              BEGIN
               LEFT:=0;
               Bottom:=GetSystemMetrics(SM_CYSCREEN);
               TOP:=Bottom-Wide;
               Right:=GetSystemMetrics(SM_CXSCREEN);
              END
  END
 END;

procedure TUSAppBar.AB_CheckPos (wide:Integer;var R:Trect);
begin
 AB_CalcRect (wide,r);
 with FABData do
  BEGIN
   cbsize:=SizeOf (FABData);
   uEdge:=FABEdge;
   hwnd:=FABHandle;
   rc:=r
  END;
 IF FABReg THEN shAppBarMessage (ABM_QUERYPOS,FABData);
 r:=FABData.rc;
case FABEdge of
 ABE_LEFT  : r.LEFT:=0;
 ABE_RIGHT : r.Bottom:=GetSystemMetrics(SM_CYSCREEN);
 ABE_TOP   : r.TOP:=0;
 ABE_BOTTOM: r.Bottom:=GetSystemMetrics(SM_CYSCREEN);
  END

end;

procedure TUSAppBar.AB_SetABPos;
var wide:Integer;
begin
IF FABReg THEN
 BEGIN
  wide:=FABWide;
  If FABAutohide THEN wide:=2;
  IF (not FABAlwaysOnTop) and (not FABAutohide) Then wide:=0;
  AB_CheckPos (wide,FABRect);
  with FABData do
   begin
    cbsize:=SizeOf (FABData);
    uEdge:=FABEdge;
    hwnd:=FABHandle;
    rc:=FABRect
   end;
  shAppBarMessage (ABM_setPos,FABData);
 END;
end;

procedure TUSAppBar.AB_SetWndPos;

var wide:Integer;
    r:TREct;
BEGIN

IF FABReg THEN
  BEGIN
   If FABHidden Then wide:=2 else wide:=FABWide;
   AB_CheckPos (Wide,r);
   SlideWindow (FABHandle,r,FABSliding);
  END;
END;

procedure TUSAppBar.AB_SetActive;

BEGIN
If FABActive THEN
 BEGIN //Registrieren, Werte setzen, und hinschieben...
 IF not FABReg THEN AB_Register;
 IF FABReg THEN
  BEGIN
   GetWindowRect (FABHandle,FABOldRect);
   FABOldStyleEx:=GetWindowLong (FABHandle,GWL_EXSTYLE);
   FABOldStyle:=GetWindowLong (FABHandle,GWL_STYLE);
   SetWindowLong (FABHandle,GWL_EXSTYLE,WS_EX_TOOLWINDOW);
   SetWindowLong (FABHandle,GWL_Style,WS_VISIBLE or WS_DLGFRAME or ws_thickframe);
   HookWin;
   AB_SetAutohide;
   AB_SetAlwaysOnTop(FABAlwaysOnTop);
   AB_SetABPos;
   AB_SetWndPos
  END
 END
ELSE
 BEGIN
 AB_NoAutoHide;
 AB_SetAlwaysOnTop (false);
 AB_Remove;
 UnHookWin;
 SetWindowLong (FABHandle,GWL_EXSTYLE,FABOldStyleEx);
 SetWindowLong (FABHandle,GWL_STYLE,FABOldStyle);
 SlideWindow (FABHandle,FABOldRect,false);
 END
END;

procedure TUSAppBar.AB_NoAutoHide;
var ret:Integer;

BEGIN

IF FABReg THEN
 BEGIN
 with FABData do
  begin
  cbsize:=Sizeof(FABData);
  uEdge:=FABEdge;
  hwnd:=FABHandle
  END;
 ret:=shAppBarMessage (ABM_GetAutohideBar,FABData);
 IF (ret=FABHandle) THEN
  BEGIN
   FABData.LParam:=0;
   ret:=shAppBarMessage (ABM_SetAutohideBar,FABData);
  END
 END
END;

procedure TUSAppBar.AB_AutoHide;
var ret:Integer;
BEGIN
IF FABReg THEN
 BEGIN
 with FABData do
  begin
  cbsize:=Sizeof(FABData);
  uEdge:=FABEdge;
  hwnd:=FABHandle
  END;
 ret:=shAppBarMessage (ABM_GetAutohideBar,FABData);
 IF (ret<>0) THEN
  BEGIN
     MessageDlg ('Another appbar ist already registered to this edge',
       mtError,[mbOk],0);
     AB_Unhide;
     FABAutohide:=FALSE;
  END
 ELSE
  BEGIN
     FABData.LParam:=1;
     ret:=shAppBarMessage (ABM_SetAutohideBar,FABData);
     FABAutohide:=ret<>0;
     IF FABAutohide THEN FABTimerId:=SetTimer(FABHandle, ID_HIDETIMER, 500, NIL)
  END
 END;

END;


procedure TUSAppBar.AB_SetAutoHide;

begin

If FABAutohide THEN AB_AutoHide ELSE AB_NoAutoHide;
END;




procedure TUSAppBar.AB_SetAlwaysOnTop;

BEGIN

IF FABReg THEN
BEGIN
  If aAlwaysOnTop THEN
  SetWindowPos(FABHandle,HWND_TOPMOST,
     0, 0, 0, 0, SWP_NOMOVE OR SWP_NOSIZE OR SWP_NOACTIVATE)
   ELSE
  SetWindowPos(FABHandle,HWND_NOTOPMOST,
     0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE or SWP_NOACTIVATE);
  AB_SetABPos;
END;

END;


procedure TUSAppBar.SetEdge (aEdge:TEdge);

BEGIN
IF FABEdge<>Ord(aEdge) THEN
 BEGIN
 FABEdge:=Ord(aEdge);
 IF not Design THEN
  BEGIN
   AB_SetABPos;
   AB_SetWndPos
  END
 END
END;


function  TUSAppBar.GetEdge:TEdge;
BEGIN
Result:=TEdge(FABEdge);
END;
procedure TUSAppBar.SetWide (aWide:Integer);
BEGIN
IF FABWide<>aWide THEN
 BEGIN
 FABWide:=aWide;
 IF not Design THEN
  BEGIN
   AB_SetABPos;
   AB_SetWndPos
  END
 END
END;

procedure TUSAppBar.SetAutoHide (aAutoHide:Boolean);

BEGIN
IF FABAutoHide<>aAutoHide THEN
 BEGIN
 FABAutohide:=aAutohide;
 If not Design THEN AB_SetAutohide;
 END
END;

procedure TUSAppBar.SetAlwaysOnTop (aAlwaysOnTop:Boolean);
BEGIN
IF FABAlwaysOnTop<>aAlwaysOnTop THEN
 BEGIN
 FABAlwaysOnTop:=aAlwaysOnTop;
 If not Design THEN AB_SetAlwaysOnTop(FABAlwaysOnTop);
 END
END;

procedure TUSAppBar.SetActive (aActive:Boolean);
BEGIN
IF aActive <>FABActive THEN
 BEGIN
 FABActive:=aActive;
 IF not Design THEN AB_SetActive
 END
END;

procedure TUSAppBar.HookWin;

BEGIN
 OldWndProc := TFarProc(GetWindowLong(FABHandle, GWL_WNDPROC));
 NewWndProc := MakeObjectInstance(HookWndProc);
 SetWindowLong(FABHandle, GWL_WNDPROC, LongInt(NewWndProc));
END;

procedure TUSAppBar.UnhookWin;
begin
 SetWindowLong(FABHandle, GWL_WNDPROC, LongInt(OldWndProc));
 if assigned(NewWndProc) then
  FreeObjectInstance(NewWndProc);
 NewWndProc := nil;
end;

procedure TUSAppBar.HookWndProc(var Message: TMessage);
var VorlRes:Integer;
    MP:TPoint;
    R:Trect;
    dx,dy,cxscreen,cyscreen,vert,horz:Integer;
begin

  with Message do
  begin
    CASE Msg OF
     wm_AppBar     : AB_CB (Message); //Eine Nachricht von unsere Appbar
     wm_Timer      : If ((WParam=id_UnHideTimer) OR (WParam=id_HideTimer)) //Ein Timer zum Autohiding
                          AND FABAutoHide THEN
                      BEGIN
                       IF WParam=id_HideTimer THEN
                       BEGIN
                        GetCursorPos(MP);
                        GetWindowRect(FABHandle, R);
                        if not PtInRect(r, mp) THEN
                        BEGIN
                         KillTimer(FABHandle, id_HideTimer);
                         AB_Hide
                        END
                       END;
                      IF WParam=id_UnHideTimer THEN
                       BEGIN
                        GetCursorPos(MP);
                        GetWindowRect(FABHandle, R);
                        if PtInRect(r, mp) THEN
                        BEGIN
                         KillTimer(FABHandle, id_UnhideTimer);
                         AB_Unhide
                        END
                       END

                      END
                     ELSE
                       Result := CallWindowProc (OldWndProc,FABHandle, Msg, wParam, lParam);

     WM_NCHITTEST:  //Es wird gerade NichtClient getestet
                       BEGIN
                       If FABHIDDEN THEN
                         FABTimerID:=SetTimer(FABHandle,id_UnhideTimer,200,nil);

                       result:=HTClient;
                       VorlRes := CallWindowProc (
                       OldWndProc,FABHandle, Msg, wParam, lParam);
                       IF not(VorlRes in [HTBottom,HTTOP,HTRight,HTLeft]) THEN
                        result:=VorlRes;

	               if ((FABEdge=ABE_TOP) AND (VorlRes = HTBOTTOM)) THEN
		        result:= HTBOTTOM;
	               if ((FABEdge=ABE_Bottom) AND (VorlRes = HTTop)) THEN
		        result:= HTTOP;
                       if (FABEdge=ABE_LEFT) AND (VorlRes = HTRight) THEN
		        result:= HTRight;
                       if ((FABEdge=ABE_RIGHT) AND (VorlRes = HTLeft)) THEN
		        result:= HTLeft;
                      END;

    wm_sizing :  IF (wparam=wmsz_top) or (wparam=wmsz_bottom) THEN
                       FABWide:=PRect(lparam)^.bottom-PRect(lparam)^.top
                    else
                       FABWide:=PRect(lparam)^.right-PRect(lparam)^.left;
     wm_LButtonDown : BEGIN

                      SetForeGroundWindow (FABHandle);
                      SetCapture (FABHandle);
                      FABMoving:=true;
                      AB_NoAutohide;
                      END;
     wm_MouseMove   : IF FABMoving THEN
                       BEGIN

                       	cxScreen := GetSystemMetrics(SM_CXSCREEN);
	                cyScreen := GetSystemMetrics(SM_CYSCREEN);
                        GetCursorPos(MP) ;

	                if mp.x < (cxScreen div 2) THEN
	                 BEGIN
		         dx := mp.x;
		         horz:= ABE_LEFT;
                         END
                        else
                         BEGIN
		         dx := (cxscreen-mp.x);
		         horz:= ABE_RIGHT;
                         END;
	                if ((mp.y) < (cyScreen div 2)) THEN
	                 BEGIN
		         dy := mp.y;
		         vert:= ABE_TOP;
                         END
                        else
                         BEGIN
		         dy := cyscreen-mp.y;
		         vert:= ABE_Bottom;
                         END;
                        if (cxScreen div dx) > (cyScreen div dy) THEN
                          FABEdge:=horz ELSE
                          FABEDge:=vert;
                          AB_CheckPos (FABWide,R);
                          SlideWindow (FABHandle,R,FALSE);
                         END;
     wm_LButtonUp   : IF FABMoving THEN
                       BEGIN
                        IF Assigned (FOnChangeEdge) THEN FOnChangeEdge(self);
                        AB_SetABPos;
                        AB_SetAutoHide;
                        FABMoving:=False;
                        ReleaseCapture();
                       END;
     wm_Activate     : BEGIN
                       with FABData do
                        BEGIN
                        cbSize:=sizeof (FABData);
                        hwnd:=FABHandle;
                        lparam:=0;
                        END;
                       SHAppBarMessage (ABM_Activate,FABData);
                       CASE wParamlo of
                        WA_CLICKACTIVE: BEGIN
                                         IF FABAutohide THEN AB_Unhide;
                                         KillTimer (FABHandle,ID_HideTimer);
                                        END;
                        WA_InACtive   : IF FABAutohide THEN AB_Hide;
                       END
                       END;
     wm_size : BEGIN
               with FABData do
                begin
                cbSize:=sizeof(FABData);
                hWnd:=FABHandle;
                lParam:=0
                END;
               SHAppBarMessage (ABM_WindowPosChanged,FABData);
               Result := CallWindowProc (OldWndProc,FABHandle, Msg, wParam, lParam);
               END
    ELSE Result := CallWindowProc (OldWndProc,FABHandle, Msg, wParam, lParam);
   END //von Case
  end;
end;

constructor TUSAppBar.Create(AOwner: TComponent);
BEGIN
inherited Create (AOwner);
FABOwner:=Aowner As TForm;
FABHandle:=FABOwner.Handle;

FABActive:=false;
FABAutoHide:=false;
FABAlwaysOnTop:=false;
FABSliding:=true;
FABWide:=50;
FABEdge:=ABE_Left;
FABHidden:=false;
FABMoving:=false;
FABReg:=false;
END;

destructor  TUSAppBar.Destroy;

BEGIN
AB_Remove;
inherited Destroy;
END;

end.
