unit cd2html;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ExtCtrls, ComCtrls, EditText, Menus, ShlObj, ShellApi,
  Buttons;

type

  TMainWindow = class(TForm)
    SaveDialog: TSaveDialog;
    ListView1: TListView;
    ImageList1: TImageList;
    StatusBar1: TStatusBar;
    LoadDialog: TSaveDialog;
    Panel2: TPanel;
    SBtnStart1: TSpeedButton;
    SBtnStop1: TSpeedButton;
    SBtnOpen1: TSpeedButton;
    SBtnSave1: TSpeedButton;
    SBtnPrint1: TSpeedButton;
    SBtnOptions1: TSpeedButton;
    SBtnAbout1: TSpeedButton;
    SBtnExit1: TSpeedButton;
    Bevel1: TBevel;
    EditPath: TEdit;
    Button1: TButton;
    SBtnPreview1: TSpeedButton;
    SBtnDelete1: TSpeedButton;
    SBtnInsert1: TSpeedButton;
    SBtnHelp1: TSpeedButton;
    procedure BtnRunClick(Sender: TObject);
    procedure GetDirSize(mask:string);
    procedure GetAllFiles(mask:string);
    procedure BtnSaveClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure BtnExitClick(Sender: TObject);
    procedure BtnInfoClick(Sender: TObject);
    procedure BtnInsertClick(Sender: TObject);
    procedure BtnDeleteClick(Sender: TObject);
    procedure BtnOptionClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    function  RGB2hex(l:Longint):String;
    procedure Options1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure BtnPrintClick(Sender: TObject);
    procedure ListView1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ListView1DblClick(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure ListView1ColumnClick(Sender: TObject; Column: TListColumn);
   // procedure CustomSortProc(Col: integer; _Lo,_Hi: integer);
    procedure ListView1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ListView1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure DirectoryBoxChange(Sender: TObject);
    procedure BtnLoadClick(Sender: TObject);
    procedure SaveAll(FileName: String);
    procedure LoadAll(FileName: String);
    procedure BtnBrowseClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure BtnStop1Click(Sender: TObject);
    procedure BtnPreviewClick(Sender: TObject);
    procedure SaveAsHTML(FileName: String);
    procedure BtnHelp1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    procedure DisplayHint(Sender: TObject);
    { Public-Deklarationen }
  end;

var
  MainWindow                            : TMainWindow;
  Ebene                                 : Byte;
  root                                  : String;
  DirSize                               : Longint;
  DocFG,DocBG, TableHeadFG, TableHeadBG,
  TableTextFG, TableTextBG              : Longint;
  fullSize                              : Longint;
  FormCaption                           : String;
  dirs                                  : Integer;
  Stop                                  : Boolean;

implementation

uses info, options, inshline, print;

function CustomSortProc1(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
// nach Datei-Namen sortieren
begin
  Result:=lstrcmp(PChar(TListItem(Item1).Caption),PChar(TListItem(Item2).Caption));
end;

function CustomSortProc2(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
// nach Datei-Gre sortieren
var i1,i2   : String;
    z1,z2,c : Integer;
begin
  i1:=TListItem(Item1).Subitems[0];
  i2:=TListItem(Item2).Subitems[0];
  If i1[Length(i1)]='e' then Delete(i1,Length(i1)-3,4)        // Byt'e'
  else If i1[Length(i1)-1]='K' then
       Begin Delete(i1,Length(i1)-1,2); i1:=i1+'000'; end     // 'K'B
  else Begin Delete(i1,Length(i1)-1,2); i1:=i1+'000000'; end; // MB
  If i2[Length(i2)]='e' then Delete(i2,Length(i2)-3,4)        // Byt'e'
  else If i2[Length(i2)-1]='K' then
       Begin Delete(i2,Length(i2)-1,2); i2:=i2+'000'; end     // 'K'B
  else Begin Delete(i2,Length(i2)-1,2); i2:=i2+'000000'; end; // MB
  Val(i1,z1,c);
  Val(i2,z2,c);
  Result:=z2-z1;
end;

function CustomSortProc3(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
// nach Datei-Pfad sortieren
begin
  Result:=lstrcmp(PChar(TListItem(Item1).Subitems[1]),PChar(TListItem(Item2).Subitems[1]));
end;

procedure TMainWindow.DisplayHint(Sender: TObject);
begin
  StatusBar1.Panels.Items[2].Text:=Application.Hint;
end;

procedure TMainWindow.GetDirSize(mask:string);
var Search: TSearchrec;
    verz  : string;
begin
  If Stop then Exit;
  Application.ProcessMessages; // den anderen Programmteilen Zeit geben
  if mask[length(mask)]<>'\' then mask:=mask + '\';
  verz:=ExtractFilePath(mask);
  { alle Dateien suchen }
  if FindFirst(verz+'*.*',faAnyFile,Search)= 0 then
  repeat
   DirSize:=DirSize+Search.Size;
  until FindNext(Search)<>0;
  { Unterverzeichnisse durchsuchen }
  if FindFirst(verz+'*.*',fadirectory, Search)= 0 then
  repeat
    if((search.attr and fadirectory)=fadirectory) and (search.name[1]<>'.')
      then GetDirSize(verz+Search.Name+'\');{ListBox1.Items.Add(verz+Search.Name+'\');}
  until FindNext(Search) <> 0;
end;

procedure TMainWindow.GetAllFiles(mask:string);
var Search: TSearchrec;
    verz  : string;
    _verz : string;
    such  : string;
    temp  : String;
    item  : TListItem;
begin
  If Stop then Exit;
  If Ebene > FormOptions.UpDown3.Position then Exit;
  Inc(dirs);
  StatusBar1.Panels.Items[1].Text:=IntToStr(dirs);
  such := FormOptions.Edit2.Text;
  verz := ExtractFilePath(mask);
  if verz[length(verz)]<>'\' then verz := verz + '\';
 { alle Dateien suchen }
  if FindFirst(mask, faAnyFile, Search)= 0 then
  repeat
    _verz:=verz;
    Delete(_verz,1,Length(root));
    If FormOptions.CheckBox1.Checked then
    Begin
     If ((Search.Attr and fadirectory)=fadirectory) and (search.name[1]<>'.') then
     Begin
       item:=ListView1.Items.Add;
       item.caption:=Search.Name;
       DirSize:=0;
       GetDirSize(verz+Search.Name);
       If DirSize > 1048576 then temp:=IntToStr(Round(DirSize/1048576))+'MB'
       else If DirSize > 1024 then temp:=IntToStr(Round(DirSize/1024))+'KB'
       else temp:=IntToStr(DirSize)+'Byte';
       item.SubItems.Add(temp);
       item.SubItems.Add('\'+_verz+Search.Name);
       If Ebene=1 then
       Begin
         fullSize:=fullSize+DirSize;
         item.StateIndex:=2;
       end
       else item.StateIndex:=6;
     end;
    end
    else
    Begin
     If ((Search.Attr and fadirectory)=fadirectory) and (search.name[1]<>'.') then
     Begin
       item:=ListView1.Items.Add;
       item.caption:=Search.Name;
       DirSize:=0;
       GetDirSize(verz+Search.Name);
       If DirSize > 1048576 then temp:=IntToStr(Round(DirSize/1048576))+'MB'
       else If DirSize > 1024 then temp:=IntToStr(Round(DirSize/1024))+'KB'
       else temp:=IntToStr(DirSize)+'Byte';
       item.SubItems.Add(temp);
       item.SubItems.Add('\'+_verz+Search.Name);
       If Ebene=1 then item.StateIndex:=FormOptions.UpDown3.Position
       else item.StateIndex:=6;
     end
     else If search.name[1]<>'.' then
     Begin
      item:=ListView1.Items.Add;
      item.caption:=Search.Name;
      If Search.Size > 1048576 then temp:=IntToStr(Round(Search.Size/1048576))+'MB'
      else If Search.Size > 1024 then temp:=IntToStr(Round(Search.Size/1024))+'KB'
      else temp:=IntToStr(Search.Size)+'Byte';
      item.SubItems.Add(temp);
      item.SubItems.Add('\'+_verz+Search.Name);
      item.StateIndex:=6;
     end;
    end;
  until FindNext(Search)<>0;
  { Unterverzeichnisse durchsuchen }
  if FindFirst(verz+'*.*',fadirectory,Search)= 0 then
  repeat
    if((search.attr and fadirectory)=fadirectory)and(search.name[1]<>'.')
    then
    Begin
      Inc(Ebene);
      GetAllFiles(verz+ Search.Name + '\' + such);
      Dec(Ebene);
    end;
  until FindNext(Search) <> 0;
end;

{$R *.DFM}

procedure TMainWindow.BtnRunClick(Sender: TObject);
Var path, temp : String;
begin
    Stop:=false;
    ListView1.Items.Clear;                  //List.View leeren
    MainWindow.Caption:=FormCaption;        //MainWindow.Caption auf Standard
    Path:=EditPath.Text;
    If Path[Length(Path)]<>'\' then Path:=Path+'\';
    root:=ExtractFilePath(Path);            //Stammverzeichnis zum scannen
    Ebene:=1;                               //Suchebene (Verzeichnistiefe)
    fullSize:=0;                            //Gre von root
    dirs:=0;                                //Anzahl der durchsuchten Directories
    screen.cursor := crHourGlass;           //Cursor soll Arbeit anzeigen
    ListView1.Items.BeginUpdate;            //ListView.Paint ausschalten
    StatusBar1.Panels.Items[0].Text:='Searching ...';
    GetAllFiles(Path+'*.*');                //Scannen
    ListView1.CustomSort(@CustomSortProc3, 0); //nach Pfad sortieren
    ListView1.Items.EndUpdate;              //ListView:Paint wieder an
    If fullSize > 1048576 then temp:=IntToStr(Round(fullSize/1048576))+'MB'
    else If fullSize > 1024 then temp:=IntToStr(Round(fullSize/1024))+'KB'
    else temp:=IntToStr(fullSize)+'Byte';
    MainWindow.Caption:=FormCaption+' ['+Path+' ('+temp+')]'; //MainWindow.Caption zeigt root-Gre an
    screen.cursor := crDefault;             //Cursor wieder normal
end;

function TMainWindow.RGB2hex(l:Longint):String;
Const hextab:Array[0..15] of Char='0123456789ABCDEF';
begin
 RGB2hex:='      ';
 RGB2hex[5]:=HexTab[(l and $F00000) shr 20];
 RGB2hex[6]:=HexTab[(l and $0F0000) shr 16];
 RGB2hex[1]:=HexTab[(l and $00F000) shr 12];
 RGB2hex[2]:=HexTab[(l and $000F00) shr 8];
 RGB2hex[3]:=HexTab[(l and $0000F0) shr 4];
 RGB2hex[4]:=HexTab[ l and $00000F];
end;

procedure TMainWindow.LoadAll(FileName: String);
var  f   : TextFile;
     W   : Word;
     S   : String;
     item: TListItem;
Begin
  // Dateiaufbau
  // 1. Text vor berschrift (Content of)
  // berschrift
  // Gre
  // Laufwerk
  // Pfad
  // DocFG,DocBG,TableHeadFG,TableHeadBG,TableTextFG,TableTextBG
  // LiestView.Items
  AssignFile(f,FileName);
  Reset(f);
  Readln(f,S);
  FormOptions.EditHeadLine.Text:=S;
  Readln(f,S);
  FormOptions.EditCDName.Text:=S;
  Readln(f,fullSize);
  Readln(f,S);
  EditPath.Text:=S;
  Readln(f,DocFG);
  Readln(f,DocBG);
  Readln(f,TableHeadFG);
  Readln(f,TableHeadBG);
  Readln(f,TableTextFG);
  Readln(f,TableTextBG);
  ListView1.Items.Clear;
  With ListView1 do While not eof(f) do
  Begin
    item:=ListView1.Items.Add;
    Readln(f,W);
    Item.StateIndex:=W;
    Readln(f,S);
    Item.Caption:=S;
    Readln(f,S);
    Item.Subitems.Add(S);
    Readln(f,S);
    Item.Subitems.Add(S);
  end;
  CloseFile(f);
  If fullSize > 1048576 then S:=IntToStr(Round(fullSize/1048576))+'MB'
  else If fullSize > 1024 then S:=IntToStr(Round(fullSize/1024))+'KB'
  else S:=IntToStr(fullSize)+'Byte';
  MainWindow.Caption:=FormCaption+' ['+EditPath.Text+' ('+S+')]';
end;

procedure TMainWindow.SaveAll(FileName: String);
var  f   : TextFile;
     i   : Word;
Begin
  // Dateiaufbau
  // 1. Text vor berschrift (Content of)
  // berschrift
  // Gre
  // Laufwerk
  // Pfad
  // DocFG,DocBG,TableHeadFG,TableHeadBG,TableTextFG,TableTextBG
  // LiestView.Items
  AssignFile(f,FileName);
  Rewrite(f);
  Writeln(f,FormOptions.EditHeadLine.Text);
  Writeln(f,FormOptions.EditCDName.Text);
  Writeln(f,fullSize);
  Writeln(f,EditPath.Text);
  Writeln(f,DocFG);
  Writeln(f,DocBG);
  Writeln(f,TableHeadFG);
  Writeln(f,TableHeadBG);
  Writeln(f,TableTextFG);
  Writeln(f,TableTextBG);
  With ListView1 do For i:=0 to Items.Count-1 do
  Begin
   Writeln(f,Items[i].StateIndex);
   Writeln(f,Items[i].Caption);
   Writeln(f,Items[i].Subitems[0]);
   Writeln(f,Items[i].Subitems[1]);
  end;
  CloseFile(f);
end;

procedure TMainWindow.SaveAsHTML(FileName: String);
var f   : TextFile;
    i   : Word;
    temp: String;
begin
With ListView1 do
begin
  If fullSize > 1048576 then temp:=IntToStr(Round(fullSize/1048576))+'MB'
  else If fullSize > 1024 then temp:=IntToStr(Round(fullSize/1024))+'KB'
  else temp:=IntToStr(fullSize)+'Byte';
  AssignFile(f,FileName);
  Rewrite(f);
  Writeln(f,'<HTML>');
  Writeln(f,'<!-- Created by CD2HTML, written by Falk Petro -->');
  Writeln(f,'<BODY BGCOLOR="#'+RGB2hex(DocBG)+'" TEXT ="#'+RGB2hex(DocFG)+'"'
                 +' LINK   ="#009900" VLINK="#003300">');
  Writeln(f,'<center>');
  Writeln(f,'<h2>'+FormOptions.EditHeadLine.Text+' '+#39+FormOptions.EditCDName.Text+#39+'</h2>');
  Writeln(f,'<i>Size: '+temp+'</i>');
  Writeln(f,'<br><br>');
  If Items.Count=0 then
  Begin
    Writeln(f,'</center>');
    Writeln(f,'</HTML>');
    CloseFile(f);
    StatusBar1.Panels.Items[0].Text:='Saved as html-file.';
    Exit;
  end;
  For i:=0 to Items.Count-1 do
    If Items[i].StateIndex<6 then
      Writeln(f,'<A HREF="#'+IntToStr(i)+'">['+Items[i].Caption+']</A>');
  Writeln(f,'<br><br>');
  For i:=0 to Items.Count-1 do
  Begin
    If Items[i].StateIndex<6 then
    Begin
      If i<>0 then Writeln(f,'</TABLE>');
      Writeln(f,'<br>');
      Writeln(f,'<a name="'+IntToStr(i)+'">');
      Write  (f,'<h'+IntToStr(Items[i].StateIndex+1)+'>'+Items[i].Caption
                 +'<i>  ['+Items[i].Subitems.Strings[0]+']</i>'+'</h'
                 +IntToStr(Items[i].StateIndex+1)+'>');
      Writeln(f,'<br>');
      Writeln(f,'<table border bgcolor=#'+RGB2hex(TableTextBG)+'>');
      Writeln(f,'<tr>');
      Writeln(f,'<th bgcolor=#'+RGB2hex(TableHeadBG)+'><font color=#'
                 +RGB2hex(TableHeadFG)+'>Program/Directory</th>');
      Writeln(f,'<th bgcolor=#'+RGB2hex(TableHeadBG)+'><font color=#'
                 +RGB2hex(TableHeadFG)+'>Size</th>');
      Writeln(f,'<th bgcolor=#'+RGB2hex(TableHeadBG)+'><font color=#'
                 +RGB2hex(TableHeadFG)+'>Path</th>');
      Writeln(f,'</tr>');
    end
    Else Writeln(f,'<tr><td> '+Items[i].Caption+' <td> '+
                   Items[i].Subitems.Strings[0]+' <td> '+
                   Items[i].Subitems.Strings[1]+' </tr>');
  end;
  Writeln(f,'</TABLE>');
  Writeln(f,'</center>');
  Writeln(f,'</HTML>');
  CloseFile(f);
end;
end;

procedure TMainWindow.BtnSaveClick(Sender: TObject);
var f   : TextFile;
    i   : Word;
    temp: String;
    star: String;
    maxl: Word;
begin
  StatusBar1.Panels.Items[0].Text:='Saving ...';
  If fullSize > 1048576 then temp:=IntToStr(Round(fullSize/1048576))+'MB'
    else If fullSize > 1024 then temp:=IntToStr(Round(fullSize/1024))+'KB'
    else temp:=IntToStr(fullSize)+'Byte';
  if SaveDialog.Execute then With ListView1 do
  If SaveDialog.FilterIndex=1 then
  Begin
     SaveAsHTML(SaveDialog.FileName);
     StatusBar1.Panels.Items[0].Text:='Saved as html-file.';
  end
  else If SaveDialog.FilterIndex=2 then
  Begin
     AssignFile(f,SaveDialog.FileName);
     Rewrite(f);
     star:='++++++++++++++++++++++++++++++++++++++++';
     star:=star+star;
     Writeln(f,star);
     Writeln(f,FormOptions.EditCDName.Text);
     Writeln(f,star);
     Writeln(f);
     Writeln(f,'Content of      : '+FormOptions.EditCDName.Text);
     Writeln(f,'Size            : '+temp);
     Writeln(f,'Catalogue');
     Writeln(f,'  Craetion Date : '+DateToStr(Date));
     Writeln(f,'  Craetion Time : '+TimeToStr(Time));
     Writeln(f,'  Created by    : CD2HTML');
     Writeln(f);
     Writeln(f);
     If Items.Count=0 then
     Begin
       Writeln(f);
       Writeln(f);
       Writeln(f);
       CloseFile(f);
       StatusBar1.Panels.Items[0].Text:='Saved as text-file.';
       Exit;
     end;
     star:='****************************************';
     star:=star+star;
     maxl:=0;
     For i:=0 to Items.Count-1 do
       If Length(Items[i].Caption)>maxl then maxl:=Length(Items[i].Caption);
     maxl:=maxl+2;
     For i:=0 to Items.Count-1 do
     Begin
       If Items[i].StateIndex<6 then
       Begin
         Writeln(f);
         Writeln(f,Format('%-'+IntToStr(maxl)+'s',[Items[i].Caption])
                  +Format('%13s',['['+Items[i].Subitems.Strings[0]+']']));
         Writeln(f,star);
       end
       Else Writeln(f,'   '+Format('%-'+IntToStr(maxl)+'s',[Items[i].Caption])
                     +Format('%10s',['['+Items[i].Subitems.Strings[0]+']'])
                     +'   '+Items[i].Subitems.Strings[1]);
     end;
     Writeln(f);
     Writeln(f);
     Writeln(f);
     CloseFile(f);
     StatusBar1.Panels.Items[0].Text:='Saved as text-file.';
  end
  else
  Begin
     SaveAll(SaveDialog.FileName);
     StatusBar1.Panels.Items[0].Text:='Saved as cd2html-file (intern format).';
  end;
end;

procedure TMainWindow.CheckBox1Click(Sender: TObject);
begin
  If FormOptions.CheckBox1.Checked then FormOptions.Edit1.Enabled:=false
  else FormOptions.Edit1.Enabled:=true;
end;

procedure TMainWindow.BtnExitClick(Sender: TObject);
begin
  Close;
end;

procedure TMainWindow.BtnInfoClick(Sender: TObject);
begin
  FormInfo.ShowModal;
end;

procedure TMainWindow.BtnInsertClick(Sender: TObject);
var InsertItem : TlistItem;
begin
  If ListView1.Selected = nil then Exit;
  FormHeadline.Edit.Text:='';
  FormHeadline.Edit2.Text:='0';
  FormHeadline.Edit3.Text:='\';
  If FormHeadline.ShowModal=mrOk then
  Begin
    with ListView1 do
     InsertItem:=Items.Insert(Selected.Index);
     InsertItem.Caption:=FormHeadline.Edit.Text;
     InsertItem.SubItems.Add(FormHeadline.Edit2.Text);
     InsertItem.SubItems.Add(FormHeadline.Edit3.Text);
     InsertItem.StateIndex:=FormHeadline.UpDown1.Position-1;
     StatusBar1.Panels.Items[0].Text:='Item inserted.';
  end;
end;

procedure TMainWindow.BtnDeleteClick(Sender: TObject);
begin
  with ListView1 do if Selected <> nil then
    While ListView1.SelCount<>0 do Selected.Delete;
  StatusBar1.Panels.Items[0].Text:='Item(s) deleted.';
end;

procedure TMainWindow.BtnOptionClick(Sender: TObject);
begin
  FormOptions.ShapeHead.Brush.Color:=TableHeadBG;
  FormOptions.ShapeText.Brush.Color:=TableTextBG;
  FormOptions.ShapeDoc.Brush.Color:=DocBG;
  FormOptions.TextHead.Color:=TableHeadBG;
  FormOptions.TextText.Color:=TableTextBG;
  FormOptions.TextDoc.Color:=DocBG;
  FormOptions.TextHead.Font.Color:=TableHeadFG;
  FormOptions.TextText.Font.Color:=TableTextFG;
  FormOptions.TextDoc.Font.Color:=DocFG;
  If FormOptions.ShowModal =mrOk then
  Begin
    DocFG:=FormOptions.TextDoc.Font.Color;
    DocBG:=FormOptions.ShapeDoc.Brush.Color;
    TableHeadFG:=FormOptions.TextHead.Font.Color;
    TableHeadBG:=FormOptions.ShapeHead.Brush.Color;
    TableTextFG:=FormOptions.TextText.Font.Color;
    TableTextBG:=FormOptions.ShapeText.Brush.Color;
  end;
end;

procedure TMainWindow.FormCreate(Sender: TObject);
begin
  Application.OnHint:=DisplayHint;
  Application.HelpFile:='cd2html.hlp';
  DocFG:=RGB(0,0,0);
  DocBG:=RGB($EE,$EE,$EE);
  TableHeadFG:=RGB($FF,$FF,$FF);
  TableHeadBG:=RGB(0,0,$A0);
  TableTextFG:=RGB(0,0,0);
  TableTextBG:=RGB($F0,$F0,$C0);
  FormCaption:=MainWindow.Caption;
//  Image1.Picture.Bitmap.TransparentColor:=clBlack;
end;

procedure TMainWindow.Print1Click(Sender: TObject);
begin
   FormPrintPrev.ShowModal;
end;

procedure TMainWindow.Options1Click(Sender: TObject);
begin
  FormOptions.ShapeHead.Brush.Color:=TableHeadBG;
  FormOptions.ShapeText.Brush.Color:=TableTextBG;
  FormOptions.ShapeDoc.Brush.Color:=DocBG;
  FormOptions.TextHead.Color:=TableHeadBG;
  FormOptions.TextText.Color:=TableTextBG;
  FormOptions.TextDoc.Color:=DocBG;
  FormOptions.TextHead.Font.Color:=TableHeadFG;
  FormOptions.TextText.Font.Color:=TableTextFG;
  FormOptions.TextDoc.Font.Color:=DocFG;
  If FormOptions.ShowModal =mrOk then
  Begin
    DocFG:=FormOptions.TextDoc.Font.Color;
    DocBG:=FormOptions.ShapeDoc.Brush.Color;
    TableHeadFG:=FormOptions.TextHead.Font.Color;
    TableHeadBG:=FormOptions.ShapeHead.Brush.Color;
    TableTextFG:=FormOptions.TextText.Font.Color;
    TableTextBG:=FormOptions.ShapeText.Brush.Color;
  end;
end;

procedure TMainWindow.Save1Click(Sender: TObject);
begin
   SaveDialog.Execute;
end;

procedure TMainWindow.BtnPrintClick(Sender: TObject);
begin
  FormPrintPrev.ShowModal;
end;

procedure TMainWindow.ListView1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  If Key=VK_F1 then Application.HelpCommand(Help_Contents,0);
  If not ListView1.IsEditing then
  Begin
    If Key=VK_DELETE then While ListView1.SelCount<>0 do ListView1.Selected.Delete;
    If Key=VK_INSERT then BtnInsertClick(Sender);
    If Key=VK_F2 then ListView1.Selected.EditCaption;
  end;
end;

procedure TMainWindow.ListView1DblClick(Sender: TObject);
var InsertItem : TlistItem;
begin
  With ListView1.Items[ListView1.Selected.Index] do
  begin
    FormHeadline.Edit.Text:=Caption;
    FormHeadline.Edit2.Text:=SubItems[0];
    FormHeadline.Edit3.Text:=SubItems[1];
    FormHeadline.UpDown1.Position:=StateIndex+1;
    If FormHeadline.ShowModal=mrOk then
    Begin
     Caption:=FormHeadline.Edit.Text;
     SubItems[0]:=FormHeadline.Edit2.Text;
     SubItems[1]:=FormHeadline.Edit3.Text;
     StateIndex:=FormHeadline.UpDown1.Position-1;
    end;
  end;
end;

procedure TMainWindow.ListView1ColumnClick(Sender: TObject;
  Column: TListColumn);
begin
  Case Column.Index of
    0: ListView1.CustomSort(@CustomSortProc1, 0); // Name geclickt
    1: ListView1.CustomSort(@CustomSortProc2, 0); // Size geclickt
    2: ListView1.CustomSort(@CustomSortProc3, 0); // Path geclickt
  end;
end;

procedure TMainWindow.ListView1DragDrop(Sender,Source: TObject; X,Y: Integer);
var
  AItem: TListItem;
  i1,i2: Integer;
begin
  With MainWindow.ListView1 do
  Begin
    If DropTarget<>nil then
     While SelCount<>0 do
     begin
       i1:=DropTarget.Index;
       i2:=Selected.Index+1;
       AItem:=Items.Insert(i1);
       Items.Item[i1].Assign(Items.Item[i2]);
       Items.Delete(i2);
    end;
  end;
end;

procedure TMainWindow.ListView1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept:=Source is TListView;
{  With MainWindow.ListView1 do
  Begin
   If Selected.Index <> DropTarget.Index then Accept:=false;
  end;}
end;

procedure TMainWindow.DirectoryBoxChange(Sender: TObject);
begin
  StatusBar1.Panels.Items[0].Text:='Directory changed.';
end;

procedure TMainWindow.BtnLoadClick(Sender: TObject);
begin
   if LoadDialog.Execute then
   LoadAll(LoadDialog.FileName);
   StatusBar1.Panels.Items[0].Text:='Loaded cd2html-file (intern format).';
end;

procedure TMainWindow.BtnBrowseClick(Sender: TObject);
var
  BrowseInfo: TBrowseInfo;
  DisplayName: array[0..MAX_PATH] of char;
  idBrowse : PItemIDList;
  tmp : PChar;
begin
  with BrowseInfo do begin
    hWndOwner:=MainWindow.Handle;
    pidlRoot:=nil;
    pszDisplayName:=DisplayName;
    lpszTitle:='Please choose a folder!';
    ulFlags:=BIF_RETURNONLYFSDIRS;
    lpfn:=nil;
    lParam:=0;
  end;
  idBrowse:=SHBrowseForFolder(@BrowseInfo);
  if assigned(idBrowse) then
  Begin
     SHGetPathFromIDList(idBrowse,tmp); // in echten Pfad konvertieren
     EditPath.Text:=StrPas(tmp);
  end;
end;

procedure TMainWindow.FormResize(Sender: TObject);
begin
  If MainWindow.Height < 150 then MainWindow.Height:=150;
  If MainWindow.Width < 500 then MainWindow.Width:=500;
end;

procedure TMainWindow.BtnStop1Click(Sender: TObject);
begin
  Stop:=true;
end;

procedure TMainWindow.BtnPreviewClick(Sender: TObject);
const TName = '~temp.htm';
var j,i      : Integer;
    doc,dir  : String;
    res      : array[1..250] of Char;
begin
  GetTempPath(SizeOf(dir),@dir[1]);
  doc:=TName+#0;
//  ExpandFileName
  dir:='c:\';
  SaveAsHTML(dir+doc);
  FillChar(res,SizeOf(res),' ');
  res[250]:=#0;
  j:=FindExecutable(@doc[1],@dir[1],@res[1]);
  If j >= 32 then
  i:=ShellExecute(handle,'open',@res[1],'file:\\c:\'+TName{@doc[1]}
                  ,PChar(0){@dir[1]},SW_SHOWDEFAULT);
end;

procedure TMainWindow.BtnHelp1Click(Sender: TObject);
begin
  Application.HelpCommand(Help_Contents,0);
end;

end.

//GetTempFileName(...
//GetCurrentDirectory(...