unit print;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, printers, ExtCtrls, StdCtrls, Buttons, ComCtrls, ClipBrd;

type
  PSize = ^TSize;
  TSize = Record
           cx,cy : Longint;
          end;
  TFormPrintPrev = class(TForm)
    paintbox1: TPaintBox;
    PrinterSetupDialog1: TPrinterSetupDialog;
    Print: TButton;
    Settings: TButton;
    Exit: TButton;
    Panel1: TPanel;
    Edit1: TEdit;
    UpDown1: TUpDown;
    Label1: TLabel;
    BtnFont: TButton;
    BtnSave: TButton;
    procedure paintbox1Paint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure PrintClick(Sender: TObject);
    procedure SettingsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure UpDown1Changing(Sender: TObject; var AllowChange: Boolean);
    procedure BtnFontClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BtnSaveClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FormPrintPrev: TFormPrintPrev;
  AFont: Array[1..7] of TFont;

implementation

uses cd2html, fonts, options;

{$R *.DFM}

var Druckbreite,Druckhoehe : Integer;

procedure Blattanpassen;
var prnxy, formxy         : single;
    dx,dy,x,y             : integer;
    rect                  : TRect;
    pencolor,fillcolor    : TColor;
    Size                  : PSize;
begin
    Druckbreite :=GetDeviceCaps(printer.handle,horzsize);
    Druckhoehe  :=GetDeviceCaps(printer.handle,vertsize);
    y:= 35;
    x:= 5;
    formxy:=(FormPrintPrev.clientWidth-x)/(FormPrintPrev.clientheight-y);
    prnxy :=druckbreite/druckhoehe;
    If formxy < prnxy then
    begin {Breite dominiert }
      dx:=FormPrintPrev.clientWidth-20;
      dy:=round(dx/prnxy);
      y :=round((FormPrintPrev.ClientHeight/2+8)-(dy/2));
    end
    else
    begin {Hhe dominiert }
      dy:=FormPrintPrev.clientHeight-y-10;
      dx:=round(dy*prnxy);
      x :=round((FormPrintPrev.clientWidth/2)-(dx/2));
    End;
    With FormPrintPrev.Paintbox1 do
    Begin
      SetBounds(x,y,dx,dy);
      SetMapMode(canvas.handle,mm_anisotropic);
//      SetWindowOrgEx(canvas.handle,Left,Top,nil);
      SetWindowExtEx(canvas.handle,druckbreite*10,-druckhoehe*10,nil);
      SetViewPortExtEx(canvas.handle,dx,dy,nil);

      PenColor :=canvas.pen.color;
      FillColor:=canvas.brush.color;
      canvas.Brush.Style:=bsSolid;
      canvas.Brush.Color:=clWhite;
      canvas.Pen.Color  :=clWhite;
      canvas.rectangle(0,0,Druckbreite*10,-Druckhoehe*10);
      canvas.pen.color  :=PenColor;
      canvas.brush.color:=FillColor;
      canvas.brush.style:=bsClear;
    end;
end;

procedure DC_TextOut(can: TCanvas;x,y,winkel:integer;txt:String);
var hfont, fontold, fnWeight : integer;
    dc             : hdc;
    fontname       : string;
    A              : array[0..79] of Char;
    fdwUnderline, fdwItalic, fdwStrikeOut : DWord;
begin
     StrPCopy(A,txt);
     if strlen(A)= 0 then exit;         
     dc := Can.handle;
     fontname := Can.Font.Name + #0;
     If Can.Font.Style >= [fsItalic] then fdwItalic:=1 else fdwItalic:=0;
     If Can.Font.Style >= [fsUnderline] then fdwUnderline:=1 else fdwUnderline:=0;
     If Can.Font.Style >= [fsStrikeout] then fdwStrikeout:=1 else fdwStrikeout:=0;
     If Can.Font.Style >= [fsBold] then fnWeight:=fw_bold else fnWeight:=fw_Normal;
     hfont:=CreateFont(-Can.Font.Height,0,winkel*10,0,fnWeight,fdwItalic,
                        fdwUnderline,fdwStrikeOut,1,4,$10,2,4,@fontname[1]);
     fontold:=SelectObject(dc,hfont);
     TextOut(dc,x,y,A,strlen(A));
     SelectObject(dc, fontold);
     DeleteObject(hfont);
end;

procedure DC_DrawText(can: TCanvas; rc: TRect; winkel:integer;txt:String);
var hfont, fontold, fnWeight : integer;
    dc             : hdc;
    fontname       : string;
    A              : array[0..79] of Char;
    fdwUnderline, fdwItalic, fdwStrikeOut : DWord;
begin
     StrPCopy(A,txt);
     if strlen(A)= 0 then exit;
     dc := Can.handle;
     fontname := Can.Font.Name + #0;
     If Can.Font.Style >= [fsItalic] then fdwItalic:=1 else fdwItalic:=0;
     If Can.Font.Style >= [fsUnderline] then fdwUnderline:=1 else fdwUnderline:=0;
     If Can.Font.Style >= [fsStrikeout] then fdwStrikeout:=1 else fdwStrikeout:=0;
     If Can.Font.Style >= [fsBold] then fnWeight:=fw_bold else fnWeight:=fw_Normal;
     hfont:=CreateFont(-Can.Font.Height,0,winkel*10,0,fnWeight,fdwItalic,
                        fdwUnderline,fdwStrikeOut,1,4,$10,2,4,@fontname[1]);
     fontold:=SelectObject(dc,hfont);
     DrawText(dc,A,strlen(A),Rc,TA_LEFT+TA_TOP);
     SelectObject(dc, fontold);
     DeleteObject(hfont);
end;

procedure ausgabe(ziel : TCanvas);
var i,n,x,y,breite,hoehe,j,k : integer;
    pencolor,fillcolor       : TColor;
    hfont, fontold           : integer;
    fontname                 : string;
    Rec                      : TRect;
    hstep,ypos,fsize         : Integer;
begin
  with ziel do begin
     PenColor :=pen.color;
     FillColor:=brush.color;
     x:=0;
     y:=-300;
     Pen.Color :=clBlack;
     Brush.Style:=bsClear;
     Font.Height:=40;
     Font.Name  :='Times';
     SetTextAlign(handle,TA_LEFT+TA_TOP);

     Rectangle(x,y,x+60,y-1170);        //Faltrand der CD 0,6*11,7cm^2
     Rectangle(x+60,y,x+1440,y-1170);   //Rckblatt der CD 13,8*11,7cm^2
     Rectangle(x+1440,y,x+1500,y-1170); //Faltrand der CD 0,6*11,7cm^2
     Rectangle(x+1510,y,x+2710,y-1200); //Klappenblatt der CD 12*12cm^2

     //Beschriftungen der Rcken, Text 90 gedreht ausgeben
     DC_TextOut(ziel,x+50,y-50,90,FormOptions.EditCDName.Text);
     DC_TextOut(ziel,x+1490,y-50,90,FormOptions.EditCDName.Text);

     //Beschriftungen der Vorderseite
     Font.Height:=100;
     Rec:=Bounds(x+1550,y-100,1120,-900);
     DC_DrawText(ziel,rec,0,FormOptions.EditCDName.Text);
     Font.Height:=20;
     DC_TextOut(ziel,x+1600,y-1140,0,'Created by cd2html!');

     i:=0;      // aktuelles Item
     n:=0;      // Spalte
     j:=0;      // aktuelle Zeile
     k:=0;      // horizontales Einrcken nach rechts in 0,1mm
     ypos:=y-50;// aktuelle Y-Position in 0,1mm
     hstep:=1280 div FormPrintPrev.UpDown1.Position; // Spaltenbreite in 0,1mm
     While i<=MainWindow.ListView1.Items.Count-1 do
     Begin
       // Einstellungen fr Font und Einrcken bei verschiedenen
       // berschriftsgren
       Font:=AFont[MainWindow.ListView1.Items[i].StateIndex+1];
       If MainWindow.ListView1.Items[i].StateIndex=6 then k:=30
       else k:=MainWindow.ListView1.Items[i].StateIndex*3;
       Font.Height:=trunc(Font.Size*3.7606); // 1p=0,376065mm=3,76065*0,1mm
       fsize:=Font.Height+Font.Height div 2;   // bentigte Zeilenhhe
       If (ypos-fsize < y-1100) and (n<FormPrintPrev.UpDown1.Position-1) then
       Begin       // Spaltenberlauf prfen
         inc(n);
         j:=0;
         ypos:=y-50;
       end;
       If (n=FormPrintPrev.UpDown1.Position-1) and (ypos-2*fsize < y-1100) then
       Begin      // letzte Spalte
         TextOut(x+n*hstep+110+k,ypos,'...');
         pen.color  :=PenColor;
         brush.color:=FillColor;
         Exit;
       end;
       Rec:=Bounds(x+n*hstep+110+k,ypos,hstep-k-20,-fsize);
       DC_DrawText(ziel,rec,0,MainWindow.ListView1.Items[i].Caption);
       inc(i);
       inc(j);
       ypos:=ypos-fsize;
     end;
     pen.color  :=PenColor;
     brush.color:=FillColor;
  end;
end;

procedure TFormPrintPrev.paintbox1Paint(Sender: TObject);
begin
  Blattanpassen;
  Ausgabe(Paintbox1.Canvas);
end;

procedure TFormPrintPrev.FormResize(Sender: TObject);
begin
  PaintBox1.onpaint(self);
end;

procedure TFormPrintPrev.PrintClick(Sender: TObject);
begin
  printer.begindoc;
  SetMapMode(printer.canvas.handle,MM_LOMETRIC);
  ausgabe(printer.canvas);
  printer.enddoc
end;

procedure TFormPrintPrev.SettingsClick(Sender: TObject);
begin
  PrinterSetupDialog1.execute;
  PaintBox1.onpaint(self);
end;

procedure TFormPrintPrev.FormCreate(Sender: TObject);
begin
   Printer.Orientation:=poLandscape;
end;

procedure TFormPrintPrev.UpDown1Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
  PaintBox1.onpaint(self);
end;

procedure TFormPrintPrev.BtnFontClick(Sender: TObject);
var i : Integer;
begin
 With FrmFont do
 Begin
   If ShowModal = mrOK then
   Begin
     AFont[1]:=Label2.Font;
     AFont[2]:=Label3.Font;
     AFont[3]:=Label4.Font;
     AFont[4]:=Label5.Font;
     AFont[5]:=Label6.Font;
     AFont[6]:=Label7.Font;
     AFont[7]:=Label8.Font;
   end;
 end;
 PaintBox1.onpaint(self);
end;

procedure TFormPrintPrev.FormShow(Sender: TObject);
begin
   With FrmFont do
   Begin
     AFont[1]:=Label2.Font;
     AFont[2]:=Label3.Font;
     AFont[3]:=Label4.Font;
     AFont[4]:=Label5.Font;
     AFont[5]:=Label6.Font;
     AFont[6]:=Label7.Font;
     AFont[7]:=Label8.Font;
   end;
end;

procedure TFormPrintPrev.BtnSaveClick(Sender: TObject);
var MyMetaFile: TMetafile;
    MyCanvas  : TCanvas;
    dx,dy     : Integer;
begin
  dx:=2800;//GetDeviceCaps(printer.handle,horzsize);
  dy:=1500;//GetDeviceCaps(printer.handle,vertsize);
  MyMetaFile:=TMetafile.Create;
  MyMetaFile.Enhanced:=True;
  MyMetaFile.MMWidth :=dx;
  MyMetaFile.MMHeight:=dy;
  MyCanvas:=TMetafileCanvas.CreateWithComment(MyMetaFile,MyMetaFile.Handle,
                     'CD2HTML by Falk Petro',FormOptions.EditCDName.Text);
  SetWindowExtEx(MyCanvas.handle,dx,-dy,nil);
//  SetViewPortExtEx(MyCanvas.handle,dx,dy,nil);
  with MyCanvas do
  try
    Ausgabe(MyCanvas);
  finally
    Free;
  end;
  MyMetaFile.SaveToFile('c:\test.emf');
  Clipboard.Assign(MyMetaFile);
//  PaintBox1.Canvas.Draw(0,0,MyMetafile);
//  PaintBox1.Canvas.StretchDraw(PaintBox1.ClientRect,MyMetafile);
  MyMetaFile.Destroy;
end;

end.
