unit grs_dlg;

interface

uses
  WinTypes, WinProcs, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, DB, DBTables;

type
  TfdbgridSearchdlg = class(TForm)
    Panel: TPanel;
    Edit: TEdit;
    procedure EditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EditChange(Sender: TObject);
    procedure EditKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    BookMark : TBookMark;
  public
    Table : TTable;
    Field : TField;
  end;


implementation

{$R *.DFM}

procedure TfdbgridSearchdlg.EditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if(Key = VK_ESCAPE) then
    ModalResult := mrCancel;
  if(Key = VK_RETURN) then
    ModalResult := mrOk;
end;

procedure TfdbgridSearchdlg.EditChange(Sender: TObject);
begin
  if(Length(Edit.Text) = 0) then
    Table.First
  else
    with Table do  begin
      EditKey;
      FieldByName(Field.FieldName).AsString := self.Edit.Text;
      GotoNearest;
   end;
 end;

procedure TfdbgridSearchdlg.EditKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key in [#32..#255]) and (Field <> nil)
  and  not Field.IsValidChar(Key) then  begin
    MessageBeep(0);
    Key := #0;
  end;
end;

procedure TfdbgridSearchdlg.FormShow(Sender: TObject);
begin
  bookMark := Table.GetBookMark;
end;

procedure TfdbgridSearchdlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if(Modalresult = mrCancel) then
    Table.GotoBookMark(bookMark);
  Table.FreeBookMark(bookMark);
end;

end.
