unit grs_dlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, DB;

type
  TfdbgridSearchdlg = class(TForm)
    Panel: TPanel;
    Edit: TEdit;
    procedure EditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EditChange(Sender: TObject);
    procedure EditKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    BookMark : TBookMark;
  public
    DataSet : TDataSet;
    Field : TField;
    CaseInsensitive : Boolean;
  end;


implementation

{$R *.DFM}

procedure TfdbgridSearchdlg.EditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if(Key = VK_ESCAPE) then
    ModalResult := mrCancel;
  if(Key = VK_RETURN) then
    ModalResult := mrOk;
end;

procedure TfdbgridSearchdlg.EditChange(Sender: TObject);
Var
  lop : TLocateOptions;
begin
  if(Length(Edit.Text) = 0) then
    DataSet.First
  else begin
    lop := [loPartialKey];
    if (CaseInsensitive) then
      lop := lop +  [loCaseInsensitive];
    DataSet.Locate(Field.FieldName, Edit.Text, lop);
  end;
end;

procedure TfdbgridSearchdlg.EditKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key in [#32..#255]) and (Field <> nil)
  and  not Field.IsValidChar(Key) then  begin
    MessageBeep(0);
    Key := #0;
  end;
end;

procedure TfdbgridSearchdlg.FormShow(Sender: TObject);
begin
  bookMark := DataSet.GetBookMark;
end;

procedure TfdbgridSearchdlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if(Modalresult = mrCancel) then
    DataSet.GotoBookMark(bookMark);
  DataSet.FreeBookMark(bookMark);
end;

end.
