unit gsrchreg;

interface

uses
  Windows,  Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs,  gridsrch, DsgnIntf, DBGrids;


procedure Register;

implementation


type
  TDBGridSerchDataFieldProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValueList(List: TStrings);
    procedure GetValues(Proc: TGetStrProc); override;
  end;

function TDBGridSerchDataFieldProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList, paSortList, paMultiSelect];
end;

procedure TDBGridSerchDataFieldProperty.GetValueList(List: TStrings);
var
  gs : TDBGridSearch;
begin
  gs := GetComponent(0) as TDBGridSearch;
  if(gs.DBGrid <> Nil) And (TDBGrid(gs.DBGrid).DataSource <> nil) And
  (TDBGrid(gs.DBGrid).DataSource.DataSet <> nil) then
     TDBGrid(gs.DBGrid).DataSource.DataSet.GetFieldNames(List);
end;

procedure TDBGridSerchDataFieldProperty.GetValues(Proc: TGetStrProc);
var
  I: Integer;
  Values: TStringList;
begin
  Values := TStringList.Create;
  try
    GetValueList(Values);
    for I := 0 to Values.Count - 1 do Proc(Values[I]);
  finally
    Values.Free;
  end;
end;

procedure Register;
begin
  RegisterComponents('Auto', [TDBGridSearch]);
  RegisterPropertyEditor(TypeInfo(string), TDBGridSearch, 'DataField', TDBGridSerchDataFieldProperty);  
end;

end.
 