(*	Revision History
	1.0 	9-15-95	Initial release.
	1.1		10-23-96
				- If an error occured during reading ascii file post was still executed
					it is now inside the correct loop.
				- Lines in ascii file can now be LINELENGTH long (up to 65K).
			  - Now support Memo Fields!
				- A ';' in the first column is for remarks!
 				- Blank lines (no spaces!) are now ingnored.
 				- Quotes are only required if field contains seperater or delimiter
				- more escapes sequence added and are now enumerated.
				- made public busy flag (removed error 97)
				- cleaned up some possible memory leaks
				- added error codes 8,10,11
	1.2		11-6-95
				- Fixed exception if user field names did not match table (broken in 1.1)
				- Now check for too many records in text file
				- If field is too long, it is just truncated (1.1 put in "too big")
				- Added WriteEnable property.  If set to false Destination table is not
					accessed (and not needed).
				- When posting, now test for -1 index rather than string 'SKIP' to
					speed things up (a little)
				- Added a OnParse Event.  OnParse in called after parsing but before
          posting allowing the user to edit the data.
				-	Removed DoUpdate proceedure and put inline
				- Added OnPrePost Event. Called just before post to allow any calculated
					data on the same record.  Table is in "Insert" mode!
				- Added error 13 - conversion error when inserting data to table.
				- Renamed Property TickCount to NotifyCount
				-	Renamed OnTick to OnNotifyCount
				-	Moved dialog creates to the execute procedure rather than create
					so they are only created if needed.
				-	Removed unneeded FDestination.Edit as FDestination.Insert does this.
				-	Switched FDestination.Insert to FDestination.Append as this is more
					logical for non-indexed files.
				-	Removed FDestination.Post (except at end) becasue FDestination.Append
					does this if one is open.
				-	Fixed bug, RecordLimit only worked if NotifyCount > 0
				-	Progress Dialog is nolonger tied to NotifyCount. Progess is reported
					in 10% increments.
				-	Fixed bug causing missing records if length > 768
				-	Remove debug stuff left in in getline
				-	Fixed some bugs in "getline" for longlines and single record files
				- Limited memo records 32758 because it is the max for dbmemo.  Reports
					error if too long.
        -	Non-memo records are truncated at 255 char
				- Max fields is now 255 rather than 50
				- Redefined meaning of some of the error codes (Sorry folks)
				-	Added readonly propert ErrorLine to indicate line in ascii file that
					caused an error.
				- Added lowend limit (256) to linelength
				- If the last record did not end in a " it was tuncated by one char - fixed
				- Added NamesFirst property if field names are in the ascii table.
				- Made used of Integer and Word more consistant
				-	Added resource block in Execute to insure proper cleanup
					This required the addion of some flags.
				- BIG BUG/feature.  We were using the existing Tfields property of the
          Table.  If the table was missing some fields, it would cause problems.
					We now generate our OWN copy of the table.
				-	Modifed check on FFieldlist > MyTable.FieldCount to ignore skips
	1.3		11-28-95 (beta A)
				- added code to parse #26 at eof
				- if there were extra cr at end of file caused errors in reading
	1.3		11-28-95 (beta B)
				- Got rid of sloppy code in getline routine read buffer is
					sized at runtime to match LineLenth so files with long lines
					should run a little faster.
				- Progress is now monitored by bytes not records.  This eliminates
					the need to count the records first! <Darral Wagoner>
				- Progress is now in increments of 1%
	1.3 	12-2-95 (beta C)
				- If FTickCount (nofifyCount) = 0 then the cancel button on the
					progress dialog does not get called. Therefore, the button is no
					longer displayed if FTickCount = 0;
				-	Added property to change update mode of table
					mCopy - erase and replace
					mAppend - add to existing table
					mUpdate - update existing only
					mAppendUpdate - add to existing table and update existing
				- Added AbortOnKeyVoil property to allow ignoring of key violation
				- Added runtime variable KeyViolationCount to count key violations
				- Added FixedWidth property to read fixed with ascii files
					length is determined by adding a comma and with after the field
					name in fieldlist strigs.  NamesFirst does not work with fixed width
					files.
	1.3 	12-3-95 (beta D)
				- Added return variable to OnPrePost to allow cancelling a post by
					the application.
				- Added public variables to show count of appended, updated,
					and aborted.
				- Changed key in GetLine to LF rather than CR so it will work
					with UNIX files.
				- Improved parsing with escaped characters so parsing is done without
					the escaped characters involved.
	1.3 	12-4-95 (beta E)
				-	Improved handling of escapes by sacrificing some memory.
				- Made BinArray in ParseLine a constant.
	1.3		1/7/95
				-	Released

	1.4 	2/10/96
				- If last ascii record was an null, the string would be terminated
          in a coma, the last record would be skipped and the record count
          would be off by one.
				- added support of the \0 escape of null and fixed some other bugs
					with escapes in both CSV and fixed file types.
				- added EndOfRecord property.  The default is #10.  This will work with
          #13#10 or just #10.  If another value is set, all #13 and #10's are
          removed.  This allows multiline records.
				- removed restriction on using char #255 in ascii file.

	1.5		3/20/96 (beta A)
				- This will be the last 16bit version!  This version does NOT compile
        	correctly under Delphi 2.0!
				- Renamed AllTrim function to TRIM and made it local to vcl (protected)
				b Moved try in execute after variable initionalation. (An execute with
          no source file would cause an GPF in the Finally section.
				b Move some Table calles under the WriteEnable flag that were missed,
					including Post.
				b ParsedCounter is now incremented before OnParse.
				b FieldList is parsed of empty strings before it is used (so they are ignored)
				f Added error 6 if FieldList is empty.
				f Added a ShowCaption to edit caption in transfer dialog box.  Default is
 					'Tranfer Progress'
				b If an error is found in the Ascii file format, the entire record is not posted
				f Completly rewrote parsing.  Now parses on the fly rather the retreiving
   				a line and then parsing.  New parsing rules...
						* Escaped characters (if enabled) are processed inside and out of
							delimiters.
						* All characters inside delimiter are literal except:
				    	a) <delimiter><delimiter> = <delimiter>
							b) Escapes (if enabled)
							This allows for ANYTHING to be inside delimitor including CRLF!
						* Outside of delimiters, extra delimiters, seperater and #26 are not allowed
							unless escaped.
						* Extra delimiters are only allowed inside a delimiter pair if they are pair too.
						* Comment lines are ignored (begin with ;)
						* Comment line terminate it a <EndOfRecord>.
						* #26 (eof) is treated as end of file except inside quotes
						* All fields are trimmed to remove leading and trailign spaces except
            	on fields with delimiters, only spaces before the first delimiter and
							the last delimiter are trimmed. memo field are also not trimmed.
				f Memory for parsed string is now dynamic. No longer need FLineLength
          so is was removed.  Length is still limited to 65534 characters.
					Ascii file will not cancel the importing (the entire record is skipped)

			3/24/96 (beta B)
				f Enumerated error codes. So error code is now type Ta2DbError.
				f A FmtErrorCount property was added to count generic format errors when
 					MaxFmtErrors is used.  This amount to the number of lines skipped.
				f Changed AbortOnFmtError boolaen to MaxFmtErrors LongInt.  If MaxFntErros
					is 0 then all errors will be skipped.  If set to 1, it will abort on the
					first error.
				e Modified memory usage.  Read file is allway 256 byte/read.  Buffer
 					is expanded as needed.
				f Added property "ErrorFile" if not empty, writes bad records to file.
					File is always overwritten!  If there are no error, file is deleted.
        f Added compile option to disable complete boolean expression if user
 					compiled with it on.
				f Add property AbortCaption for cancel caption in progress dialog!
				f OnParse event is now called right after parsing.  It now includes
					pointer to record string, record length and NumberOfFields.  This gives
					user a chances to update the data or do their own parsing.  If NumberOfFields
					is set to 0, the record is skippped (like a comment).  If a -1 is return,
					the execute is aborted. If NumberOfFields <> ParsedList.Count a format error
					is generated. {suggestion by John Garnett}
				b ParsedCount back to being incremented after OnParse.
				e ParsedList changed from TStringList to TList (of TFieldStream)
					This effects the OnParse and OnPreParse events!
				b mUpdate did not work! Fixed. (I think this was broken in 1.4 too)
				f Limitation of 256 fields removed. New limit is limited by TList. This
					should be 16K!
				e Removed OnPreParse event as the same data is now available in the OnParse
					event.
			3/28/96 (beta C)
				- Field and Record pChar's are now global - speeds things up!
				- Expanding Buffers was basically bad code, GPF! (must have been late).  New
					routines written to use global buffers.
			  - Put Fixed fields back together (missing in beta A & B
				f Added runtime property LineCount to count lines in ascii file
				f ErrorLine now returns LineCount not parsedCount
				f	Added LineCount property to indicate total lines read.

			3/30/96 (beta D)
				f Added handy GetDatabasePath Function.
				e Remove AbortOnKeyViol property as this is covered by MaxRecordError
				- Renamed MaxFmtErrors MaxRecordErrors
				- Renamed FmtErrorCount to FieldCountErrors
				- Renamed KeyViolationCount to KeyViolationErrors
				f Added ConversionErrors runtime property
				f Added MemoErrors runtime property
				f Added ErrorField runtime property to list field with error
				f Added EmptyCount runtime property to indicate empty (or comment) lines found
				b Fixed up error counting!
					LineCount = ParsedCount + EmptyCount
					ParsedLines = AppendedCount + UpdatedCount + MemoErrors +
												ConversionErrors + KeyViolationErrors + FieldCountErrors
				e Added eMultiError to indicate at least one error was found
					when MaxRecordErrors is > 1
				f Added AnnotateErrorFile property to add annotations to each record
					written to error file.
				e Added AnsiToOEM conversions for file access.  I beleive strings to and
					from a table will be converted by default on memo and string fields.
        b Fixed broken MemoFields. (not sure when it broke)
        f Now do a prefilter on numbers to remove # and thousand separatots
  				Only numbers and DecimalSepartor are allowed.  Also () are turned
					to negitive numbers.
        - Fixed bug in doing recordcount with FixedFields (Hang!)
        - Fixed so last record in FixedField did not return #13 too.
        e On fixed fields, the last field may be shorter than width specified
        	without generating an error.
        f Added some standard date formats (dfMDY, dfDMY, dfYMD, dfBCD)
        	dfBCD (CCYYMMDD) only works with ftDate fields.
          {thanks to JPires, Matthew McDermott}
        f Added user defined decimal and date seperators.
      (released beta D 4/1/96)

			4/6/96 (beta E)
      	e Removed need for exclusive access unless doing an mCopy
        b BIG bug, mAppend and mUpdate only worked (correclty) with string
          fields! Poor used of FindKey.  Now used SetKey...
        f	Using SetKey so now we can support indexes across multiple fields
        b Fixed ErrorField as it was off by 1
        f	Copied IndexName from orig table so it will work with DBF tables
        - Tested with DBF tables, supports:
        	CHARACTER,FLOAT,NUMBER,LOGICAL,MEMO,DATE fields.
        - Found that AsString will convert $xxxx to integers/words so
        	modified number preping to not strip '$' on this fields
      (released beta E 4/7/95)

      4/25/96 (beta F)
      	f Added minimal export (DB2Ascii)
        e Changed Trim and GetErrorString to Global functions

      4/29/96 (beta G)
      	e Change name of objects to generic words (Ta2db => TDBcvt)
        e Change GetErrorString back to separage calls for TAscii2DB
          and TDB2Ascii.

      5/14/96 (beta H)
      	e Added ShowDlg stuff to TDB2Ascii
        e	Added AlwayQuote propert to TDB2Ascii
        e Added NotifyCount and OnNofityCount to TDB2Ascii
        b	Made EndOfRecord work (#13 = #10#13)
        b Added StopExecute function
        e Added WrittenCount

      5/14/96 (beta I)
      	fixed typo in TParseEvent delclaration
        moved all history to its own file

			9/1/96
				change constant Version to DBcvtVersion
				moved DefRecLength to Implementation section
				added property AllowComments
				release version 1.5

		Things to add to TAscii2DB (some day):
		- autocreate of table if it does not exist
    - direct calls to BDE to speed up?
		- use database width as default!
		- GUI field list generator
    - Add Update (if its there)/Append (if it not)/Purge (if not is ascii file) mode!
		- make comment line optional

   	Things to add to TDB2Ascii (some day)
		- add support for ftMemo
    - add escapes
    - add date format stuff
    - add RecordLimit?
    - add FixedWidth?
    - add "smart delimitor"
    - add GUI fields editor?

***
	Bugs ?
 		- add check on max num of fields = 16380
		- should we get and pass TDataset not TTable?
    - What more should be done about OEMtoANSI stuff?
*)