unit pentium;
// Adapted on article "A TestJig Tool for Pentium Optimization" by S. Durham
// C/C++ User Journal (Dec. 1996) by Max

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, uMemObj, uPentium;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    CheckBox1: TCheckBox;
    PentiumTimer1: TPentiumTimer;
    procedure PentiumTimer1TestFunction(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure PentiumTimer1CacheHeath(Sender: TObject);
    procedure PentiumTimer1EndTest(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  myMem : TMemBlock;
 x,test : Integer;
 ptr : pointer;

implementation

{$R *.DFM}

// Place code to be tested in OnTestFunction...
procedure TForm1.PentiumTimer1TestFunction(Sender: TObject);
var
 tmp : ^integer;
begin
     tmp := PentiumTimer1.GetPointer(0);
     For x:= 0 to 3999 do
       begin
         test := test + tmp^;
         inc(tmp);
       end;
end;



procedure TForm1.Button1Click(Sender: TObject);
begin
     PentiumTimer1.ColdCache := CheckBox1.Checked;

     // Even if the cache is filled with random numbers our test function
     // needs memory to work on
     if PentiumTimer1.ColdCache then
        PentiumTimer1.AllocateMemory(4000*sizeof(Integer));


     PentiumTimer1.Active := True;

     Label1.Caption := 'Cycles = '+IntTostr(PentiumTimer1.TimeCount);

end;

// Place code to be executed before test start in OnHeatCache
procedure TForm1.PentiumTimer1CacheHeath(Sender: TObject);
begin
     PentiumTimer1.AllocateMemory(4000*sizeof(Integer));
end;


// Place code to be executed at the end of the test in OnEndTest
procedure TForm1.PentiumTimer1EndTest(Sender: TObject);
begin
     PentiumTimer1.FreeAll;
end;

end.
