unit Mssql32;

{ Import routines and some constants for MS SQL server.
  32-bit only... Use Freely, but I warranty nothing.
  Ed Lyk  1997-08-27
  elyk@sprynet.com
}

interface

uses
  SysUtils, Windows, Messages, Classes, Forms, Dialogs;

type

  DBPROCESS = Pointer;
  LOGINREC = Pointer; 
  DBCURSOR = Pointer; 

const
  DBSETHOST  = 1;
  DBSETUSER  = 2;
  DBSETPWD   = 3;
  DBSETAPP   = 4;
  DBSETID    = 5;
  DBSETLANG  = 6;
  DBSUCCEED  = 1;
  DBFAIL     = 0;
  INTBIND    = 3;
  CHARBIND   = 4;
  BINARYBIND = 5;
  DATETIMEBIND = 7;
  STRINGBIND = 10;
  NTBSTRINGBIND = 11;
  VARYCHARBIND = 12;
  VARYBINBIND = 13;
  MORE_ROWS   = -1;
  NO_MORE_ROWS = -2;
  BUF_FULL  = -3;
  NO_MORE_RESULTS = 2;
  REG_ROW = MORE_ROWS;
  DBRPCRETURN = 1;
  SQLTEXT = $23;
  SQLVARBINARY = $25;
  SQLVARCHAR = $27;
  SQLBINARY = $2d;
  SQLIMAGE =  $22;
  SQLCHAR =  $2f;
  SQLINT1 =  $30;
  SQLINT2 = $34;
  SQLINT4 = $38;
  SQLINTN = $26;
  SQLDATETIME = $3d;
  SQLFLT8 = $3e;
  SQLFLTN = $6d;
  SQLMONEYN = $6e;
  SQLDATETIMN = $6f;

function dblogin: LOGINREC; stdcall;
function dbopen(login: LOGINREC; ServerName: PChar): DBPROCESS; stdcall;
function dbinit: PChar; stdcall;
procedure dbexit; stdcall;
function dbsetlname(login: LOGINREC; val: PChar; item: Integer): Integer; stdcall;
procedure dbfreelogin(login: LOGINREC); stdcall;
procedure dbclose(proc: DBPROCESS); stdcall;
function dbcmd(proc: DBPROCESS; cmd: PChar): Integer; stdcall;
function dbsqlexec(proc: DBPROCESS): Integer; stdcall;
function dbresults(proc: DBPROCESS): Integer; stdcall;
function dbbind(proc: DBPROCESS; Column, VarType, VarLen: Integer; VarAddr: Pointer):Integer; stdcall;
function dbnextrow(proc: DBPROCESS): Integer; stdcall;
function dbdata(proc: DBPROCESS; column: Integer): Pointer; stdcall;
function dbdatlen(proc: DBPROCESS; column: Integer): Integer; stdcall;
function dbrpcinit(proc: DBPROCESS; ProcName: PChar; Options: Integer): Integer; stdcall;
function dbrpcparam(proc: DBPROCESS; paramname: PChar; status: Byte; ptype: Integer; maxlen, datalen: Integer;
                    value: Pointer): Integer; stdcall;
function dbrpcsend(proc: DBPROCESS): Integer; stdcall;
function dbsqlok(proc: DBPROCESS): Integer; stdcall;
function dbretdata(proc: DBPROCESS; column: Integer): Pointer; stdcall;
function dbrpcexec(proc: DBPROCESS): Integer; stdcall;
function dbuse(proc: DBPROCESS; DBName: PChar): Integer; stdcall;

implementation

function dblogin: LOGINREC; external 'ntwdblib.dll';
function dbopen(login: LOGINREC; ServerName: PChar): DBPROCESS;external 'ntwdblib.dll';
function dbinit: PChar; external 'ntwdblib.dll';
procedure dbexit; external 'ntwdblib.dll';
function dbsetlname(login: LOGINREC; val: PChar; item: Integer): Integer; external 'ntwdblib.dll';
procedure dbfreelogin(login: LOGINREC); external 'ntwdblib.dll';
procedure dbclose(proc: DBPROCESS); external 'ntwdblib.dll';
function dbcmd(proc: DBPROCESS; cmd: PChar): Integer; external 'ntwdblib.dll';
function dbsqlexec(proc: DBPROCESS): Integer; external 'ntwdblib.dll';
function dbresults(proc: DBPROCESS): Integer; external 'ntwdblib.dll';
function dbbind(proc: DBPROCESS; Column, VarType, VarLen: Integer; VarAddr: Pointer):Integer;
                                external 'ntwdblib.dll';
function dbnextrow(proc: DBPROCESS): Integer; external 'ntwdblib.dll';
function dbdata(proc: DBPROCESS; column: Integer): Pointer; external 'ntwdblib.dll';
function dbdatlen(proc: DBPROCESS; column: Integer): Integer; external 'ntwdblib.dll';
function dbrpcinit(proc: DBPROCESS; ProcName: PChar; Options: Integer): Integer;
                external 'ntwdblib.dll';
function dbrpcparam(proc: DBPROCESS; paramname: PChar; status: Byte; ptype: Integer; maxlen, datalen: Integer;
                    value: Pointer): Integer; external 'ntwdblib.dll';
function dbrpcsend(proc: DBPROCESS): Integer; external 'ntwdblib.dll';
function dbsqlok(proc: DBPROCESS): Integer; external 'ntwdblib.dll';
function dbretdata(proc: DBPROCESS; column: Integer): Pointer; external 'ntwdblib.dll';
function dbrpcexec(proc: DBPROCESS): Integer; external 'ntwdblib.dll';
function dbuse(proc: DBPROCESS; DBName: PChar): Integer; external 'ntwdblib.dll';

end.
