// MyOle ver. 0.90
// Author: Matej Trampus, Slovenija
// E-MAIL:
//   - Matej.Trampus@kiss.uni-lj.si
// See readme.txt for details.
//

unit myOle;

// BUGS:
//  - TMyOle.Close is not correctly implemented
//  - TMyOle.IsDirty not implemented (it always claims, that object has *not* changed since last save)
//  - See TMyOle.Test procedure. I can not resize the object without GPF - iOleInPlaceSite.OnPosRectChange(r)
//
// HISTORY
//  -- ver 0.91
//  26.10.1996 - InitFromData was not implemented [correctly] in 0.90. Now return E_NOTIMPL
//               GetUserType changed
//             - Storage property changed to GetStorage procedure, so you are reminded to
//               call storage.Release, when you do not need it anymore
//               The same happend to persistStorage property
//             - added HasStorage property

//  25.10.1996 Added TDelphiOle.Release. Removed dummy Seek in TMyPersistStorage.Load

// KAJ JE Z DEFFERED COPY. Ko hoce kopirat objekt moras narediti snapshot
// trenutnega stanja in mu ga podtakniti pri dejanskem Copy. (med QueryFormat
// in dejanskim COpy se lahkonotranje stanje objekta spremeni, uporabnik
// pa hoce tisto staro stanje (v trenutku, ko si dal na clipboard)
//

interface
uses windows,ole2,olectnrs,dataObject,graphics,classes,controls;

type
  TViewObject=class;
  TDelphiOle=class;
  TDelphiOleClass=class of TDelphiOle;
  TMyPersistStorage=class;

  TMyOle = class(IOleObject)
  private
    fRefCount:longint;
    fClientSite:IOleClientSite;
    fViewObject:TViewObject;

    fPersistStorage:TMyPersistStorage;
    fOleAdviseHolder:IOleAdviseHolder;
    fObjHandle:integer; // internal handle used for debbuging
  protected
    ftheObject:TDelphiOle; // we *do* own the object
    fDataObject:TMyDataObject;
    function  GetHasStorage:boolean;
    function  GetContainerControl:TWInControl;
  public
    constructor Create(ObjectClass:TDelphiOleClass);
    destructor Destroy; override;
    function QueryInterface(const iid: TIID; var obj): HResult; override;
    function AddRef: Longint; override;
    function Release: Longint; override;

    function SetClientSite(clientSite: IOleClientSite): HResult;  override;
    function GetClientSite(var clientSite: IOleClientSite): HResult; override;
    function SetHostNames(szContainerApp: POleStr; szContainerObj: POleStr): HResult; override;
    function Close(dwSaveOption: Longint): HResult; override;
    function SetMoniker(dwWhichMoniker: Longint; mk: IMoniker): HResult;  override;
    function GetMoniker(dwAssign: Longint; dwWhichMoniker: Longint;  var mk: IMoniker): HResult; override;
    function InitFromData(dataObject: IDataObject; fCreation: BOOL; dwReserved: Longint): HResult; override;
    function GetClipboardData(dwReserved: Longint; var dataObject: IDataObject): HResult; override;
    function DoVerb(iVerb: Longint; msg: PMsg; activeSite: IOleClientSite; lindex: Longint; hwndParent: HWND; const posRect: TRect): HResult;      override;
    function EnumVerbs(var enumOleVerb: IEnumOleVerb): HResult; override;
    function Update: HResult; override;
    function IsUpToDate: HResult; override;
    function GetUserClassID(var clsid: TCLSID): HResult; override;
    function GetUserType(dwFormOfType: Longint; var pszUserType: POleStr): HResult; override;
    function SetExtent(dwDrawAspect: Longint; const size: TPoint): HResult;   override;
    function GetExtent(dwDrawAspect: Longint; var size: TPoint): HResult;   override;
    function Advise(advSink: IAdviseSink; var dwConnection: Longint): HResult;   override;
    function Unadvise(dwConnection: Longint): HResult; override;
    function EnumAdvise(var enumAdv1: IEnumStatData): HResult; override;
    function GetMiscStatus(dwAspect: Longint; var dwStatus: Longint): HResult;   override;
    function SetColorScheme(var logpal: TLogPalette): HResult; override;
    // following functions are used for debugging and are not part of IOleObject interface
    function GetObjHandle:integer;
    // following functions are not part of IOleObject interface
    procedure ViewChanged(dwaspect:DWORD);
    procedure GetStorage(var storage:IStorage);
    procedure GetPersistStorage(var persistStorage:IPersistStorage);

    property theObject:TDelphiOle read ftheObject;
    property hasStorage:boolean read GetHasStorage;
    property ContainerControl:TWinControl read GetContainerControl; // valid only for Delphi control, otherwise nil
    procedure Test;
  end;

  TViewObject = class(IViewObject)
     private
      fUnkOuter:TMyOle;       // pointer to outer object
      fRefCount:longint;
      fAdviseSink:IADviseSink;
     public
       constructor Create(UnkOuter: TMyOle);
       destructor Destroy; override;
       function QueryInterface(const iid: TIID; var obj): HResult; override;
       function AddRef: Longint; override;
       function Release: Longint; override;

       function Draw(dwDrawAspect: Longint; lindex: Longint; pvAspect: Pointer;
         ptd: PDVTargetDevice; hicTargetDev: HDC; hdcDraw: HDC;
         prcBounds: PRect; prcWBounds: PRect; fnContinue: TContinueFunc;
         dwContinue: Longint): HResult; override;
       function GetColorSet(dwDrawAspect: Longint; lindex: Longint;
         pvAspect: Pointer; ptd: PDVTargetDevice; hicTargetDev: HDC;
         var colorSet: PLogPalette): HResult; override;
       function Freeze(dwDrawAspect: Longint; lindex: Longint; pvAspect: Pointer;
         var dwFreeze: Longint): HResult; override;
       function Unfreeze(dwFreeze: Longint): HResult; override;
       function SetAdvise(aspects: Longint; advf: Longint;
         advSink: IAdviseSink): HResult; override;
       function GetAdvise(pAspects: PLongint; pAdvf: PLongint;
         var advSink: IAdviseSink): HResult; override;
  end;


  TDropTarget=class(IDropTarget) // not used
   private
     fRefCount:longint;
   public
    constructor create;
    function QueryInterface(const iid: TIID; var obj): HResult; override;
    function AddRef: Longint; override;
    function Release: Longint; override;
    function DragEnter(dataObj: IDataObject; grfKeyState: Longint;const pt: TPoint; var dwEffect: Longint): HResult; override;
    function DragOver(grfKeyState: Longint; const pt: TPoint; var dwEffect: Longint): HResult; override;
    function DragLeave: HResult; override;
    function Drop(dataObj: IDataObject; grfKeyState: Longint; const pt: TPoint;var dwEffect: Longint): HResult; override;
  end;


    { IPersistStorage interface }

// TMyPersistStorage can be only used as part of another object. If you would like to change this,
// you have to change following functions: QueyInterface, AddRef and Relase

  TMyPersistStorage = class(IPersistStorage)
  private
    FRefCount: Integer;
    fOleOuter:TMyOle;             // pointer to outer object
    fStorage:IStorage;
    fStream:IStream;
    ds:TOleStream;
  public
    constructor Create(OleOuter: TMyOle);  // iunknown methods
    destructor Destroy; override;
    function QueryInterface(const iid: TIID; var obj): HResult; override;
    function AddRef: Longint; override;
    function Release: Longint; override;
    function GetClassID(var classID: TCLSID): HResult; override; // IPersist method
    function IsDirty: HResult; override;                // IPersistStorage methods
    function InitNew(stg: IStorage): HResult; override;
    function Load(stg: IStorage): HResult; override;
    function Save(stgSave: IStorage; fSameAsLoad: BOOL): HResult; override;
    function SaveCompleted(stgNew: IStorage): HResult; override;
    function HandsOffStorage: HResult; override;
  end;


  TDelphiOle=class  // maybe it would be beter TDelphiOle(TComponent), so that we can use WriteComponent to
    private         // save published properties
      fOwner:TMyOle;
      procedure SetOwner(newOwner:TMyOle);
    protected
      procedure   ViewChanged(dwAspect:DWORD);
    public
      class function  GetCLSID:TCLSID; virtual; abstract;
      class function  GetUserType:string; virtual; abstract;
      class function  GetProgID:string; virtual; abstract;
      constructor Create; virtual; // must be virtual for TClassFactory to work
      procedure   Changed; virtual;
      procedure   Draw(dwDrawAspect: Longint;const bounds:TRect;Canvas:TCanvas); virtual; abstract;
      procedure   Save(str:TStream); virtual; abstract;
      procedure   Load(str:TStream); virtual; abstract;
      function    GetExtent(dwDrawAspect: Longint):TPoint; virtual; abstract; // result in HIMETRIC
      function    DoVerb(iVerb: Longint): HResult; virtual; abstract;
      procedure   Release;
      property    owner:TMyOle read fOwner write SetOwner;
  end;


var _LastCreatedMyOle:TMyOle;
procedure LastAdviseChange;

function HimetricToPixels(const P: TPoint): TPoint; // from oleCtnrs.pas
function PixelsToHimetric(const P: TPoint): TPoint; // from oleCtnrs.pas


var _TMyOleCount:integer; // number of TMyOle objects
implementation

uses debugMemo1,sysutils,dialogs,stdctrls,comctrls{,myOleContainer};
var
    _enHandle:integer;
     PixPerInch: TPoint; // for HiMetricToPixel
const errCantChangeOwner='Can not change owner';


procedure LastAdviseChange;
var a:IAdviseSink;
begin
 if _LastCreatedMyOle=nil then debug('LastAdviseChange: No last MyOle!')
 else begin
   a:=_LastCreatedMyOle.fViewObject.fAdviseSink;
   if a<>nil then begin
     a.AddRef;
       a.OnViewChange(DVASPECT_CONTENT,-1);
     a.Release;
   end else debug('LastAdviseChange: No AdviseSink')

 end;
end;

{ Convert point from himetric to pixels } // from oleCtnrs.pas
function HimetricToPixels(const P: TPoint): TPoint;
begin
  Result.X := MulDiv(P.X, PixPerInch.X, 2540);
  Result.Y := MulDiv(P.Y, PixPerInch.Y, 2540);
end;

{ Convert point from pixels to himetric } // from oleCtnrs.pas
function PixelsToHimetric(const P: TPoint): TPoint;
begin
  Result.X := MulDiv(P.X, 2540, PixPerInch.X);
  Result.Y := MulDiv(P.Y, 2540, PixPerInch.Y);
end;

// TMyOle supports following aggregated interfaces:
//  - IViewObject
//  - IDataObject
//  - IPersistStorage
// Those interfaces are implemented with coresponding Txxxx objects.
// We are also doing reference count in inner objects, although inner object's reference
// count in never used.


constructor TMyOle.Create(ObjectClass:TDelphiOleClass);
begin
   fObjHandle:=_enHandle; inc(_enHandle);
   debug2(self,'Create');
   FRefCount := 1;
   fClientSite:=nil; fOleAdviseHolder:=nil; // neccessary?
   fViewObject:=TViewObject.Create(Self);
   fDataObject:=TMyDataObject.Create(self);
   fPersistStorage:=TMyPersistStorage.Create(self);
   _LastCreatedMyOle:=self;
   fTheObject:=ObjectClass.Create; fTheObject.owner:=self;
   inc(_TMyOleCount); debug('*Create TMyOleCount='+intToStr(_TMyOleCount));
end;


destructor TMyOle.destroy;
begin
  debug2(self,'destroy');
  // I am not following IOL2 guidelines here because I know, that all inner objects are
  // local native Delphi objects.

(*  //inc(fRefCount,4);  // artifical reference count prevents following lines from calling .Destroy again
                       // any number greather than nuber of aggregated objects could be used
  {if fViewObject<>nil     then }fViewObject.Free; // fViewObject.release;     // fRefCount=3
  debug('Zdaj pa data!');
  {if fDataObject<>nil     then }fDataObject.Free; // fDataObject.Release;     // fRefCount=2
  {if fPersistStorage<>nil then }fPersistStorage.Free; // fPersistStorage.Release; // fRefCount=1
  // fRefCount:=0; // we don't need this line, because we will be destroyed in a momnet
*)
  fDataObject.Free;

  fPersistStorage.Free;
  fViewObject.Free;

  if fClientSite<>nil      then fClientSite.release;
  if fOleAdviseHolder<>nil then fOleAdviseHolder.release;
  dec(_TMyOleCount); debug('*destroy TMyOleCount='+intToStr(_TMyOleCount));
end;

function TMyOle.QueryInterface(const iid: TIID; var obj): HResult;
var  p:IUnknown;
begin
  p:=nil;
    if IsEqualIID(iid, IID_IUnknown) or IsEqualIID(iid, IID_IOleObject) then p:=self
  else if IsEqualIID(iid, IID_IViewObject)     then p:=fViewObject
  else if IsEqualIID(iid, IID_IDataObject)     then p:=fDataObject
  else if IsEqualIID(iid, IID_IPersistStorage) then p:=fPersistStorage;

 Pointer(obj) := P;
  if P = nil then begin debug2(self,'not suported: '+iid2String(iid)); Result := E_NOINTERFACE end
  else  begin
    debug2(self,'QueryInterface + '+iid2String(iid)+' '+p.ClassName);
    P.AddRef; // !!!! We are doing counnting for aggregated object too !
    Result := S_OK;
  end;
end;

function TmyOle.AddRef: Longint;
begin
  Inc(FRefCount);
  debug2(self,'Addref - now '+intToStr(fRefCOunt));
  Result := FRefCount;
end;

function TmyOle.Release: Longint;
begin
  Dec(FRefCount);
  debug2(self,'Release - now='+intToStr(FRefCount));
  Result := FRefCount;
  if Result = 0 then Free;
end;

procedure TMyOle.Test;
var r:TRect; ipSite:IOleInPlaceSite;
begin
 if (fClientSite<>nil) and (fClientSite.QueryInterface(IID_IOleInPlaceSite,ipSite)=S_OK) then begin
   r.Left:=110; r.top:=200; r.right:=120; r.Bottom:=200;
   debug2(self,'OnPoRectChange');
   ipSite.OnPosRectChange(r); // THIS LINE CAUESES GPF. WHY???
//   debug2(self,intToStr(ipSite.CanInPlaceActivate));
//   debug2(self,'uspel');
   ipSite.Release;
 end;
end;

function TMyOle.SetClientSite(clientSite: IOleClientSite): HResult;
begin
 debug2(self,format('SetClientSite %p',[pointer(clientSite)]));
 if fClientSite<>nil then fClientSite.Release; // release old clinet site
 fClientSite:=clientSite; if fclientSite<>nil then fClientSite.Addref;
// if fclientSite<>nil then viewChanged(DVASPECT_CONTENT); To pomaga le pri mojem insert
 result:=S_OK;
end;

function TMyOle.GetClientSite(var clientSite: IOleClientSite): HResult;
begin
  debug2(self,'GetClientSite');
  clientSite:=fClientSite;
  if fClientSite<>nil then fClientSite.AddRef; // Caller will releaseObject
  result:=s_ok;
end;

function TMyOle.SetHostNames(szContainerApp: POleStr; szContainerObj: POleStr): HResult;
begin
  debug2(self,'setHostNames '+wideCharToString(szContainerApp)+' '+wideCharToString(szContainerApp));
 result:=S_OK;
end;

function TMyOle.Close(dwSaveOption: Longint): HResult;
begin
  // NOT CORECTLY IMPLEMENTED!!! (See online help, IOLE2)
  debug2(self,'Close ');
  // if we have been changed we should call IOleClientSite.SaveObject (see help for .Close)
  // we should send IDataObjectDadvise needded
  // we do not onw clipboard, so we do not call OleFlushClipboard

  // IOleCLientSite.OnShowWindow not needed, because we do not have seperate window

  // IAdvise.OnClose

   if foleAdviseHolder<> nil then begin debug2(self,'Sending OnClose'); foleAdviseHolder.SendOnClose; end;
  // CoDisconnet object. Not needed bacuse we are not remote???

  result:=S_OK;
end;

function TMyOle.SetMoniker(dwWhichMoniker: Longint; mk: IMoniker): HResult;
begin
  debug2(self,'SetMoniker NOT IMPLEMENTED');
  result:=E_NOTIMPL; // From inside ole 2
end;

function TMyOle.GetMoniker(dwAssign: Longint; dwWhichMoniker: Longint;  var mk: IMoniker): HResult;
begin
  debug2(self,'GetMoniker NOT IMPLEMENTED');
  mk:=nil;
  result:=E_NOTIMPL; // From inside ole 2
end;

function TMyOle.InitFromData(dataObject: IDataObject; fCreation: BOOL; dwReserved: Longint): HResult;
var formatEtc:TFormatEtc; stgMedium:TStgMedium;
begin
  debug2(self,'InitFromData - not E_NOTIMPL'); result:=E_NOTIMPL;
(*
  debug2(self,'InitFromData '+intToStr(integer(dataObject))+' '+intToStr(integer(fCreation)));
  result:=S_OK;
  if DataObject=nil then begin result:=S_OK; exit; end; // we are capable of initializating object from data

  FormatEtc.cfFormat := CFDelphiObjectData;
  FormatEtc.ptd := nil;
  FormatEtc.dwAspect := DVASPECT_CONTENT;
  FormatEtc.lIndex := -1;
  FormatEtc.tymed := TYMED_HGLOBAL;

  if DataObject.GetData(formatetc,stgMedium)=S_OK then begin
    debug2(self,'InitFromData: Mora sprostiti medij????');
  end else begin
    result:=S_FALSE;
    debug2(self,'InitFromData: GetData failed!');
  end;
*)
end;

function TMyOle.GetClipboardData(dwReserved: Longint; var dataObject: IDataObject): HResult;
begin
   debug2(self,'GetClipboardData - returning data object');
   dataObject:=fDataObject;  fDataObject.AddRef; // [out] parameter
   result:=S_OK;
end;

function TMyOle.DoVerb(iVerb: Longint; msg: PMsg; activeSite: IOleClientSite; lindex: Longint; hwndParent: HWND; const posRect: TRect): HResult;
begin
  debug2(self,'DoVerb '+intToSTr(iVerb));
  result:=theObject.DoVerb(iVerb);
end;

function TMyOle.EnumVerbs(var enumOleVerb: IEnumOleVerb): HResult;
begin
  debug2(self,'EnumVerbs - no verbs ');
  result:=OLEOBJ_E_NOVERBS;
end;

function TMyOle.Update: HResult;
begin
  debug2(self,'Update - all is up to date ');
  result:=S_OK;
end;

function TMyOle.IsUpToDate: HResult;
begin
  debug2(self,'isUpToDate');
  result:=S_OK;
end;

function TMyOle.GetUserClassID(var clsid: TCLSID): HResult;
begin
   clsid:=theObject.GetCLSID;
   debug2(self,'GetUserClassID ret='+iid2String(clsid));
   result:=S_OK;
end;

function TMyOle.GetUserType(dwFormOfType: Longint; var pszUserType: POleStr): HResult;
begin
   debug2(self,'GetUserType - returning user type');
   result:=OleRegGetUserType(theObject.GetClsid,dwFormOfType,pszUserType);
   //debug2(self,wideCharToString(pszUserType));
end;

function TMyOle.SetExtent(dwDrawAspect: Longint; const size: TPoint): HResult;
begin
   debug2(self,format('SetExtent (%d,%d)- fixed size E_FAIL',[size.x,size.y]));
   result:=E_FAIL;
end;

function TMyOle.GetExtent(dwDrawAspect: Longint; var size: TPoint): HResult;
begin
// if containerControl=nil then begin
   debug2(self,'getExtent'+intToStr(dwDrawAspect));
   size:=theObject.GetExtent(dwDrawAspect);
   result:=s_ok;
end;

function TMyOle.Advise(advSink: IAdviseSink; var dwConnection: Longint): HResult;
begin
  if foleAdviseHolder=nil then begin
    result:=CreateOleAdviseHolder(fOleAdviseHolder);
    debug2(self,'Advise - Creating default holder');
    if result<>S_OK then exit;
  end;
  result:=fOleAdviseHolder.Advise(advSink,dwConnection);
  debug2(self,'Advise - Delegated handler returned '+intToStr(result));
end;

function TMyOle.Unadvise(dwConnection: Longint): HResult;
begin
  debug2(self,'UnAdvise - Delegating to default holder');
  if fOleAdviseHolder<>nil then
    result:=fOleAdviseHolder.Unadvise(dwConnection)
  else result:=E_FAIL;
end;

function TMyOle.EnumAdvise(var enumAdv1: IEnumStatData): HResult;
begin
  debug2(self,'EnumAdvise - Delegating to default holder');
  if fOleAdviseHolder<>nil then
    result:=fOleAdviseHolder.EnumAdvise(enumAdv1)
  else result:=E_FAIL;
end;

function TMyOle.GetMiscStatus(dwAspect: Longint; var dwStatus: Longint): HResult;
begin
debug2(self,'GetMiscStatus -rendering idnependet');
 dwStatus:=OLEMISC_RENDERINGISDEVICEINDEPENDENT;
 result:=S_OK;
end;

function TMyOle.SetColorScheme(var logpal: TLogPalette): HResult;
begin
  debug2(self,'SetColorScheme - notImp');
  result:=E_NOTIMPL; // from inside ole 2
end;

// non-IOleObject routines
procedure TMyOle.ViewChanged(dwaspect:DWORD);
begin
  if fViewObject.fAdviseSink<>nil then fViewObject.fAdviseSink.OnViewChange(dwAspect,-1);
end;

// property access
function TMyOle.GetObjHandle:integer;
begin
  result:=fObjHandle;
end;

function  TMyOle.GetHasStorage:boolean;
begin
  result:=fPersistStorage.fStorage<>nil;
end;
  
procedure TMyOle.GetStorage(var storage:IStorage);
begin
  storage:=fPersistStorage.fStorage; storage.AddRef;
end;

procedure TMyOle.GetPersistStorage(var persistStorage:IPersistStorage);
begin
  persistStorage:=fPersistStorage; persistStorage.AddRef;
end;
function TMyOle.GetContainerControl:TWinControl;
var h:hwnd; ipSite:IOleInPlaceSite;
begin
 // IN FOLLOWING VERSION, THE POINTER WILL BE CACHED (recaculated in SetClientSite)
 result:=nil;
 if (fClientSite<>nil) and (fClientSite.QueryInterface(IID_IOleInPlaceSite,ipSite)=S_OK) then begin
   ipSite.GetWindow(h);
   result:=findControl(h);
   ipSite.Release;
 end;
end;

////////////////////////////////////////////////////////////////////////////////
// IVIEWObject
////////////////////////////////////////////////////////////////////////////////

constructor TViewObject.Create(UnkOuter: TMyOle);
begin
 debug2(self,'Create');
 fRefCount:=1; // .. the outer object should not explicitly call addref after TMyDataObject.Create
 fUnkOuter:=UnkOuter;
end;

destructor TViewObject.destroy;
begin
  debug2(self,'Destroy');
  if fAdviseSink<>nil then fAdviseSink.release;
end;

function TViewObject.AddRef: Longint;
begin
  debug2(self,'AddRef - delegating to outer');
  Inc(FRefCount);
  result:=fUnkOUter.AddRef; // delegates call to outer object
end;

function TViewObject.Release: Longint;
begin
  debug2(self,'Release- delegating to outer');
  Dec(FRefCount);
  Result := fUnkOuter.Release; // delegates call to outer object
end;

function TViewObject.QueryInterface(const iid: TIID; var obj): HResult;
begin
  debug2(self,'QueryInterface -delegating to outer');
  result:=fUnkOuter.QueryInterface(iid,obj); // delegates call to outer object
end;

function TViewObject.Draw(dwDrawAspect: Longint; lindex: Longint; pvAspect: Pointer;
  ptd: PDVTargetDevice; hicTargetDev: HDC; hdcDraw: HDC;
  prcBounds: PRect; prcWBounds: PRect; fnContinue: TContinueFunc;
  dwContinue: Longint): HResult;
var canvas:Tcanvas;
begin
  debug2(self,'Draw');
  // we should check other parameters too, but for now, we handle only drawing to screen
  canvas:=Tcanvas.Create;
  canvas.Handle:=hdcDraw;

  if (fUnkOuter<>nil) and (fUnkOuter.theObject<>nil) then
      fUnkOuter.theObject.Draw(dwDrawAspect,prcBounds^,canvas);

  canvas.Free;
  result:=S_OK;
end;

function TViewObject.GetColorSet(dwDrawAspect: Longint; lindex: Longint;
  pvAspect: Pointer; ptd: PDVTargetDevice; hicTargetDev: HDC;
  var colorSet: PLogPalette): HResult;
begin
 debug2(self,'GetCOlorSet '+intToStr(dwDrawAspect)+' '+intToStr(longint(pointer(ptd))));
 colorset:=nil;
 result:=S_FALSE;
end;

function TViewObject.Freeze(dwDrawAspect: Longint; lindex: Longint; pvAspect: Pointer;
  var dwFreeze: Longint): HResult;
begin
  debug2(self,'Freeze - NotImp');
  dwFreeze:=0;
  result:=S_OK;
end;

function TViewObject.Unfreeze(dwFreeze: Longint): HResult;
begin
  debug2(self,'UnFreze - NotImp');
  result:=S_OK;
end;

function TViewObject.SetAdvise(aspects: Longint; advf: Longint;
  advSink: IAdviseSink): HResult;
begin
  debug2(self,'Set advise');
  // ali je potrebno za vsak aspect posebaj
  if fAdviseSink<>nil then fAdviseSink.release; // free old one
  fadviseSink:=advSink; if fAdviseSink<>nil then fAdviseSink.AddRef;
  debug2(self,'setAdvise S_OK');
  result:=S_OK; //OLE_E_ADVISENOTSUPPORTED;
end;

function TViewObject.GetAdvise(pAspects: PLongint; pAdvf: PLongint;
  var advSink: IAdviseSink): HResult;
begin
  debug2(self,'GetAdvise NotImpl - returning OK !!!! ****POPRAVI********');
  advSink:=nil;
  result:=s_ok;
end;

////////////////////////////////////////////////////////////////////////////////
/////   TMyPersistStorage
////////////////////////////////////////////////////////////////////////////////
constructor TMyPersistStorage.Create(OleOuter:TMyOle);
begin
  debug2(self,'Create');
  fRefCount:=1; // Object who created us with this Delphi Constructor *must not*
                // explicitly call AddRef. IOL2 uses different technique
  ds:=TOleStream.Create(nil); // precreate, so we do not consume memory during .Save
  fOleOuter:=OleOuter;
end;

destructor TMyPersistStorage.destroy;
begin
 ds.Free;
 debug2(self,'Destroy');
end;

function TMyPersistStorage.QueryInterface(const iid: TIID; var obj): HResult;
begin
  debug2(self,'QueryInterface -delegating to outer');
  result:=fOleOuter.QueryInterface(iid,obj); // delegates call to outer object
end;

function TMyPersistStorage.AddRef: Longint;
begin
  debug2(self,'AddRef - delegating to outer');
  Inc(FRefCount);  result:=fOleOuter.AddRef; // delegates call to outer object
end;

function TMyPersistStorage.Release: Longint;
begin
  debug2(self,'Release- delegating to outer');
  Dec(FRefCount); Result := fOleOuter.release; // delegates call to outer object
end;

function TMyPersistStorage.GetClassID(var classID: TCLSID): HResult; // IPersist method
begin
   classId:=foleOuter.theObject.GetCLSID; debug2(self,'GetClassID ret='+iid2String(classId));
   result:=S_OK;
end;

function TMyPersistStorage.IsDirty: HResult;
begin
  result:=S_FALSE; // Object has not changed since last Save
end;

function TMyPersistStorage.InitNew(stg: IStorage): HResult;
var usrType:POleStr;
begin
  debug2(self,format('InitNew %p',[pointer(stg)]));
  if fStorage<>nil then begin  //** This should not happen
    debug2(self,'InitNew: ERROR - storage already set'); result:=E_UNEXPECTED; exit;
  end;
  //** The rules of IPersistStorage mean we hold onto the IStorage
  //** and pre-create anything we'd need in save(...,TRUE) for
  //** low-memory situations. For us this means creating our
  //** "CONTENTS" stream and holding onto that IStream as
  //** well as the IStorage here (requiring an AddRef call).
  result:=stg.CreateStream('CONTENTS',STGM_DIRECT or STGM_CREATE or STGM_READWRITE or
                           STGM_SHARE_EXCLUSIVE,0,0,fStream);
  if failed(result) then begin debug2(self,'InitNew: ERROR - CreateStream failed'); exit; end;

  //**initializate class information
  WriteClassStg(stg,foleOuter.theObject.GetCLSID);
  fOleOuter.GetUserType(USERCLASSTYPE_FULL,usrType);
  WriteFmtUserTypeStg(stg,CfDelphiObjectData,usrType); // was wrong in 0.9
  stg.AddRef; fStorage:=stg;
  result:=S_OK;
end;

function TMyPersistStorage.Load(stg: IStorage): HResult;
var openedStream:IStream;  var dummy:LargeInt;
begin
  debug2(self,'Load');
  if fStorage<>nil then begin  //** This should not happen
     debug2(self,'Load: ERROR - storage already set'); result:=E_UNEXPECTED; exit;
  end;

  if stg=nil then begin
   debug2(self,'Load: ERROR - invalid [in] pointer'); result:=STG_E_INVALIDPOINTER; exit;
  end;

  result:=stg.OpenStream('CONTENTS',nil,STGM_DIRECT or STGM_READWRITE or
                           STGM_SHARE_EXCLUSIVE,0,openedStream);
  if failed(result) then begin debug2(self,'Load: OpenStream failed'); result:=E_FAIL; exit; end;

  // ReadDataFromStream
  openedStream.Seek(STREAM_SEEK_SET,0,dummy); // to the begining of the stream

  ds.AssignTo(openedStream); // use delphi stream
  fOleOuter.theObject.Load(ds);
  ds.AssignTo(nil); // release delphi stream

  //** We do not call openedStream.Release because we may need it for a low-memory
  //** save in Save. We also need to hold onto a copy of Istorage, menanig AddRef

  fStream:=OpenedStream;
  Stg.AddRef; fStorage:=stg;
  result:=S_OK;
end;


function TMyPersistStorage.Save(stgSave: IStorage; fSameAsLoad: BOOL): HResult;
var str:IStream; dummy:largeInt; usrType:POleStr;
begin
  debug2(self,'Save');
  if stgSave=nil then begin  //** This should not happen
     debug2(self,'Save: invalid [in] pointer'); result:=STG_E_INVALIDPOINTER; exit;
  end;

  //** if we are saving to a new storage, create a new stream. If fSameAsLoad is TRUE,
  //** then we write to the stream we already allocated. We should NOT depends on
  //** stgSave with fSameAsLoad is TRUE.
  if (fSameAsLoad) then begin
    //** Use pre-allocated streams to avoid failures doue to low-memory conditions.
    //** Be sure to reset the stream poiner if you used this theam before!!
    str:=fStream;
    str.Seek(STREAM_SEEK_SET,0,dummy); // to the begining of the stream
    str.AddRef;                        //** This matches the Release below.

  end else begin  // fSameIsLoad==false - we have to create new stream
    result:=stgSave.CreateStream('CONTENTS',STGM_DIRECT or STGM_CREATE or STGM_READWRITE or
                             STGM_SHARE_EXCLUSIVE,0,0,str);
    if failed(result) then begin debug2(self,'Save: CreateStream failed'); exit; end;

    // Strange: no WriteClassStg Answer: OleSaveToStream calls writeClassStg (-->Win32Sdk IPersist:Save)
    // BTW: IPerStor.cpp (Chapter5) *does* call WriteClassStg, IPerStor.cpp (Chapter 10) does *not*

    fOleOuter.GetUserType(USERCLASSTYPE_FULL,usrType);
    WriteFmtUserTypeStg(stgSave,CfDelphiObjectData,usrType); // was wrong in 0.9
  end;

  // write Data to stream
  ds.AssignTo(str); // use delphi stream
  fOleOuter.theObject.Save(ds);
  ds.AssignTo(nil); // release delphi stream

  str.Release;
  debug2(self,'Save successfully returning');
  result:=S_OK; // Ok,ok we should check if write was successfull
end;

function TMyPersistStorage.SaveCompleted(stgNew: IStorage): HResult;
var str:IStream;
begin
  //** if stgNew is NULL, then we don't need to do anything, since we already have
  //** all the pointers we need for Save. Otherwise, we have to relese any held
  //** pointers and reinitializate then from PIStorage
  debug2(self,format('SaveCompleted %p',[pointer(stgNew)]));
  if stgNew<>nil then begin
    result:=stgNew.OpenStream('CONTENTS',nil,STGM_DIRECT or STGM_READWRITE or
                              STGM_SHARE_EXCLUSIVE,0,str);
    if failed(result) then begin debug2(self,'SaveCompleted: OpenStream failed'); result:=E_FAIL; exit; end;

    if fStream<>nil then fStream.release; // release old stream
    fStream:=str;

    if fStorage<>nil then fStorage.release; // release old storage
    stgNew.AddRef; fStorage:=stgnew;
 end;
 result:=S_OK;
end;

function TMyPersistStorage.HandsOffStorage: HResult;
begin
  debug2(self,'Hands of storage');
  //**Release held pointers
  if fStream<>nil  then begin fStream.release; fStream:=nil; end;
  if fStorage<>nil then begin fStorage.Release; fStorage:=nil; end;
  result:=S_OK;
end;

/////////////////// TDropTarget is never used.
function TDropTarget.DragEnter(dataObj: IDataObject; grfKeyState: Longint;const pt: TPoint; var dwEffect: Longint): HResult;
begin
  abort; // noce klicati drag over???? poklice dragEnter, ostalo pa ne....
  dweffect:=1; // copy
  result:=s_ok;
end;


function TDropTarget.DragOver(grfKeyState: Longint; const pt: TPoint; var dwEffect: Longint): HResult;
begin
  dweffect:=1; // copy
  result:=s_ok;
end;

function TDropTarget.DragLeave:hresult;
begin
  result:=s_ok;
end;

function TDropTarget.Drop(dataObj: IDataObject; grfKeyState: Longint; const pt: TPoint;var dwEffect: Longint): HResult;
begin
  showMessage('PASTE!');
  result:=s_ok;
end;

constructor TDropTarget.Create;
begin
   FRefCount := 1;
end;
function TDropTarget.QueryInterface(const iid: TIID; var obj): HResult;
var  p:IUnknown;
begin
  p:=nil;
  debug2(self,'dropTarget.QueryInterface + '+iid2String(iid));
    if IsEqualIID(iid, IID_IUnknown) or IsEqualIID(iid, IID_IDROPTARGET) then p:=self;

 Pointer(obj) := P;
  if P = nil then begin debug2(self,'not suported!'); Result := E_NOINTERFACE end  else
  begin
    P.AddRef;
    Result := S_OK;
  end;
end;

function TDropTarget.AddRef: Longint;
begin
  Inc(FRefCount);
  Result := FRefCount;
end;

function TDropTarget.Release: Longint;
begin
  Dec(FRefCount);
  Result := FRefCount;
  if FRefCount = 0 then Free;
end;

////////////////////////////////////////////////////////////////////////////////
// TDelphiOle
////////////////////////////////////////////////////////////////////////////////
constructor TDelphiOle.Create;
begin
  inherited Create;
end;

procedure TDelphiOle.ViewChanged(dwaspect:DWORD);
begin
  if fOwner<>nil then fOwner.ViewChanged(dwAspect);
end;

procedure TDelphiOle.release;
begin  fowner.Release;  end;

procedure TDelphiOle.Changed;
begin
  viewChanged(DVASPECT_CONTENT);
  // ok, this is not always true, but in most cases changes in object data are also reflected in object view
  // we should also call data advisory SendOnDataChange...
end;

procedure TDelphiOle.SetOwner(newOwner:TMyOle);
begin
  if fowner<>nil then raise exception.Create(errCantChangeOwner);
  fOwner:=newOwner;
end;

var
  DC: HDC;
initialization
  _lastCreatedMyOle:=nil;
  _TMyOleCount:=0;

  DC := GetDC(0);
  PixPerInch.X := GetDeviceCaps(DC, LOGPIXELSX);
  PixPerInch.Y := GetDeviceCaps(DC, LOGPIXELSY);
  ReleaseDC(0, DC);

end.
