unit Setup1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, TSetup;

type
  TMainForm = class(TForm)
    Label1: TLabel;
    Memo1: TMemo;
    StartBtn: TBitBtn;
    CancelBtn: TBitBtn;
    MainOptions: TSetupRadioChoice;
    Files: TSetupFileCopy;
    Directory: TSetupDirChoice;
    ProgramGroups: TSetupGroups;
    CustomOptions: TSetupCheckBoxChoice;
    procedure CancelBtnClick(Sender: TObject);
    procedure StartBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.CancelBtnClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TMainForm.StartBtnClick(Sender: TObject);
var
  Res: TModalResult;
begin
  {This code relies on the fact that Boolean Evalution is short-circuited}
  Res:= mrCancel;
  Res:= MainOptions.Execute;
  if (Res <> mrCancel) and (MainOptions.Selected = 2) then
    Res:= CustomOptions.Execute;
  if (Res <> mrCancel) then Res:= Directory.Execute;
  if (Res <> mrCancel) then Res:= Files.Execute;
  if (Res <> mrCancel) then Res:= ProgramGroups.Execute;
  if Res = mrCancel then
    ShowMessage('Setup did not successfully complete.')
  else ShowMessage('Setup completed.');
end;

end.
